20 May 2026: Wouter
	- Fix CVE-2026-33278, Possible remote code execution during DNSSEC
	  validation. Thanks to Qifan Zhang, Palo Alto Networks, for the report.
	- Fix CVE-2026-42944, Heap overflow and crash with multiple nsid,
	  cookie, padding EDNS options. Thanks to Qifan Zhang, Palo Alto
	  Networks, for the report.
	- Fix CVE-2026-42959, Crash during DNSSEC validation of malicious
	  content. Thanks to Qifan Zhang, Palo Alto Networks, for the report.
	- Fix CVE-2026-32792, Packet of death with DNSCrypt. Thanks to Andrew
	  Griffiths from 'calif.io' for the report.
	- Fix CVE-2026-40622, "Ghost domain name" variant. Thanks to Qifan
	  Zhang, Palo Alto Networks, for the report.
	- Fix CVE-2026-41292, Parsing a long list of incoming EDNS options
	  degrades performance. Thanks to GitHub user 'N0zoM1z0', also Qifan
	  Zhang from Palo Alto Networks, for the report.
	- Fix CVE-2026-42534, Jostle logic bypass degrades resolution
	  performance. Thanks to Qifan Zhang, Palo Alto Networks, for the
	  report.
	- Fix CVE-2026-42923, Degradation of service with unbounded NSEC3
	  hash calculations. Thanks to Qifan Zhang, Palo Alto Networks, for
	  the report.
	- Fix CVE-2026-42960, Possible cache poisoning attack while following
	  delegation. Thanks to TaoFei Guo from Peking University, Yang Luo
	  and JianJun Chen, Tsinghua University, for the report.
	- Fix CVE-2026-44390, Unbounded name compression in certain cases
	  causes degradation of service. Thanks to Qifan Zhang, Palo Alto
	  Networks, for the report.
	- Fix CVE-2026-44608, Use after free and crash in RPZ code. Thanks
	  to Qifan Zhang, Palo Alto Networks, for the report.

23 April 2026: Wouter
	- Merge #1441: Fix buffer overrun in
	  doq_repinfo_retrieve_localaddr().
	- For #1441: Fix type of ipv6 addr struct.

21 April 2026: Wouter
	- Add test case for malformed SVCB records. Thanks to
	  Qifan Zhang, Palo Alto Networks for the additional test.
	- Fix for the Jiggle Attack. The server is fixed to answer
	  with errors for error cases, and does not stay silent.
	  In addition, the error replies do not contain parts of the
	  incoming query. This is more conformant, stops reflection
	  and stops it as a covert channel. Thanks to Yuqi Qiu and
	  Xiang Li, Nankai University (AOSP Lab) for the report.
	  In addition, thanks to Qifan Zhang, Palo Alto Networks, for
	  noting the fingerprinting possibility, that is also fixed
	  with this.
	- Fix EDNS extended RCODE reflection. This fixes that
	  the server does not echo extended rcode values after class
	  chaos queries. Thanks to Qifan Zhang, Palo Alto Networks
	  for the report.
	- Fix for iterator RCODE handling of YXDOMAIN. This fixes
	  that the server only accepts YXDOMAIN answers that contain
	  a DNAME record. This stops bad answers, and checks that
	  the authoritative server gives correct replies.
	  Thanks to Qifan Zhang, Palo Alto Networks for the report.
	- Fix for missing bounds check for decompressing dnames
	  for downloaded authority zones. This fixes that the server
	  could end up with malformed zone content after receiving
	  truncated packet contents from an AXFR. In addition, the
	  domain names in the SOA rdata are checked before the
	  authority code picks up the zone serial.
	  Thanks to Halil Oktay for the report.
	- Fix that upstream TLS connections are not reused as TLS
	  connections for a different name, at the same IP. This
	  checks that the tls name is correct when reusing the
	  upstream connections. Thanks to TaoFei Guo from Peking
	  University and JianJun Chen from Tsinghua University for
	  the report.
	- Fix that signatures are not allowed with revoked dnskeys.
	  Thanks to Qifan Zhang, Palo Alto Networks for the report.
	- Fix that a DNAME with an unsigned CNAME is checked for
	  the correct match. This stops that for certain zone
	  configurations an unchecked unsigned CNAME could get
	  secure status. Thanks to Qifan Zhang, Palo Alto Networks
	  for the report.
	- Fix handling of wildcard CNAMEs in the chain of trust.
	  An improper wildcard in the chain of trust would send
	  the retries to the wrong upstream. Also it could label
	  the step in the chain of trust as secure, when it was not.
	  Thanks to Qifan Zhang, Palo Alto Networks for the report.
	- Set version number to 1.25.0 of code repository.
	- Fix doxygen comment syntax.

20 April 2026: Wouter
	- Fix compile warnings for thread setname routine, and test compile.
	- Fix unused variable warning when compiled without ssl.
	- Fix test with https zone for libressl.

17 April 2026: Wouter
	- Fix setup of ssl context copy of the tls service pem option,
	  from a clang analyzer warning.
	- Fix setup of ssl context copy, to check for the tls service
	  pem option for stat calls.
	- Fix to compile the shm code when there is no shmget.
	- Update github ci to use actions/checkout@v6.
	- Update github ci cross platform to use
	  cross-platform-actions/action@v1.0.0.
	- Fix github ci to speed up with parralel build, for windows ci.
	- Fix compat/chacha_private sigma and tau definitions to use
	  nonstring attribute.
	- Fix compat/gmtime_r old style definition syntax.
	- Fix to increase size of the buffer for the win_svc reportev log
	  function.
	- Fix ttl comparisons in rdata_copy for 32bit signed or unsigned.
	- Fix subnet store of servfail to not leak memory.
	- Update generated man pages.
	- Update generated configure, with autoconf.
	- Fix pthread_setname detection to fail on warnings.

17 April 2026: Yorgos
	- Merge #1400: Support pthread_setname_np. Adds support for
	  pthread_setname_np and variants to set the name on spawned threads
	  for easier debugging/monitoring.

16 April 2026: Yorgos
	- Merge #1406: Introduce new 'tls-protocols' configuration option.
	- Introduce new 'tls-protocols' configuration option that specifies
	  which of the supported TLS protocols will be used.
	  This change invalidates some previous changes:
	- TLSv1.2 is again enabled by default, but can be selectively turned
	  off if desired (related to #1303).
	- The biefly introduced (not yet released) 'tls-use-system-versions'
	  configuration option, that addressed #1346, is reverted in favor of
	  'tls-protocols'.
	- The briefly introduced (not yet released) '--enable-system-tls'
	  configure option, related to #1401, is no longer needed with the new
	  option and the current default.
	- Fix cleaning up DoH session. The same query can be on multiple
	  streams in a session.

16 April 2026: Wouter
	- Fix configure, autoconf for #1406.

15 April 2026: Wouter
	- Fix RFC7766 compliance when client sends EOF over TCP. It stops
	  pending replies and closes. Thanks to Yuxiao Wu, Tsinghua
	  University for the report.
	- Fix to shorten RRSIG count in scrubber, this protects against
	  an overly large number of RRSIGs. It can be configured with
	  `iter-scrub-rrsig: 8`, it has default 8. Thanks to Yuxiao Wu,
	  Tsinghua University for the report.

14 April 2026: Wouter
	- Fix #1017: memory corruption related core dumps.
	  When alloc_reg_obtain has an empty list, return a new allocation.
	- Fix clang analyzer warning for subnetmod, when return_msg is
	  NULL for update cache, like when it stores servfail status.
	- iana portlist updated.

13 April 2026: Yorgos
	- Update the documentation of 'max-query-restarts' in the man page.

10 April 2026: Wouter
	- Fix for EDNS client subnet so that it does not store SERVFAIL in
	  the global cache after a failed lookup, such as timeouts. A failure
	  entry is stored in the subnet cache, for the query name, for a
	  couple of seconds. Queries can continue to use the subnet cache
	  during that time.

7 April 2026: Yorgos
	- Fix unused variable warning.

30 March 2026: Wouter
	- Merge #1408: Fix shared memory stats with threads.

27 March 2026: Wouter
	- Fix to allow the control-interface config to use ip@port notation.
	- Fix test code to allow empty hex answer packets from testbound.
	- Fix defense in depth for service callback with empty packet.

24 March 2026: Wouter
	- Fix to check for invalid http content length and chunk size,
	  and to check the RR rdata field lengths when decompressing and
	  inserting RRs from an authority zone transfer. This stops
	  large memory use and heap buffer-overflow read errors. Thanks
	  to Haruto Kimura (Stella) for the report.

20 March 2026: Wouter
	- Fix for testcode pktview to check buffer size and log errors.

13 March 2026: Yorgos
	- Fix to ignore out-of-zone DNAME records for CNAME synthesis. Thanks
	  to Yuxiao Wu, Yiyi Wang, Zhang Chao, Baojun Liu, and Haixin Duan from
	  Tsinghua University.

13 March 2026: Wouter
	- Fix #278: DoT: complete unbound restart required on certificate
	  renew. Fix so that a reload checks if the files have changed, and
	  if so, reload the contexts. Also for DoH, DoQ and outgoing DoT.
	- iana portlist updated.
	- For #278: fast_reload can reload tls-service-key, tls-service-pem
	  and tls-cert-bundle changes. It checks the modification time of
	  the tls-service-key and tls-service-pem files for update.
	- Fix detection of http listening port in fast_reload.
	- Fix to add tls-service-key to memory printout for fast_reload.

9 March 2026: Wouter
	- Fix compile failure in unbound-checkconf for older gcc compiler.
	- Merge #1418: Apply cache TTL policy to DNAME and synthesized
	  CNAME on wire path.

6 March 2026: Wouter
	- Merge #1415: Add lock unlock for view in memory error handling.

6 March 2026: Yorgos
	- Document the suggestion for a higher value for 'outgoing-range';
	  helps when the request list is full.
	- Warn for unused 'nodefault' local-zone configuration in
	  unbound-checkconf (related to #1416).

5 March 2026: Wouter
	- Fix for DNS Rebinding Bypass via SVCB/HTTPS Records in Unbound.
	  Thanks to Kunta Chu, School of Software, Tsinghua University,
	  Taofei Guo, Peking University, and Jianjun Chen, Institute for
	  Network Sciences and Cyberspace, Tsinghua University for the
	  report. The private-address option is fixed to also elide
	  SVCB and HTTPS records that match the filter.
	- Update generated man pages.

4 March 2026: Yorgos
	- For #1411: Introduce a failing case in the rpl test so that it only
	  passes with the fix in place.

3 March 2026: Wouter
	- Merge #1411: Allow synthesized DNAME TTL=0 to be served from cache
	  within grace period. The responses are served from cache within
	  a 1-second grace period. Reduces recursion when authoritative
	  servers return DNAME with TTL=0 (RFC 2308). Response
	  still returns TTL=0 to clients. Adds a test for it.
	- For #1411: Fix that the lookup for DNAME uses flag. Fix assertion
	  in expired calc debug routine.

27 February 2026: Wouter
	- Merge #1409: Documentation CNAME in redirect-type local-zone.
	- Update generated man pages.

25 February 2026: Wouter
	- Fix validator to set unchecked when validation recursion
	  requests are passed. The edns subnet module checks if validation
	  is needed for a cache response, and set the validator to protect
	  the cache with validation for non-subnet lookups.

23 February 2026: Wouter
	- Fix to have cachedb not return expired bogus data as non-bogus.
	- Fix to make the cachedb_val_expired.crpl succeed.

23 February 2026: Yorgos
	- Fix to disallow cache lookup/store in external cachedb when a
	  forwarder/stub forbids it with the no-cache option.
	- Fixed some typos reported in #1395 by rezky_nightky.

17 February 2026: Wouter
	- Fix to remove unused conditional from cookie timestamp at
	  worker env.
	- For #1405: local-zone always_refuse also blocks queries of type DS.

16 February 2026: Yorgos
	- Fix #1404: Priming the root key fails after loading ipfire.org RPZ
	  zones. Fixed by including the ZONEMD RRtype in the list of types to
	  ignore for RPZ zones. Analysis and patch provided by ummeegge.

16 February 2026: Wouter
	- Fix that cachedb aggressive negative responses have the RA flag set.

11 February 2026: Wouter
	- Fix #1403: Inconsistency between do-nat64 and do-not-query-address
	  during retries.

9 February 2026: Wouter
	- Merge #1401: Add a new build-time option for system TLS.
	  The --enable-system-tls flag enables the
	  tls-use-system-policy-versions setting by default.
	- Update generated man pages.

6 February 2026: Yorgos
	- Fix #1389: [FR] replacement with ECC-GOST12 according to RFC9558.
	  Patch contributed by Igor V. Ruzanov, available in
	  contrib/gost12.patch.

4 February 2026: Wouter
	- Fix local privilege escalation on Windows. Thanks to Hao Huang and
	  CrisprXiang with Fudan University for the report. The OpenSSL
	  init calls are set to not load the openssl.cnf file when compiled
	  for Windows.

3 February 2026: Yorgos
	- Eagerly remove .skip mark files in between mini_tdir.sh runs in case
	  there has been a change on the environment.

27 January 2026: Wouter
	- Add test for allow-notify with a host name.

26 January 2026: Wouter
	- Fix that allow-notify entries with hostnames are copied after IPv4
	  and IPv6 lookup.
	- Fix to not skip allow-notify hostname lookups when there are only
	  urls.

23 January 2026: Yorgos
	- Merge #1396: Log Linux thread ID.
	- On Linux systems log the system-wide unique thread ID instead of
	  Unbound's internal thread counter.
	- Introduce the 'log-thread-id' configuration option to manage logging
	  the system-wide Linux thread ID for easier debugging with system
	  tools.
	- Update generated man pages.

22 January 2026: Wouter
	- Fix that fast reload copies the iter_scrub_ns, iter_scrub_cname
	  and max_global_quota options.
	- Fix http test tool petal to not print errors when there is no
	  error.

21 January 2026: Wouter
	- Merge #1388: QNX Porting support for unbound.

19 January 2026: Wouter
	- Merge #1392: Include "V" (version) option in synopsis.

15 January 2026: Wouter
	- Fix documentation for requestlist.overwritten and
	  requestlist.exceeded, it explains which query was dropped.

8 January 2026: Wouter
	- Merge #1381: Do not initialize quic_table unless it is enabled.

6 January 2026: Wouter
	- Fix edns subnet, that scope zero queries, when there is a
	  subquery without subnet, and the forward-no-cache or
	  stub-no-cache option is set, it is not stored in cache due to
	  the forward or stub option.

6 January 2026: Yorgos
	- Merge #1391 from Götz Görisch: Fix documentation to adhere to
	  RFC5952.

31 December 2025: Yorgos
	- Update the unbound-anchor man page to note write permissions of the
	  generated file if it is to be used with Unbound's
	  auto-trust-anchor-file option.
	- Use the same EDE removal logic when encoding errors as when encoding
	  replies.

30 December 2025: Yorgos
	- Mark "THROWAWAY" and "(DNSSEC) LAME" responses clearly as Unbound's
	  categorization in the log output.

24 December 2025: Yorgos
	- More specific wording in the unbound.conf man page for stub-first
	  and forward-first options.

3 December 2025: Wouter
	- Fix http2 drop handling to clear the postpone_drop state so that
	  other streams on the http2 session are not affected by a drop,
	  and can clean up properly if also dropped. Fix http2 send reply
	  so that when there is a send failure is does not recurse into
	  the mesh functions and also does not drop the connection due to
	  the condition of one stream.

2 December 2025: Wouter
	- Fix to remove http2 stream mesh state when mesh new request is
	  dropping the new request.

1 December 2025: Wouter
	- Fix to add EDNS CO flag to testbound and debug message log.
	- Fix header comment about EDE reference in validator/val_sigcrypt.h.

28 November 2025: Yorgos
	- For #1375, there is no DNSTAP environment if it wasn't configured.

26 November 2025: Yorgos
	- Tag for 1.24.2 release.
	  The repository continues with version 1.24.3.

13 November 2025: Wouter
	- Merge #1374: Mesh reply counters.
	  This adds the statistics num.queries.replyaddr_limit and
	  requestlist.current.replies.
	- Merge #1375: Copy DNSTAP changes from daemon to workers after
	  fast_reload.

12 November 2025: Wouter
	- Fix that when discard timeout drops packet, they are accounted as
	  less reply addresses in use in the mesh area.
	- iana portlist updated.

6 November 2025: Wouter
	- Fix add comment to worker_handle_request function that explain it.
	- Fix configure test for noreturn attribute so it compiles without
	  warning.
	- Fix configure test for nonstring attribute so that it does not
	  accept when the compiler prints a warning about an unknown
	  attribute.

4 November 2025: Wouter
	- Fix dns64 log output to log the default instead of a null string.

1 November 2025: Yorgos
	- Fix #1366: Infra cache does not work correctly for NAT64, by
	  moving the NAT64 synthesis from the iterator when selecting a target
	  address, to the delegation point itself when adding target
	  addresses.

27 October 2025: Yorgos
	- Merge #1331 from Jitka Plesníková: Replace deprecated $function by
	  new $action, for SWIG.
	- Fix #1165, document the possible circular dependency when using
	  host names instead of IP addresses for name servers in stub/forward
	  zones and log a warning when spotted in the configuration.

24 October 2025: Yorgos
	- unbound.conf man page updates to include a preview of the section
	  clauses and some reformatting around the use of "clause", "option"
	  and "attributes". Based on Havard Eidnes' suggestions on the
	  mailing list.
	- Fix unused attribute warning in redis.c when threads are not
	  supported.
	- For #1364, use OPENSSL_VERSION_TEXT instead of OPENSSL_VERSION_NUMBER
	  for part of the configure script. OPENSSL_VERSION_TEXT is more
	  consistent across versions.

22 October 2025: Yorgos
	- Tag for 1.24.1 release.
	  The repository continues with version 1.24.2.

15 October 2025: Wouter
	- Fix to drop UDP for discard-timeout, but not stream connections.
	- Fix to reply with SERVFAIL when the wait-limit is exceeded.
	- Add extended dns error code for invalid query type to definition
	  list.
	- Fix unbound.conf man page entry for root-hints to say it can
	  be used without strongly recommending it.
	- Remove iPhone armv7s, and iPhoneSimulator i386 from ios ci.
	  The lib system does not provide symbols for it on the new macos
	  runner.
	- Fix to exclude libssp for windows compiles.

10 October 2025: Wouter
	- Fix #1358 Enabling FIPS in OpenSSL causes unit test to fail.

3 October 2025: Yorgos
	- Note 'respip' and 'dns64' module order in the unbound.conf
	  man page.
	- Note clearly that 'wait-limit: 0' disables all wait limits.
	- 'wait-limit-cookie: 0' can now disable cookie validated wait
	  limits.

2 October 2025: Wouter
	- Fix that https is set up as enabled when the port is listed in
	  interface-automatic-ports. Also for the set up of quic it is
	  enabled when listed there.

30 September 2025: Wouter
	- Fix for #1344: Fix that respip and dns64 can be enabled at the
	  same time, the client info is copied for attach_sub and add_sub
	  calls. That makes respip work on dns64 synthesized answers, and
	  also makes RPZ work with DNS64. The order for the modules is
	  module-config: "respip dns64 validator iterator".

29 September 2025: Wouter
	- Rebuild configure script from its sources.
	- Fix modstack_call_init to use the original string when it has
	  changed, to call modstack_config with. And skip the changed name
	  in the string correctly. Thanks to Jan Komissar.
	- Neaten up the change in acx_nlnetlabs.m4 to version 49.
	- Fix fr_atomic_copy_cfg.
	- Rebuild configure script from its sources.
	- Fix #1353: auth-zone can not use empty label for $ORIGIN when
	  http download.
	- Fix #1344: module conf 'respip dns64 validator cachedb iterator'
	  is not known to work.

29 September 2025: Yorgos
	- Merge #1349: Fix #1346: [FR] Please allow back TLS 1.2.
	- Merge #1351: ac_cv_func_malloc_0_nonnull for malloc(0) check.

26 September 2025: Yorgos
	- Test for nonstring attribute in configure and add
	  nonstring attribute annotations.

24 September 2025: Yorgos
	- Avoid calling mesh_detect_cycle_found() when there is no mesh state
	  to begin with.

23 September 2025: Yorgos
	- Merge #1352 from Petr Vaganov: pythonmod: fix HANDLE_LEAK on
	  pythonmod_init.
	- For #1352, align with the current Python<3 code.
	- Merge #1350 from Maryse47: unbound.service.in: allow CAP_NET_ADMIN.
	- For #1350, same CAP_NET_ADMIN change for unbound_portable.service.in
	  as well.

19 September 2025: Wouter
	- Fix to remove configure~ from release tarballs.

19 September 2025: Yorgos
	- Update README.man with clearer text.
	- Merge #1337: 0 TTL cached replies and some TTL behavior changes.
	- TTL change: Cached records that reach TTL 0 are expired.
	- TTL change: TTL 0 upstream answers are no longer cached by
	   cachedb, as they should.
	- TTL change: 'serve-expired-reply-ttl' is now capped by the original
	  TTL value of the record to try and make some sense when replying
	  with expired records.
	- TTL change: TTL decoding was updated to adhere to RFC8767 section 4
	  where a 'set high-order bit' means the value is positive instead of
	  0.
	- unbound.conf manpage: explicitly mention RFC6891.

18 September 2025: Wouter
	- Tag for 1.24.0 release. Includes the fixes below after rc1.
	  The repository continues with version 1.24.1.

17 September 2025: Yorgos
	- Too many quotes for the EDE message debug printout.

15 September 2025: Yorgos
	- Small debug output improvement when attaching an EDE.

15 September 2025: Wouter
	- Fix to print warning for when so-sndbuf setsockopt is not granted.

11 September 2025: Wouter
	- version set to 1.24.0 for release.
	- tag for 1.24.0rc1.
	- Update contrib/aaaa-filter-iterator.patch so it applies on 1.24.0.

9 September 2025: Wouter
	- Fix #1332: CNAME chains are sometimes not followed when RPZs add a
	  local CNAME rewrite.

8 September 2025: Yorgos
	- Update documentation for using "SET ... EX" in Redis.
	- Document max buffer sizes for Redis commands.
	- Update man pages.

3 September 2025: Wouter
	- For #1328: make depend.

2 September 2025: Wouter
	- Fix #1235: Outdated Python2 code in
	  unbound/pythonmod/examples/log.py.
	- Fix #1324: Memory leak in 'msgparse.c' in
	  'parse_edns_options_from_query(...)'.
	- Fix indentation in tcp-mss option parsing.

1 September 2025: Wouter
	- Fix for #1324: Fix to free edns options scratch in ratelimit case.

29 August 2025: Yorgos
	- Limit the number of consecutive reads on an HTTP/2 session.
	  Thanks to Gal Bar Nahum for exposing the possibility of infinite
	  reads on the session.

28 August 2025: Wouter
	- Fix setup_listen_sslctx warning for nettle compile.

27 August 2025: Wouter
	- Fix unbound-control dump_cache for double unlock of lruhash table.

26 August 2025: Wouter
	- Fix ports workflow to install expat for macos.

22 August 2025: Wouter
	- For #1318: Fix compile warnings for DoH compile on windows.
	- Fix sha1 enable environment variable in test code on windows.
	- Fix #1319: [FR] zone status for Unbound auth-zones.
	- Fix that the zone acquired timestamp is set after the
	  zonefile is read.

21 August 2025: Wouter
	- Fix to check for extraneous command arguments for unbound-control,
	  when the command takes no arguments but there are arguments present.
	- Fix #1317: Unbound starts too early. Add
	  Wants=network-online.target under [Unit] in unbound.service.
	- Fix for #1317: Fix contrib/unbound.service comment path for
	  systemd network configuration.

15 August 2025: Wouter
	- unbound-control cache_lookup +t allows tld and root names. And
	  subnet cache contents are printed.
	- Fix cache_lookup subnet printout to wipe zero part of the prefix.
	- Fix cache_lookup subnet print to not print messages without rrsets
	  and perform in-depth check on node in the addrtree.

14 August 2025: Wouter
	- Fix to increase responsiveness of dump_cache.
	- Fix to decouple file descriptor activity and cache lookups in
	  dump_cache.

13 August 2025: Wouter
	- unbound-control cache_lookup <domains> prints the cached rrsets
	  and messages for those.
	- Fix to remove debug from cache_lookup.
	- Fix to unlock cache_lookup message for malformed records.

12 August 2025: Wouter
	- Fix that unbound-control dump_cache releases the cache locks
	  every so often, so that the server stays responsive.

7 August 2025: Wouter
	- Fix dname_str for printout of long names. Thanks to Jan Komissar
	  for the fix.
	- Fix that edns-subnet failure to create a subquery errors as
	  servfail, and not formerror.
	- Fix to whitespace in dname_str.

6 August 2025: Wouter
	- Fix edns subnet, so that the subquery without subnet is stored in
	  global cache if the querier used 0.0.0.0/0 and the name and address
	  do not receive subnet treatment. If the name and address are
	  configured for subnet, it is stored in the subnet cache.

5 August 2025: Wouter
	- Fix #1309: incorrectly reclaimed tcp handler can cause data
	  corruption and segfault.
	- Fix to use assertions for consistency checks in #1309 reclaimed
	  tcp handlers.

1 August 2025: Wouter
	- Fix testbound test program to accurately output packets from hex.

28 July 2025: Wouter
	- Fix redis cachedb module gettimeofday init failure.

24 July 2025: Wouter
	- Redis checks for server down and throttles reconnects.

17 July 2025: Wouter
	- Fix to not set rlimits in the unit tests.
	- Fix #1303: [FR] Disable TLSv1.2.
	- iana portlist updated.

16 July 2025: Wouter
	- Fix for RebirthDay Attack CVE-2025-5994, reported by Xiang Li
	  from AOSP Lab Nankai University.
	- Tag for 1.23.1 with the release of 1.23.0 and the CVE fix, the
	  repository continues with the previous fixes, with 1.23.2.
	- Add unit tests for non-ecs aggregation.

12 July 2025: Yorgos
	- Merge #1289 from Roland van Rijswijk-Deij: Add extra statistic to
	  track the number of signature validation operations.
	  Adds 'num.valops' to extended statistics.
	- For #1289: test num.valops in existing stat_values.tdir.
	- For #1289: add num.valops in the unbound-control man page.

11 July 2025: Wouter
	- Fix detection of SSL_CTX_set_tmp_ecdh function.
	- For #1301: configure cant find SSL_is_quic in OpenSSL 3.5.1.

8 July 2025: Wouter
	- Fix to improve dnstap discovery on Fedora.

3 July 2025: Wouter
	- Fix #1300: Is 'sock-queue-timeout' a linux only feature.
	- For #1300: implement sock-queue-timeout for FreeBSD as well.
	- Fix layout of comm_point_udp_ancil_callback.

2 July 2025: Wouter
	- Merge #1299: Fix typos.
	- Generate ltmain.sh and configure again.

25 June 2025: Yorgos
	- Fix #1247: forward-first: ssl handshake failed on root nameservers.
	- For #1247, turn off fetch-policy for delegation when looking into
	  parent side name servers that may not update the addresses and hit
	  NXNS limits.
	- For #1247, replay test (added tcp_transport to
	  outnet_serviced_query).

20 June 2025: Yorgos
	- Fix #1293: EDE 6 is attached to insecure cached answers when client
	  sends the CD bit.

19 June 2025: Wouter
	- Fix #1296: DNS over QUIC depends on a very outdated version of
	  ngtcp2. Fixed so it works with ngtcp2 1.13.0 and OpenSSL 3.5.0.
	- Merge #1297: edns-subnet: fix NULL_AFTER_DEREF on subnetmod.
	- Fix rrset cache create allocation failure case.

17 June 2025: Yorgos
	- Fix for consistent use of local zone CNAME alias for configured auth
	  zones. Now it also applies to downstream configured auth zones.

16 June 2025: Wouter
	- Fix to check control-interface addresses in unbound-checkconf.
	- Fix #1295: Windows 32-bit binaries download seems to be missing dll
	  dependency.

12 June 2025: Wouter
	- Fix header return value description for skip_pkt_rrs and
	  parse_edns_from_query_pkt.

11 June 2025: Wouter
	- Fix bitwise operators in conditional expressions with parentheses.
	- Fix conditional expressions with parentheses for bitwise and.

5 June 2025: Wouter
	- Fix unbound-anchor certificate file read for line ends and end of
	  file.
	- Fix comment for the dname_remove_label_limit_len function.
	- iana portlist updated.

3 June 2025: Yorgos
	- Small manpage corrections for the 'disable-dnssec-lame-check' option.

21 May 2025: Wouter
	- Fix #1288: [FR] Improve fuzzing of unbound by adapting the netbound
	  program.

20 May 2025: Yorgos
	- Merge #1285:  RST man pages. It introduces restructuredText man pages
	  to sync the online and source code man page documentation.
	  The templated man pages (*.in) are still part of the repo but
	  generated with docutils from their .rst counterpart.
	  Documentation on how to generate those (mainly for core developers)
	  is in README.man.
	- Add more checks about respip in unbound-checkconf.
	  Also fixes #310: unbound-checkconf not reporting RPZ configuration
	  error.

19 May 2025: Wouter
	- Fix for cname chain length with qtype ANY and qname minimisation.
	  Thanks to Jim Greenwood from Nominet for the report.

15 May 2025: Wouter
	- Fix config of slab values when there is no config file.

13 May 2025: Yorgos
	- Fix #1284: NULL pointer deref in az_find_nsec_cover() (latent bug)
	  by adding a log_assert() to safeguard future development.
	- Fix #1282: log-destaddr fail on long ipv6 addresses.

13 May 2025: Wouter
	- Change default for so-sndbuf to 1m, to mitigate a cross-layer
	  issue where the UDP socket send buffers are exhausted waiting
	  for ARP/NDP resolution. Thanks to Reflyable for the report.
	- Adjusted so-sndbuf default to 4m.

12 May 2025: Yorgos
	- Merge #1280: Fix auth nsec3 code. Fixes NSEC3 code to not break on
	  broken auth zones that include unsigned out of zone (above apex)
	  data. Could lead to hang while trying to prove a wildcard answer.

12 May 2025: Wouter
	- Fix #1283: Unsafe usage of atoi() while parsing the configuration
	  file.

9 May 2025: Wouter
	- Fix #1281: forward-zone "name: ." conflicts with auth-zone "name: ."
	  in 1.23.0, but worked in 1.22.0.

5 May 2025: Yorgos
	- Sync unbound and unbound-checkconf log output for unknown modules.

29 April 2025: Wouter
	- Fix for parallel build of dnstap protoc-c output.
	- Fix dnstap to use protoc.

29 April 2025: Yorgos
	- Merge #1276: Auto-configure '-slabs' values.

28 April 2025: Yorgos
	- Merge #1275: Use macros for the fr_check_changed* functions.

25 April 2025: Wouter
	- Fix #1272: assertion failure testcode/unitverify.c:202.

16 April 2025: Wouter
	- Increase default to `num-queries-per-thread: 2048`, when unbound is
	  compiled with libevent. It makes saturation of the task queue more
	  resource intensive and less practical. Thanks to Shiming Liu,
	  Network and Information Security Lab, Tsinghua University for the
	  report.

11 April 2025: Wouter
	- Tag for 1.23.0rc2. This became the release of 1.23.0 on 24 April
	  2025. The code repository continues with 1.23.1 in development.

11 April 2025: Yorgos
	- Merge #1265: Fix WSAPoll.

10 April 2025: Wouter
	- Fix for print of connection type in log-replies for dot and doh.

9 April 2025: Wouter
	- Fix to detect if atomic_store links in configure.
	- Fix #1264: unbound 1.22.0 leaks memory when doing DoH.

8 April 2025: Wouter
	- Tag for 1.23.0rc1.
	- Fix fast_reload to print chroot with config file name.

7 April 2025: Yorgos
	- Merge #902: DNS Error Reporting (RFC 9567). Introduces new
	  configuration option 'dns-error-reporting' and new statistics for
	  'num.dns_error_reports'.

4 April 2025: Wouter
	- Fix mesh_copy_client_info to omit null contents from copy.
	- Fix comment name in the rpz nsdname test.
	- Fix nettle compile for warnings and ticket keys.
	- Fix redis_replica test for unused option defaults and log printout.
	- Fix test to speed up common.sh script kill_pid.
	- Fix to update common.sh for speed of kill_pid.

4 April 2025: Yorgos
	- Merge #1019: Redis read-only replica support.
	  Introduces new 'redis-replica-*' options for the Redis cache backend.

3 April 2025: Wouter
	- Fix #1263: Exempt loopback addresses from wait-limit.
	- Fix wait-limit-netblock and wait-limit-cookie-netblock config parse
	  to allow two arguments.
	- Fix ub_event and include dnstap and win_svc headers.
	- Fix test for stat_values for wait limit defaults for localhost.
	- Fix parameter unused warning in net_help.c.

2 April 2025: Yorgos
	- Merge #1262 from markyang92, fix build with
	  'gcc-15 -Wbuiltin-declaration-mismatch' error in compat/malloc.c.
	- For #1262, ifdef is no longer needed.

2 April 2025: Wouter
	- Fix unbound-control test so it counts the new flush_negative output,
	  also answers the _ta probe from testns and prints command output
	  and skip a thread specific test when no threads are available.
	- Fix that ub_event has the facility to deal with callbacks for
	  fast reload, doq, windows-stop and dnstap.
	- Fix fast reload test to check if pid exists before acting on it.

1 April 2025: Wouter
	- Fix escape more characters when printing an RR type with an unquoted
	  string.
	- Enable the auth_tls.tdir and auth_tls_failcert.tdir tests.

31 March 2025: Wouter
	- iana portlist update.
	- Merge #1042: Fast Reload. The unbound-control fast_reload is added.
	  It reads changed config in a thread, then only briefly pauses the
	  service threads, that keep running. DNS service is only interrupted
	  briefly, less than a second.
	- Skip the unit tests for auth_tls.tdir and auth_tls_failcert.tdir.

27 March 2025: Wouter
	- Fix unit test dname log printout typecast.
	- Fix for ci test, expat is installed on the osx image.

26 March 2025: Yorgos
	- Fix #1255: Multiple pinnings to vulnerable copies of libexpat.
	- For #1255, for ios use an older expat version that does not require
	  C++11 language features.
	- For #1255, for ios disable building tests that require C++11.
	- For #1255, for ios try the latest expat version again.

24 March 2025: Wouter
	- Fix #1254: `send failed: Socket is not connected` and
	  `remote address is 0.0.0.0 port 53`.

21 March 2025: Wouter
	- Fix #1253: Cache entries fail to be removed from Redis cachedb
	  backend with unbound-control flush* +c.
	- Fix for #1253: Fix for redis cachedb backend to expect an integer
	  reply for the EXPIRE command.

20 March 2025: Wouter
	- Fix print of RR type NSAP-PTR, it is an unquoted string.

18 March 2025: Wouter
	- Fix #1251: WSAPoll first argument cannot be NULL.
	- Fix for windows compile create ssl contexts.

17 March 2025: Wouter
	- Fix representation of types GPOS and RESINFO, add rdf type for
	  unquoted str.

16 March 2025: Yorgos
	- Fix 'unbound-control flush_negative' when reporting removed data;
	  reported by David 'eqvinox' Lamparter.

28 February 2025: Wouter
	- Merge #1238: Prefer SOURCE_DATE_EPOCH over actual time.
	  Add --help output description for the SOURCE_DATE_EPOCH variable.

25 February 2025: Wouter
	- Merge #1243: Do not shadow tm on line 236.

24 February 2025: Yorgos
	- Fix hash calculation for cachedb to ignore case. Previously, cached
	  records there were only relevant for same case queries (if not
	  already in Unbound's internal cache).

19 February 2025: Yorgos
	- Fix static analysis report about unhandled EOF on error conditions
	  when reading anchor key files.
	- Merge #1241: Fix infra-keep-probing for low infra-cache-max-rtt
	  values.

17 February 2025: Yorgos
	- Consider reconfigurations when calculating the still_useful_timeout
	  for servers in the infrastructure cache.

30 January 2025: Wouter
	- Fix #986: Resolving sas.com with dnssec-validation fails though
	  signed delegations seem to be (mostly) correct.

29 January 2025: Yorgos
	- Make the default value of module-config "validator iterator"
	  regardless of compilation options. --enable-subnet would implicitly
	  change the value to enable the subnetcache module by default in the
	  past.

24 January 2025: Yorgos
	- Merge #1220 from Petr Menšík, Add unbound members group access to
	  control key.

21 January 2025: Yorgos
	- Use the same interface listening port discovery code for all needed
	  protocols.
	- Port to string only when needed before getaddrinfo().
	- Do not open unencrypted channels next to encrypted ones on the same
	  port.
	- Merge #1224 from Theo Buehler: Do not use DSA API unless USE_DSA is
	  set.

21 January 2025: Wouter
	- Fix compile of interface check code when dnscrypt or quic is
	  disabled.
	- Fix encoding of RR type ATMA.
	- Fix to check length in ATMA string to wire.
	- Merge #1229: check before use daemon->shm_info.

20 January 2025: Yorgos
	- Merge #1222: Unique DoT and DoH SSL contexts to allow for different
	  ALPN.
	- Create the quic SSL listening context only when needed.

15 January 2025: Yorgos
	- Merge #1221: Consider auth zones when checking for forwarders.

14 January 2025: Yorgos
	- Add resolver.arpa and service.arpa to the default locally served
	  zones.

13 January 2025: Yorgos
	- Fix #1213: Misleading error message on default access control causing
	  refuse.

10 January 2025: Yorgos
	- Merge #1214: Use TCP_NODELAY on TLS sockets to speed up the TLS
	  handshake.

31 December 2024: Yorgos
	- Merge #1174: Serve expired cache update fixes. Fixes a regression bug
	  with serve-expired that appeared in 1.22.0 and would not allow the
	  iterator to update the cache with not-yet-validated entries resulting
	  in increased outgoing traffic.

20 December 2024: Yorgos
	- For #1207: [FR] Support for RESINFO RRType 261 (RFC9606), add
	  LDNS_RR_TYPE_RESINFO similar to LDNS_RR_TYPE_TXT.

13 December 2024: Yorgos
	- Merge #1204: ci: set persist-credentials: false for actions/checkout
	  per zizmor suggestion.

3 December 2024: Yorgos
	- Merge #1189: Fix the dname_str method to cause conversion errors
	  when the domain name length is 255.
	- Merge #1197: dname_str() fixes.
	- For #1175, the default value of serve-expired-ttl is set to 86400
	  (1 day) as suggested by RFC8767.
	- Merge #1198: Fix log-servfail with serve expired and no useful cache
	  contents.
	- Safeguard alias loop while looking in the cache for expired answers.
	- Merge #1187: Create the SSL_CTX for QUIC before chroot and privilege
	  drop.
	- Fix typo in log_servfail.tdir test.

22 November 2024: Yorgos
	- Fix #1175: serve-expired does not adhere to secure-by-default
	  principle. The default value of serve-expired-client-timeout
	  is set to 1800 as suggested by RFC8767.
	- For #1175, update serve-expired tests.

20 November 2024: Yorgos
	- Fix comparison to help static analyzer.

19 November 2024: Yorgos
	- Merge #1169 from Sergey Kacheev, fix: lock-free counters for
	  auth_zone up/down queries.

15 November 2024: Wouter
	- Fix #1183: the data being used is released in method
	  nsec3_hash_test_entry.
	- Fix for #1183: release nsec3 hashes per test file.

8 November 2024: Yorgos
	- More descriptive text for 'harden-algo-downgrade'.
	- Complete fix for max-global-quota to 200.

6 November 2024: Yorgos
	- Increase the default of max-global-quota to 200 from 128 after
	  operational feedback. Still keeping the possible amplification
	  factor (CAMP related issues) in the hundreds.

5 November 2024: Wouter
	- Fix for the serve expired DNSSEC information fix, it would not allow
	  current delegation information be updated in cache. The fix allows
	  current delegation and validation recursion information to be
	  updated, but as a consequence no longer has certain expired
	  information around for later dnssec valid expired responses.
	- Fix to log redis timeout error string on failure.

5 November 2024: Yorgos
	- Fix SETEX check during Redis (re)initialization.

4 November 2024: Wouter
	- Fix redis that during a reload it does not fail if the redis
	  server does not connect or does not respond. It still logs the
	  errors and if the server is up checks expiration features.
	- Merge #1167: Makefile.in: fix occasional parallel build failures
	  around bison rule.

1 November 2024: Yorgos
	- Merge #1159: Stats for discard-timeout and wait-limit.
	- Add test case for #1159.
	- Some clean up for stat_values.test.
	- Merge #1170 from Melroy van den Berg, Fix chroot manpage
	  description.
	- Merge #1157 from Liang Zhu, Fix heap corruption when calling
	  ub_ctx_delete in Windows.

25 October 2024: Yorgos
	- Fix #1163: Typos in unbound.conf documentation.

17 October 2024: Wouter
	- Tag for 1.22.0 release. This did not contain the 1154 fix
	  from 16 oct. The code repository continues with
	  version 1.22.1 in development.

16 October 2024: Yorgos
	- Fix for dnsoverquic and dnstap to use the correct dnstap
	  environment.

16 October 2024: Wouter
	- Fix for dnstap with dnscrypt and dnstap without dnsoverquic.
	- Fix #1154: Tag Incorrectly Applying for Other Interfaces
	  Using the Same IP. This fix is not for 1.22.0.

14 October 2024: Wouter
	- Fix to display warning if quic-port is set but dnsoverquic is not
	  enabled when compiled.
	- Fix dnsoverquic to extend the number of streams when one is closed.

11 October 2024: Wouter
	- Fix to disable detection of quic configured ports when quic is
	  not compiled in.
	- Fix harden-unverified-glue for AAAA cache_fill_missing lookups.
	- Fix contrib/aaaa-filter-iterator.patch for change in call
	  signature for cache_fill_missing.

10 October 2024: Wouter
	- Fix cookie_file test sporadic fails for time change during
	  the test.
	- Fix add reallocarray to alloc stats unit test, and disable
	  override of strdup in unbound-host, and the result of config
	  get option is freed properly.
	- Tag for 1.22.0rc1.

9 October 2024: Wouter
	- Merge #871: DNS over QUIC. This adds `quic-port: 853` and
	  `quic-size: 8m` that enable dnsoverquic, and the counters
	  `num.query.quic` and `mem.quic` in the statistics output.
	  The feature needs to be enabled by compiling with libngtcp2,
	  with `--with-libngtcp2=path` and libngtcp2 needs openssl+quic,
	  pass that with `--with-ssl=path` to compile unbound as well.
	- Fix to limit NSEC TTL for messages from cachedb. Fix to limit the
	  prefetch ttl for messages after a CNAME with short TTL.
	- Fix for dnstap compile of doqclient with doq disabled.

8 October 2024: Wouter
	- Fix #1149: unbound-control-setup hangs sometimes depending on
	  the openssl version.
	- Fix #1128: Cannot override tcp-upstream and tls-upstream with
	  forward-tcp-upstream and forward-tls-upstream.

3 October 2024: Yorgos
	- Fix CVE-2024-8508, unbounded name compression could lead to denial
	  of service.
	- This fix was part of 1.21.1, a security point release on 1.21.0.
	  The code repository continues with this fix and the version number
	  1.22.0.

30 September 2024: Wouter
	- Fix negative cache NSEC3 parameter compares for zero length NSEC3
	  salt.
	- Fix unbound dnstap socket test program analyzer warnings about
	  unused variable assignments and variable initialization.

25 September 2024: Wouter
	- Fix #1144: [FR] log timestamps in ISO8601 format with timezone.
	  This adds the option `log-time-iso: yes` that logs in ISO8601
	  format.

24 September 2024: Yorgos
	- Attempt to further fix doh_downstream_buffer_size.tdir flakiness.
	- More clear text for prefetch and minimal-responses in the
	  unbound.conf man page.
	- Merge #1143: Fix cache update when serve expired is used. Expired
	  records are favored over resolution and validation failures when
	  serve-expired is used.

23 September 2024: Wouter
	- Fix dns64 with prefetch that the prefetch is stored in cache.

23 September 2024: Yorgos
	- Fix doxygen warnings by commenting out CLANG_ASSISTED_PARSING,
	  CLANG_ADD_INC_PATHS, CLANG_OPTIONS and CLANG_DATABASE_PATH; they were
	  already disabled.

17 September 2024: Wouter
	- Add redis-command-timeout: 20 and redis-connect-timeout: 200,
	  that can set the timeout separately for commands and the
	  connection set up to the redis server. If they are not
	  specified, the redis-timeout value is used.

16 September 2024: Wouter
	- Merge #1140: Fix spelling mistake in comments.

11 September 2024: Yorgos
	- Fix and add comments in testdata/val_negcache_ttl.rpl.

10 September 2024: Wouter
	- Fix to limit NSEC and NSEC3 TTL when aggressive nsec is
	  enabled (RFC9077).
	- Add unit test for ttl limit for aggressive nsec.

6 September 2024: Yorgos
	- Fix alloc-size and calloc-transposed-args compiler warnings.
	- Fix comment to not trigger doxygen unknown command.

5 September 2024: Wouter
	- Fix config file read for dnstap-sample-rate.

2 September 2024: Wouter
	- Merge #1135: Add new IANA trust anchor.

30 August 2024: Wouter
	- Merge #1132: b.root renumbering.
	- Fix for #1132, adjusted unit test for change in the test file.
	- Fix for #1132, comment about adjusted copy of reference check.

29 August 2024: Wouter
	- Unit test for auth zone transfer TLS, and TLS failure.
	- Fix to print port number in logs for auth zone transfer activities.

28 August 2024: Wouter
	- Fix that when rpz is applied the message does not get picked up by
	  the validator. That stops validation failures for the message.
	- Fix that stub-zone and forward-zone clauses do not exhaust memory
	  for long content.

27 August 2024: Wouter
	- Fix #1130: Loads of logs: "validation failure: key for validation
	  <domain>. is marked as invalid because of a previous" for
	  non-DNSSEC signed zone.

23 August 2024: Wouter
	- Merge patch to fix for glue that is outside of zone, with
	  `harden-unverified-glue`, from Karthik Umashankar (Microsoft).
	  Enabling this option protects the Unbound resolver against bad
	  glue, that is unverified out of zone glue, by resolving them.
	  It uses the records as last resort if there is no other working
	  glue.
	- Fix #1127: error: "memory exhausted" when defining more than 9994
	  local-zones.
	- Fix documentation for cache_fill_missing function.

21 August 2024: Wouter
	- Add cross platform freebsd, openbsd and netbsd to github ci.
	- Fix for char signedness warnings on NetBSD.

20 August 2024: Wouter
	- Add iter-scrub-ns, iter-scrub-cname and max-global-quota
	  configuration options.

19 August 2024: Wouter
	- Fix #1126: unbound-control-setup hangs while testing for openssl
	  presence starting from version 1.21.0.

9 August 2024: Wouter
	- Fix spelling for the cache-min-negative-ttl entry in the
	  example.conf.
	- Tag for release 1.21.0, the repository continues with 1.21.1
	  in development.

8 August 2024: Wouter
	- Fix CAMP issues with global quota. Thanks to Huayi Duan, Marco
	  Bearzi, Jodok Vieli, and Cagin Tanir from NetSec group, ETH Zurich.
	- Fix CacheFlush issues with limit on NS RRs. Thanks to Yehuda Afek,
	  Anat Bremler-Barr, Shoham Danino and Yuval Shavitt (Tel-Aviv
	  University and Reichman University).
	- Set version number to 1.21.0 for release. This has tag 1.21.0rc1.
	- Fix that for windows the module startup is called and sets up
	  the module-config.

2 August 2024: Wouter
	- Fix that alloc stats has strdup checks, it stops debuggers from
	  complaining about mismatch at free time.
	- Fix testbound for alloc stats strdup in util/alloc.c.
	- Merge #1090: Cookie secret file. Adds
	  `cookie-secret-file: "unbound_cookiesecrets.txt"` option to store
	  cookie secrets for EDNS COOKIE secret rollover. The remote control
	  add_cookie_secret, activate_cookie_secret and drop_cookie_secret
	  commands can be used for rollover, the command print_cookie_secrets
	  shows the values in use.
	- Fix that alloc stats for forwards and hints are printed, and when
	  alloc stats is enabled, the unit test for unbound control waits for
	  reloads to complete.

1 August 2024: Wouter
	- Fix dnstap test program, cleans up to have clean memory on exit,
	  for tap_data_free, does not delete NULL items. Also it does not try
	  to free the tail, specifically in the free of the list since that
	  picked up the next item in the list for its loop causing invalid
	  free. Added internal unit test to unbound-dnstap-socket for that.
	- Fix that the worker mem report with alloc stats does not attempt
	  to print memory use of forwards and hints if they have been
	  deleted already.

31 July 2024: Wouter
	- Fix for #1114: Fix that cache fill for forward-host names is
	  performed, so that with nonzero target-fetch-policy it fetches
	  forwarder addresses and uses them from cache. Also updated that
	  delegation point cache fill routines use CDflag for AAAA message
	  lookups, so that its negative lookup stops a recursion since the
	  cache uses the bit for disambiguation for dns64 but the recursion
	  uses CDflag for the AAAA target lookups, so the check correctly
	  stops a useless recursion by its cache lookup.

30 July 2024: Wouter
	- Fix to document parameters of auth_zone_verify_zonemd_with_key.

25 July 2024: Wouter
	- Add root key 38696 from 2024 for DNSSEC validation. It is added
	  to the default root keys in unbound-anchor. The content can be
	  inspected with `unbound-anchor -l`.

23 July 2024: Yorgos
	- Fix #1106: ratelimit-below-domain logs the wrong FROM address.
	- Cleanup ede.tdir test.
	- For #935 and #1104, clarify RPZ order and semantics.

23 July 2024: Wouter
	- Merge #1110: Make fallthrough explicit for libworker.c.
	- For #1110: Test for fallthrough attribute in configure and add
	  fallthrough attribute annotations.
	- Fix compile when the compiler does not support the noreturn
	  attribute.
	- Fix to have empty definition when not supported for weak attribute.
	- Fix uninitialized variable warning in create_tcp_accept_sock.
	- Fix link of dnstap without openssl.
	- Fix link of unbound-dnstap-socket without openssl.

19 July 2024: Wouter
	- Add dnstap-sample-rate that logs only 1/N messages, for high volume
	  server environments. Thanks Dan Luther.
	- Fix dnstap wakeup, a running wakeup timer is left to expire and not
	  increased, a timer is started when the dtio thread is sleeping,
	  the timer set disabled when the dtio thread goes to sleep, and
	  after sleep the thread checks to see if there are messages to log
	  immediately.

16 July 2024: Wouter
	- For #1103: Fix to drop mesh state reference for the http2 stream
	  associated with the reply, not the currently active stream. And
	  it does not remove it twice on a mesh_send_reply call. The reply
	  h2_stream is NULL when not in use, for more initialisation.

15 July 2024: Wouter
	- For #1103: fix to also drop mesh state reference when the discard
	  limit is reached, when there is an error making a new recursion
	  state and when the connection is dropped with is_drop.

12 July 2024: Yorgos
	- Add RPZ tag tests in acl_interface.tdir.
	- For #1102: clearer text for using interface-* options for the
	  loopback interface.

12 July 2024: Wouter
	- Fix #1103: unbound 1.20.0 segmentation fault with nghttp2.
	- For #1103: fix to also drop mesh state reference when a h2 reply is
	  dropped.

10 July 2024: Wouter
	- For #773: In contrib/unbound.service.in set unbound to start after
	  network-online.target. Also for contrib/unbound_portable.service.in.

9 July 2024: Yorgos
	- Update list of known EDE codes.

8 July 2024: Wouter
	- Fix that validation reason failure that uses string print uses
	  separate buffer that is passed, from the scratch validation buffer.
	- Fixup algo_needs_reason string buffer length.
	- Fix shadowed error string variable in validator dnskey handling.

5 July 2024: Yorgos
	- Don't check for message TTL changes if the RRsets remain the same.

5 July 2024: Wouter
	- Fix for neater printout for error for missing DS response.
	- Fix neater printout.
	- Fix #1099: Unbound core dump on SIGSEGV.
	- Fix for #1099: Fix to check for deleted RRset when the contents
	  is updated and fetched after it is stored, and also check for a
	  changed RRset.

4 July 2024: Wouter
	- Fix to print details about the failure to lookup a DNSKEY record
	  when validation fails due to the missing DNSKEY. Also for key prime
	  and DS lookups.

3 July 2024: Yorgos
	- Fix for repeated use of a DNAME record: first overallocate and then
	  move the exact size of the init value to avoid false positive heap
	  overflow reads from address sanitizers.

3 July 2024: Wouter
	- Fix #144: Port ipset to BSD pf tables.
	- Add unit test skip files and bison and flex output to gitignore.
	- Fix to use modstack_init in zonemd unit test.
	- Fix to remove unneeded linebreak in fptr_wlist.c.
	- Fix compile warnings in fptr_wlist.c.

2 July 2024: Wouter
	- Fix to remove unused include from the readzone test program.
	- Fix unused variable warning in do_cache_remove.
	- Fix compile warning in worker pthread id printout.

17 June 2024: Wouter
	- Fix ip-ratelimit-cookie setting, it was not applied.

26 June 2024: Yorgos
	- Explicitly set the RD bit for the mesh query flags when prefetching.
	  These queries have no waiting client but they need to be treated as
	  recursive.

21 June 2024: Yorgos
	- Fix pkg-config availability check in dnstap/dnstap.m4 and
	  systemd.m4.

19 June 2024: Yorgos
	- Fix #1092: Ubuntu 22.04 Jammy fails to compile unbound 1.20.0; by
	  adding helpful text for the Python interpreter version and allowing
	  the default pkg-config unavailability error message to be shown.

17 June 2024: Wouter
	- Fix #1091: Build fails with OpenSSL >= 3.0 built with
	  OPENSSL_NO_DEPRECATED.

7 June 2024: Wouter
	- Add unit test for validation of repeated use of a DNAME record.

6 June 2024: Wouter
	- Fix memory leak in setup of dsa sig.
	- Fix typos for 'the the' in text.
	- Fix validation for repeated use of a DNAME record.

4 June 2024: Yorgos
	- Merge #1080: AddressSanitizer detection in tdir tests and memory leak
	  fixes.
	- Fix memory leak when reload_keep_cache is used and num-threads
	  changes.
	- Fix memory leak on exit for unbound-dnstap-socket; creates false
	  negatives during testing.

3 June 2024: Wouter
	- Fix to squelch connection reset by peer errors from log. And fix
	  that the tcp read errors are labeled as initial for the first calls.

30 May 2024: Wouter
	- Fix #1079: tags from tagged rpz zones are no longer honored after
	  upgrade from 1.19.3 to 1.20.0.
	- Fix for #1079: fix RPZ taglist in iterator callback that no client
	  info is like no taglist intersection.

29 May 2024: Wouter
	- Merge #1078: Only check old pid if no username.

27 May 2024: Wouter
	- Fix to enable that SERVFAIL is cached, for a short period, for more
	  cases. In the cases where limits are exceeded.
	- Fix spelling of tcp-idle-timeout docs, from Michael Tokarev.

27 May 2024: Yorgos
	- Fix unused variable warning on compilation with no thread support.
	- unbound-control-setup: check openssl availability before doing
	  anything, patch from Michael Tokarev.
	- Update patch to remove 'command' shell builtin and update error
	  text.

24 May 2024: Wouter
	- Fix #1064: Unbound 1.20 Cachedb broken?

24 May 2024: Yorgos
	- Fix #1059: Intermittent DNS blocking failure with local-zone and
	  always_nxdomain. Addition of local_zones dynamically via
	  unbound-control was not finding the zone's parent correctly.

21 May 2024: Wouter
	- Merge #1073: fix null pointer dereference issue in function
	  ub_ctx_set_fwd.
	- Fix to print a parse error when config is read with no name for
	  a forward-zone, stub-zone or view.
	- Fix for parse end of forward-zone, stub-zone and view.
	- Fix for #1064: Fix that cachedb expired messages are considered
	  insecure, and thus can be served to clients when dnssec is enabled.

17 May 2024: Yorgos
	- Merge #1069: Fix unbound-control stdin commands for multi-process
	  Unbounds.
	- Fix unbound-control commands that read stdin in multi-process
	  operation (local_zones_remove, local_zones, local_datas_remove,
	  local_datas, view_local_datas_remove, view_local_datas). They will
	  be properly distributed to all processes. dump_cache and load_cache
	  are no longer supported in multi-process operation.
	- Remove testdata/remote-threaded.tdir. testdata/09-unbound-control.tdir
	  now checks both single and multi process/thread operation.

16 May 2024: Yorgos
	- Merge #1070: Fix rtt assignment for low values of
	  infra-cache-max-rtt.

16 May 2024: Wouter
	- Fix #1071: [FR] Clear both in-memory and cachedb module cache with
	  `unbound-control flush*` commands.

15 May 2024: Yorgos
	- Add missing common functions to tdir tests.

10 May 2024: Wouter
	- Fix when the mesh jostle is exceeded that nameserver targets are
	  marked as resolved, so that the lookup is not stuck on the
	  requestlist.

8 May 2024: Wouter
	- Fix to squelch udp connect errors in the log at low verbosity about
	  invalid argument for IPv6 link local addresses.

7 May 2024: Wouter
	- Merge #1062: Fix potential overflow bug while parsing port in
	  function cfg_mark_ports.
	- Fix for #1062: declaration before statement, avoid print of null,
	  and redundant check for array size.

1 May 2024: Wouter
	- Fix for the DNSBomb vulnerability CVE-2024-33655. Thanks to Xiang Li
	  from the Network and Information Security Lab of Tsinghua University
	  for reporting it.
	- Set version number to 1.20.0 for release. This became the release
	  on 8 may 2024, the repository continues with version 1.20.1.

29 April 2024: Yorgos
	- Cleanup unnecessary strdup calls for EDE strings.

29 April 2024: Wouter
	- Fix doxygen comment for errinf_to_str_bogus.

26 April 2024: Wouter
	- Fix cachedb with serve-expired-client-timeout disabled. The edns
	  subnet module deletes global cache and cachedb cache when it
	  stores a result, and serve-expired is enabled, so that the global
	  reply, that is older than the ecs reply, does not return after
	  the ecs reply expires.
	- Add unit tests for cachedb and subnet cache expired data.
	- Man page entry for unbound-checkconf -q.

26 April 2024: Yorgos
	- Fix #876: [FR] can unbound-checkconf be silenced when configuration
	  is valid?

25 April 2024: Wouter
	- Fix configure flto check error, by finding grep for it.
	- Merge #1041: Stub and Forward unshare. This has one structure
	  for them and fixes #1038: fatal error: Could not initialize
	  thread / error: reading root hints.
	- Fix to disable fragmentation on systems with IP_DONTFRAG,
	  with a nonzero value for the socket option argument.
	- Fix doc unit test for out of directory build.

24 April 2024: Wouter
	- Fix ci workflow for macos for moved install locations.

23 April 2024: Yorgos
	- Merge #1053: Remove child delegations from cache when grandchild
	  delegations are returned from parent.

22 April 2024: Wouter
	- Add checklock feature verbose_locking to trace locks and unlocks.
	- Fix edns subnet to sort rrset references when storing messages
	  in the cache. This fixes a race condition in the rrset locks.

15 April 2024: Wouter
	- Fix #1048: Update ax_pkg_swig.m4 and ax_pthread.m4.
	- Fix configure, autoconf for #1048.

15 April 2024: Yorgos
	- Merge #1049 from Petr Menšík: Py_NoSiteFlag is not needed since
	  Python 3.8

12 April 2024: Wouter
	- Fix cachedb for serve-expired with serve-expired-client-timeout.
	- Fixup unit test for cachedb server expired client timeout with
	  a check if response if from upstream or from cachedb.
	- Fixup cachedb to not refetch when serve-expired-client-timeout is
	  used.

10 April 2024: Wouter
	- Implement cachedb-check-when-serve-expired: yes option, default
	  is enabled. When serve expired is enabled with cachedb, it first
	  checks cachedb before serving the expired response.
	- Fixup compile without cachedb.
	- Add test for cachedb serve expired.
	- Extended test for cachedb serve expired.
	- Fix makefile dependencies for fake_event.c.
	- Fix cachedb for serve-expired with serve-expired-reply-ttl.
	- Fix to not reply serve expired unless enabled for cachedb.

9 April 2024: Yorgos
	- Merge #1043 from xiaoxiaoafeifei: Add loongarch support; updates
	  config.guess(2024-01-01) and config.sub(2024-01-01), verified
	  with upstream.

8 April 2024: Yorgos
	- Fix #595: unbound-anchor cannot deal with full disk; it will now
	  first write out to a temp file before replacing the original one,
	  like Unbound already does for auto-trust-anchor-file.

5 April 2024: Wouter
	- Fix comment syntax for view function views_find_view.

5 April 2024: Yorgos
	- Merge #1027: Introduce 'cache-min-negative-ttl' option.

3 April 2024: Wouter
	- Fix #1040: fix heap-buffer-overflow issue in function cfg_mark_ports
	  of file util/config_file.c.
	- For #1040: adjust error text and disallow negative ports in other
	  parts of cfg_mark_ports.

3 April 2024: Yorgos
	- Fix #1035: Potential Bug while parsing port from the "stub-host"
	  string; also affected forward-zones and remote-control host
	  directives.
	- Fix #369: dnstap showing extra responses; for client responses
	  right from the cache when replying with expired data or
	  prefetching.

28 March 2024: Wouter
	- Fix #1034: DoT forward-zone via unbound-control.
	- Fix for crypto related failures to have a better error string.

27 March 2024: Wouter
	- Fix name of unit test for subnet cache response.
	- Fix #1032: The size of subnet_msg_cache calculation mistake cause
	  memory usage increased beyond expectations.
	- Fix for #1032, add safeguard to make table space positive.
	- Fix comment in lruhash space function.
	- Fix to add unit test for lruhash space that exercises the routines.
	- Fix that when the server truncates the pidfile, it does not follow
	  symbolic links.
	- Fix that the server does not chown the pidfile.

25 March 2024: Yorgos
	- Merge #831 from Pierre4012: Improve Windows NSIS installer
	  script (setup.nsi).
	- For #831: Format text, use exclamation icon and explicit label
	  names.

19 March 2024: Wouter
	- Fix rpz so that rpz CNAME can apply after rpz CNAME. And fix that
	  clientip and nsip can give a CNAME.
	- Fix localdata and rpz localdata to match CNAME only if no direct
	  type match is available.

18 March 2024: Wouter
	- Fix that rpz CNAME content is limited to the max number of cnames.
	- Fix rpz, it follows iterator CNAMEs for nsip and nsdname and sets
	  the reply query_info values, that is better for debug logging.
	- Fix rpz that copies the cname override completely to the temp
	  region, so there are no references to the rpz region.
	- Add rpz unit test for nsip action override.
	- Fix rpz for qtype CNAME after nameserver trigger.

15 March 2024: Yorgos
	- Merge #1030: Persist the openssl and expat directories for repeated
	  Windows builds.

15 March 2024: Wouter
	- Fix that addrinfo is not kept around but copied and freed, so that
	  log-destaddr uses a copy of the information, much like NSD does.

13 March 2024: Wouter
	- Fix #1029: rpz trigger clientip and action rpz-passthru not working
	  as expected.
	- Fix rpz that the rpz override is taken in case of clientip triggers.
	  Fix that the clientip passthru action is logged. Fix that the
	  clientip localdata action is logged. Fix rpz override action cname
	  for the clientip trigger.
	- Fix to unify codepath for local alias for rpz cname action override.
	- Fix rpz for cname override action after nsdname and nsip triggers.

12 March 2024: Yorgos
	- Merge #1028: Clearer documentation for tcp-idle-timeout and
	  edns-tcp-keepalive-timeout.

11 March 2024: Wouter
	- Fix #1021 Inconsistent Behavior with Changing rpz-cname-override
	  and doing a unbound-control reload.

8 March 2024: Wouter
	- Fix unbound-control-setup.cmd to use 3072 bits so that certificates
	  are long enough for newer OpenSSL versions. This fix is included
	  in 1.19.3rc2.
	- Fix TTL of synthesized CNAME when a DNAME is used from cache. This
	  fix is included in 1.19.3rc2.
	- Remove unused portion from iter_dname_ttl unit test.
	- Fix validator classification of qtype DNAME for positive and
	  redirection answers, and fix validator signature routine for dealing
	  with the synthesized CNAME for a DNAME without previously
	  encountering it and also for when the qtype is DNAME.
	- Fix qname minimisation for reply with a DNAME for qtype CNAME that
	  answers it.
	- Fix doc test so it ignores but outputs unsupported doxygen options.
	- Fix unbound-control-setup.cmd to have CA v3 basicConstraints,
	  like unbound-control-setup.sh has. This fix is included in 1.19.3rc2.

8 March 2024: Yorgos
	- Update doc/unbound.doxygen with 'doxygen -u'. Fixes option
	  deprecation warnings and updates with newer defaults.

7 March 2024: Wouter
	- Version set to 1.19.3 for release. After 1.19.2 point release with
	  security fix for CVE-2024-1931, Denial of service when trimming
	  EDE text on positive replies. The code repo includes the fix and
	  is for version 1.19.3. The code repo continues for version 1.19.4,
	  but 1.19.3 includes the fixes in 1.19.3rc2 as well.

5 March 2024: Wouter
	- Fix for #1022: Fix ede prohibited in access control refused answers.

4 March 2024: Wouter
	- Fix edns subnet replies for scope zero answers to not get stored
	  in the global cache, and in cachedb, when the upstream replies
	  without an EDNS record.

28 February 2024: Wouter
	- Move github workflows to use checkoutv4.

23 February 2024: Yorgos
	- Document the suspend argument for process_ds_response().

22 February 2024: Wouter
	- Fix trim of EDE text from large udp responses from spinning cpu.

20 February 2024: Yorgos
	- Merge #1010: Mention REFUSED has the TC bit set with unmatched
	  allow_cookie acl in the manpage. It also fixes the code to match the
	  documentation about clients with a valid cookie that bypass the
	  ratelimit regardless of the allow_cookie acl.

13 February 2024: Wouter
	- Fix CVE-2023-50387, DNSSEC verification complexity can be exploited
	  to exhaust CPU resources and stall DNS resolvers.
	- Fix CVE-2023-50868, NSEC3 closest encloser proof can exhaust CPU.
	- These fixes are part of the 1.19.1 release, that is a security
	  point release on 1.19.0, the code repository continues with these
	  fixes, with version number 1.19.2.

8 February 2024: Wouter
	- Fix documentation for access-control in the unbound.conf man page.

7 February 2024: Yorgos
	- Fix #1006: Can't find protobuf-c package since #999.

30 January 2024: Wouter
	- Merge #999: Search for protobuf-c with pkg-config.

23 January 2024: Yorgos
	- Update message TTL when using cached RRSETs. It could result in
	  non-expired messages with expired RRSETs (non-usable messages by
	  Unbound).

22 January 2024: Yorgos
	- Update error printout for duplicate trust anchors to include the
	  trust anchor name (relates to #920).

22 January 2024: Wouter
	- Fix for #997: Print details for SSL certificate failure.

17 January 2024: Wouter
	- Update workflow for ports to use newer openssl on windows compile.
	- Fix warning for windres on resource files due to redefinition.

16 January 2024: Wouter
	- Fix to link with libssp for libcrypto and getaddrinfo check for
	  only header. Also update crosscompile to remove ssp for 32bit.
	- Merge #993: Update b.root-servers.net also in example config file.

15 January 2024: Wouter
	- Fix to link with -lcrypt32 for OpenSSL 3.2.0 on Windows.

9 January 2024: Wouter
	- Merge #988: Fix NLnetLabs#981: dump_cache truncates large records.

5 January 2024: Wouter
	- Merge #987: skip edns frag retry if advertised udp payload size is
	  not smaller.
	- Fix unit test for #987 change in udp1xxx retry packet send.

4 January 2024: Wouter
	- Remove unneeded newlines and improve indentation in remote control
	  code.

3 January 2024: Wouter
	- Merge #980: DoH: reject non-h2 early. To fix #979: Improve errors
	  for non-HTTP/2 DoH clients.
	- Merge #985: Add DoH and DoT to dnstap message.
	- Fix #983: Sha1 runtime insecure change was incomplete.

22 December 2023: Yorgos
	- Update example.conf with cookie options.

8 December 2023: Yorgos
	- Merge PR #973: Use the origin (DNAME) TTL for synthesized CNAMEs as
	  per RFC 6672.

8 December 2023: Wouter
	- Fix root_zonemd unit test, it checks that the root ZONEMD verifies,
	  now that the root has a valid ZONEMD.

7 December 2023: Wouter
	- Fix #974: doc: default number of outgoing ports without libevent.
	- Merge #975: Fixed some syntax errors in rpl files.

6 December 2023: Wouter
	- Fix to sync the tests script file common.sh.
	- iana portlist update.
	- Updated IPv4 and IPv6 address for b.root-servers.net in root hints.
	- Update test script file common.sh.
	- Fix tests to use new common.sh functions, wait_logfile and
	  kill_from_pidfile.

5 December 2023: Wouter
	- Merge #971: fix 'WARNING: Message has 41 extra bytes at end'.
	- Fix #969: [FR] distinguish Do53, DoT and DoH in the logs.
	- Fix dnstap that assertion failed on logging other than UDP and TCP
	  traffic. It lists it as TCP traffic.

27 November 2023: Yorgos
	- Merge #968: Replace the obsolescent fgrep with grep -F in tests.

27 November 2023: Wouter
	- Fix #964: config.h.in~ backup file in release tar balls.

24 November 2023: Yorgos
	- Use 127.0.0.1 explicitly in tests to avoid delays and errors on
	  newer systems.

9 November 2023: Wouter
	- Fix unit test parse of origin syntax.

2 November 2023: Wouter
	- Set version number to 1.19.0.
	- Tag for 1.19.0rc1 release. It became 1.19.0 release on 8 nov 2023.
	  The repository continues with 1.19.1.

1 November 2023: George
	- Mention flex and bison in README.md when building from repository
	  source.

1 November 2023: Wouter
	- Fix SSL compile failure for definition in log_crypto_err_io_code_arg.
	- Fix SSL compile failure for other missing definitions in
	  log_crypto_err_io_code_arg.
	- Fix compilation without openssl, remove unused function warning.

31 October 2023: George
	- Fix #941: dnscrypt doesn't work after upgrade to 1.18 with
	  suggestion by dukeartem to also fix the udp_ancil with dnscrypt.

30 October 2023: George
	- Merge #930 from Stuart Henderson: add void to
	  log_ident_revert_to_default declaration.

30 October 2023: Wouter
	- autoconf.

24 October 2023: George
	- Clearer configure text for missing protobuf-c development libraries.

20 October 2023: Wouter
	- Merge #951: Cachedb no store. The cachedb-no-store: yes option is
	  used to stop cachedb from writing messages to the backend storage.
	  It reads messages when data is available from the backend. The
	  default is no.

19 October 2023: Wouter
	- Fix to print detailed errors when an SSL IO routine fails via
	  SSL_get_error.

18 October 2023: George
	- Mailing list patches from Daniel Gröber for DNS64 fallback to plain
	  AAAA when no A record exists for synthesis, and minor DNS64 code
	  refactoring for better readability.
	- Fixes for the DNS64 patches.
	- Update the dns64_lookup.rpl test for the DNS64 fallback patch.
	- Merge #955 from buevsan: fix ipset wrong behavior.
	- Update testdata/ipset.tdir test for ipset fix.

17 October 2023: Wouter
	- Fix #954: Inconsistent RPZ handling for A record returned along with
	  CNAME.

16 October 2023: George
	- Expose the script filename in the Python module environment 'mod_env'
	  instead of the config_file structure which includes the linked list
	  of scripts in a multi Python module setup; fixes #79.
	- Expose the configured listening and outgoing interfaces, if any, as
	  a list of strings in the Python 'config_file' class instead of the
	  current Swig object proxy; fixes #79.
	- For multi Python module setups, clean previously parsed module
	  functions in __main__'s dictionary, if any, so that only current
	  module functions are registered.

13 October 2023: George
	- Better fix for infinite loop when reading multiple lines of input on
	  a broken remote control socket, by treating a zero byte line the
	  same as transmission end. Addresses #947 and #948.

12 October 2023: Wouter
	- Merge #944: Disable EDNS DO.
	  Disable the EDNS DO flag in upstream requests. This can be helpful
	  for devices that cannot handle DNSSEC information. But it should not
	  be enabled otherwise, because that would stop DNSSEC validation. The
	  DNSSEC validation would not work for Unbound itself, and also not
	  for downstream users. Default is no. The option
	  is disable-edns-do: no

11 October 2023: George
	- Fix #850: [FR] Ability to use specific database in Redis, with new
	  redis-logical-db configuration option.

11 October 2023: Wouter
	- Fix #949: "could not create control compt".
	- Fix that cachedb does not warn when serve-expired is disabled about
	  use of serve-expired-reply-ttl and serve-expired-client-timeout.
	- Fix for #949: Fix pythonmod/ubmodule-tst.py for Python 3.x.

10 October 2023: George
	- Fix infinite loop when reading multiple lines of input on a broken
	  remote control socket. Addresses #947 and #948.

9 October 2023: Wouter
	- Fix edns subnet so that queries with a source prefix of zero cause
	  the recursor send no edns subnet option to the upstream.
	- Fix that printout of EDNS options shows the EDNS cookie option by
	  name.

4 October 2023: Wouter
	- Fix #946: Forwarder returns servfail on upstream response noerror no
	  data.

3 October 2023: George
	- Merge #881: Generalise the proxy protocol code.

2 October 2023: George
	- Fix misplaced comment.

22 September 2023: Wouter
	- Fix #942: 1.18.0 libunbound DNS regression when built without
	  OpenSSL.

18 September 2023: Wouter
	- Fix rpz tcp-only action with rpz triggers nsdname and nsip.

15 September 2023: Wouter
	- Merge #936: Check for c99 with autoconf versions prior to 2.70.
	- Fix to remove two c99 notations.

14 September 2023: Wouter
	- Fix authority zone answers for obscured DNAMEs and delegations.

8 September 2023: Wouter
	- Fix send of udp retries when ENOBUFS is returned. It stops looping
	  and also waits for the condition to go away. Reported by Florian
	  Obser.

7 September 2023: Wouter
	- Fix to scrub resource records of type A and AAAA that have an
	  inappropriate size. They are removed from responses.
	- Fix to move msgparse_rrset_remove_rr code to util/msgparse.c.
	- Fix to add EDE text when RRs have been removed due to length.
	- Fix to set ede match in unit test for rr length removal.
	- Fix to print EDE text in readable form in output logs.

6 September 2023: Wouter
	- Merge #931: Prevent warnings from -Wmissing-prototypes.

31 August 2023: Wouter
	- Fix autoconf 2.69 warnings in configure.
	- Fix #927: unbound 1.18.0 make test error. Fix make test without SHA1.

30 August 2023: Wouter
	- Fix for WKS call to getservbyname that creates allocation on exit
	  in unit test by testing numbers first and testing from the services
	  list later.

28 August 2023: Wouter
	- Fix for version generation race condition that ignored changes.

25 August 2023: Wouter
	- Fix compile error on NetBSD in util/netevent.h.

23 August 2023: Wouter
	- Tag for 1.18.0rc1 release. This became the 1.18.0 release on
	  30 aug 2023, with the fix from 25 aug, fix compile on NetBSD
	  included. The repository continues with version 1.18.1.

22 August 2023: Wouter
	- Set version number to 1.18.0.

21 August 2023: Wouter
	- Debug Windows ci workflow.
	- Fix windows ci workflow to install bison and flex.
	- Fix for #925: unbound.service: Main process exited, code=killed,
	  status=11/SEGV. Fixes cachedb configuration handling.
	- Fix #923: processQueryResponse() THROWAWAY should be mindful of
	  fail_reply.
	- Fix unit test for unbound-control to work when threads are disabled,
	  and fix cache dump check.

18 August 2023: Wouter
	- Fix for iter_dec_attempts that could cause a hang, part of
	  capsforid and qname minimisation, depending on the settings.
	- Fix uninitialized memory passed in padding bytes of cmsg to sendmsg.
	- Fix stat_values test to work with dig that enables DNS cookies.

17 August 2023: Wouter
	- Merge PR #762: Downstream DNS Server Cookies a la RFC7873 and
	  RFC9018. Create server cookies for clients that send client cookies.
	  This needs to be explicitly turned on in the config file with:
	  `answer-cookie: yes`. A `cookie-secret:` can be configured for
	  anycast setups. Without one, a random cookie secret is generated.
	  The acl option `allow_cookie` allows queries with either a valid
	  cookie or over a stateful transport. The statistics output has
	  `queries_cookie_valid` and `queries_cookie_client` and
	  `queries_cookie_invalid` information. The `ip\-ratelimit\-cookie:`
	  value determines a rate limit for queries with cookies, if desired.
	- Fix regional_alloc_init for potential unaligned source of the copy.
	- Fix ip_ratelimit test to work with dig that enables DNS cookies.

2 August 2023: George
	- Move a cache reply callback in worker.c closer to the cache reply
	  generation.

1 August 2023: George
	- Merge #911 from natalie-reece: Exclude EDE before other EDNS options
	  when there isn't enough space.
	- For #911: Try to trim EXTRA-TEXT (and LDNS_EDE_OTHER options
	  altogether) before giving up on attaching EDE options.
	- More braces and formatting for Fix for EDNS EDE size calculation to
	  avoid future bugs.
	- Fix to use the now cached EDE, if any, for CD_bit queries.

1 August 2023: Wouter
	- Fix for EDNS EDE size calculation.

31 July 2023: George
	- Merge #790 from Tom Carpay: Add support for EDE caching in cachedb
	  and subnetcache.

31 July 2023: Wouter
	- iana portlist update.

30 July 2023: George
	- Merge #759 from Tom Carpay: Add EDE (RFC8914) caching.

28 July 2023: George
	- Fix unused variable compile warning for kernel timestamps in
	  netevent.c

21 July 2023: George
	- Merge #857 from eaglegai: fix potential memory leaks when errors
	  happen.
	- For #857: fix mixed declarations and code.
	- Merge #118 from mibere: Changed verbosity level for Redis init &
	  deinit.
	- Merge #390 from Frank Riley: Add missing callbacks to the python
	  module.
	- Cleaner failure code for callback functions in interface.i.
	- Merge #889 from borisVanhoof: Free memory in error case + remove
	  unused function.
	- For #889: use netcat-openbsd instead of netcat-traditional.
	- For #889: Account for num_detached_states before possible
	  mesh_state_delete when erroring out.

20 July 2023: George
	- Merge #909 from headshog: Numeric truncation when parsing TYPEXX and
	  CLASSXX representation.
	- For #909: Fix return values.
	- Merge #901 from Sergei Trofimovich: config: improve handling of
	  unknown modules.

20 July 2023: Wouter
	- For #909: Fix RR class comparison.

14 July 2023: George
	- More clear description of the different auth-zone behaviors on the
	  man page.

13 July 2023: George
	- Merge #880 from chipitsine: services/authzone.c: remove redundant
	  check.

11 July 2023: George
	- Merge #664 from tilan7763: Add prefetch support for subnet cache
	  entries.
	- For #664: Easier code flow for subnetcache prefetching.
	- For #664: Add testcase.
	- For #664: Rename subnet_prefetch tests to subnet_global_prefetch to
	  differentiate from the new subnet prefetch support.

3 July 2023: George
	- Merge #739: Add SVCB dohpath support.
	- Code cleanup for sldns_str2wire_svcparam_key_lookup.
	- Merge #802: add validation EDEs to queries where the CD bit is set.
	- For #802: Cleanup comments and add RCODE check for CD bit test case.
	- Skip the 00-lint test. splint is not maintained; it either does not
	  work or produces false positives. Static analysis is handled in the
	  clang test.

3 July 2023: Wouter
	- Fix #906: warning: ‘Py_SetProgramName’ is deprecated.
	- Fix dereference of NULL variable warning in mesh_do_callback.

29 June 2023: George
	- More fixes for reference counting for python module and clean up
	  failure code.
	- Merge #827 from rcmcdonald91: Eliminate unnecessary Python reloading
	  which causes memory leaks.

29 June 2023: Wouter
	- Fix python modules with multiple scripts, by incrementing reference
	  counts.

27 June 2023: George
	- Merge #892: Add cachedb hit stat. Introduces 'num.query.cachedb' as
	  a new statistical counter.
	- Remove warning about unknown cast-function-type warning pragma.

22 June 2023: Wouter
	- Merge #903: contrib: add yocto compatible init script.

15 June 2023: Philip
	- Fix for issue #887 (Timeouts to forward servers on BSD based
	  system with ASLR)
	- Probably fixes #516 (Stream reuse does not work on Windows) as well

14 June 2023: George
	- Properly handle all return values of worker_check_request during
	  early EDE code.
	- Do not check the incoming request more than once.

12 June 2023: Wouter
	- Merge #896: Fix: #895: pythonmodule: add all site-packages
	  directories to sys.path.
	- Fix #895: python + sysconfig gives ANOTHER path comparing to
	  distutils.
	- Fix for uncertain unit test for doh buffer size events.

25 May 2023: Wouter
	- Fix unbound-dnstap-socket printout when no query is present.
	- Fix unbound-dnstap-socket time fraction conversion for printout.

19 May 2023: Wouter
	- Fix RPZ removal of client-ip, nsip, nsdname triggers from IXFR.
	- Fix to remove unused variables from RPZ clientip data structure.

16 May 2023: Wouter
	- Fix #888: [FR] Use kernel timestamps for dnstap.
	- Fix to print debug log for ancillary data with correct IP address.

11 May 2023: Wouter
	- Fix warning in windows compile, in set_recvtimestamp.

4 May 2023: Wouter
	- Fix #885: Error: util/configlexer.c: No such file or directory,
	  adds error messages explaining to install flex and bison.
	- Fix to remove unused whitespace from acx_nlnetlabs.m4 and config.h.
	- Fix doxygen in addr_to_nat64 header definition.

1 May 2023: George
	- Merge #722 from David 'eqvinox' Lamparter: NAT64 support.
	- For #722: minor fixes, formatting, refactoring.

1 May 2023: Wouter
	- Fix RPZ IP responses with trigger rpz-drop on cache entries, that
	  they are dropped.

26 April 2023: Philip
	- Fix issue #860: Bad interaction with 0 TTL records and serve-expired

26 April 2023: Wouter
	- Merge #882 from vvfedorenko: Features/dropqueuedpackets, with
	  sock-queue-timeout option that drops packets that have been in the
	  socket queue for too long. Added statistics num.queries_timed_out
	  and query.queue_time_us.max that track the socket queue timeouts.
	- Fix for #882: small changes, date updated in Copyright for
	  util/timeval_func.c and util/timeval_func.h. Man page entries and
	  example entry.
	- Fix for #882: document variable to stop doxygen warning.

19 April 2023: Wouter
	- Fix for #878: Invalid IP address in unbound.conf causes Segmentation
	  Fault on OpenBSD.

14 April 2023: Wouter
	- Merge #875: change obsolete txt URL in unbound-anchor.c to point
	  to RFC 7958, and Fix #874.

13 April 2023: Wouter
	- Fix build badge, from failing travis link to github ci action link.

6 April 2023: Wouter
	- Fix for #870: Add test case for the qname minimisation and CNAME.

4 April 2023: Wouter
	- Fix #870: NXDOMAIN instead of NOERROR rcode when asked for existing
	  CNAME record.

24 March 2023: Philip
	- Fix issue #676: Unencrypted query is sent when
	  forward-tls-upstream: yes is used without tls-cert-bundle
	- Extra consistency check to make sure that when TLS is requested,
	  either we set up a TLS connection or we return an error.

21 March 2023: Philip
	- Fix issue #851: reserved identifier violation 

20 March 2023: Wouter
	- iana portlist update.

17 March 2023: George
	- Fix #812, fix #846, by using the SSL_OP_IGNORE_UNEXPECTED_EOF option
	  to ignore the unexpected eof while reading in openssl >= 3.

16 March 2023: Wouter
	- Fix ssl.h include brackets, instead of quotes.

14 March 2023: Wouter
	- Fix unbound-dnstap-socket test program to reply the finish frame
	  over a TLS connection correctly.

23 February 2023: Wouter
	- Fix for #852: Completion of error handling.

21 February 2023: Philip
       - Fix #825: Unexpected behavior with client-subnet-always-forward
         and serve-expired

10 February 2023: George
	- Clean up iterator/iterator.c::error_response_cache() and allow for
	  better interaction with serve-expired, prefetch and cached error
	  responses.

9 February 2023: George
	- Allow TTL refresh of expired error responses.
	- Add testcase for refreshing expired error responses.

9 February 2023: Wouter
	- Fix to ignore entirely empty responses, and try at another authority.
	  This turns completely empty responses, a type of noerror/nodata into
	  a servfail, but they do not conform to RFC2308, and the retry can
	  fetch improved content.
	- Fix unit tests for spurious empty messages.
	- Fix consistency of unit test without roundrobin answers for the
	  cnametooptout unit test.
	- Fix to git ignore the library symbol file that configure can create.

8 February 2023: Wouter
	- Fix #841: Unbound won't build with aaaa-filter-iterator.patch.

30 January 2023: George
	- Add duration variable for speed_local.test.

26 January 2023: Wouter
	- Fix acx_nlnetlabs.m4 for -Wstrict-prototypes.

23 January 2023: George
	- Fix #833: [FR] Ability to set the Redis password.

23 January 2023: Wouter
	- Fix #835: [FR] Ability to use Redis unix sockets.

20 January 2023: Wouter
	- Merge #819: Added new static zone type block_a to suppress all A
	  queries for specific zones.

19 January 2023: Wouter
	- Set max-udp-size default to 1232. This is the same default value as
	  the default value for edns-buffer-size. It restricts client edns
	  buffer size choices, and makes unbound behave similar to other DNS
	  resolvers. The new choice, down from 4096 means it is harder to get
	  large responses from Unbound. Thanks to Xiang Li, from NISL Lab,
	  Tsinghua University.
	- Add harden-unknown-additional option. It removes
	  unknown records from the authority section and additional section.
	  Thanks to Xiang Li, from NISL Lab, Tsinghua University.
	- Set default for harden-unknown-additional to no. So that it does
	  not hamper future protocol developments.
	- Fix test for new default.

18 January 2023: Wouter
	- Fix not following cleared RD flags potentially enables amplification
	  DDoS attacks, reported by Xiang Li and Wei Xu from NISL Lab,
	  Tsinghua University. The fix stops query loops, by refusing to send
	  RD=0 queries to a forwarder, they still get answered from cache.

13 January 2023: Wouter
	- Merge #826: Аdd a metric about the maximum number of collisions in
	  lrushah.
	- Improve documentation for #826, describe the large collisions amount.

9 January 2023: Wouter
	- Fix python module install path detection.
	- Fix python version detection in configure.

6 January 2023: Wouter
	- Fix #823: Response change to NODATA for some ANY queries since
	  1.12, tested on 1.16.1.
	- Fix wildcard in hyperlocal zone service degradation, reported
	  by Sergey Kacheev. This fix is included in 1.17.1rc2.
	  That became 1.17.1 on 12 Jan 2023, the code repo continues
	  with 1.17.2. 1.17.1 excludes fix #823, it is included forwards.

5 January 2023: Wouter
	- Tag for 1.17.1 release.

2 January 2023: Wouter
	- Fix windows compile for libunbound subprocess reap comm point closes.
	- Update github workflows to use checkout v3.

14 December 2022: George
	- Merge #569 from JINMEI Tatuya: add keep-cache option to
	  'unbound-control reload' to keep caches.

13 December 2022: George
	- Expose 'statistics-inhibit-zero' as a configuration option; the
	  default value retains Unbound's behavior.
	- Expose 'max-sent-count' as a configuration option; the
	  default value retains Unbound's behavior.
	- Merge #461 from Christian Allred: Add max-query-restarts option.
	  Exposes an internal configuration but the default value retains
	  Unbound's behavior.

13 December 2022: Wouter
	- Merge #808: Wrap Makefile script's directory variables in quotes.
	- Fix to wrap Makefile scripts directory in quotes for uninstall.

1 December 2022: Wouter
	- Fix #773: When used with systemd-networkd, unbound does not start
	  until systemd-networkd-wait-online.service times out.

30 November 2022: George
	- Add SVCB and HTTPS to the types removed by 'unbound-control flush'.
	- Clear documentation for interactivity between the subnet module and
	  the serve-expired and prefetch configuration options.

30 November 2022: Wouter
	- Fix #782: Segmentation fault in stats.c:404.

28 November 2022: Wouter
	- Fix for the ignore of tcp events for closed comm points, preserve
	  the use after free protection features.

23 November 2022: Philip
	- Merge #720 from jonathangray: fix use after free when
	  WSACreateEvent() fails.

22 November 2022: George
	- Ignore expired error responses.

11 November 2022: Wouter
	- Fix #779: [doc] Missing documentation in ub_resolve_event() for
	  callback parameter was_ratelimited.

9 November 2022: George
	- Complementary fix for distutils.sysconfig deprecation in Python 3.10
	  to commit 62c5039ab9da42713e006e840b7578e01d66e7f2.

8 November 2022: Wouter
	- Fix to ignore tcp events for closed comm points.
	- Fix to make sure to not read again after a tcp comm point is closed.
	- Fix #775: libunbound: subprocess reap causes parent process reap
	  to hang.
	- iana portlist update.

21 October 2022: George
	- Merge #767 from jonathangray: consistently use IPv4/IPv6 in
	  unbound.conf.5.

21 October 2022: Wouter
	- Fix that cachedb does not store failures in the external cache.

18 October 2022: George
	- Clarify the use of MAX_SENT_COUNT in the iterator code.

17 October 2022: Wouter
	- testcode/dohclient sets log identity to its name.

14 October 2022: Wouter
	- Merge #768 from fobser: Arithmetic on a pointer to void is a GNU
	  extension.
	- In unit test, print python script name list correctly.

13 October 2022: Wouter
	- Tag for 1.17.0 release. The code repository continues with 1.17.1.

11 October 2022: George
	- Fix PROXYv2 header read for TCP connections when no proxied addresses
	  are provided.

7 October 2022: Wouter
	- Tag for 1.17.0rc1 release.

7 October 2022: George
	- Fix to stop possible loops in the tcp reuse code (write_wait list
	  and tcp_wait list). Based on analysis and patch from Prad Seniappan
	  and Karthik Umashankar.
	- Fix unit test to properly test the reuse_write_wait_pop function.

6 October 2022: Wouter
	- Fix to stop responses with TC flag from resulting in partial
	  responses. It retries to fetch the data elsewhere, or fails the
	  query and in depth fix removes the TC flag from the cached item.
	- Fix proxy length debug output printout typecasts.

5 October 2022: Wouter
	- Fix dnscrypt compile for proxy protocol code changes.

5 October 2022: George
	- Use DEBUG_TDIR from environment in mini_tdir.sh for debugging.
	- Fix string comparison in mini_tdir.sh.
	- Make ede.tdir test more predictable by using static data.
	- Fix checkconf test for dnscrypt and proxy port.

4 October 2022: George
	- Merge #764: Leniency for target discovery when under load (for
	  NRDelegation changes).

4 October 2022: Wouter
	- Fix static analysis report to remove dead code from the
	  rpz_callback_from_iterator_module function.
	- Fix to clean up after the acl_interface unit test.

3 October 2022: George
	- Merge #760: PROXYv2 downstream support. (New proxy-protocol-port
	  configuration option).

3 October 2022: Wouter
	- Fix to remove erroneous TC flag from TCP upstream.
	- Fix test tdir skip report printout.
	- Fix windows compile, the identifier interface is defined in headers.
	- Fix to close errno block in comm_point_tcp_handle_read outside of
	  ifdef.

26 September 2022: George
	- Better output for skipped tdir tests.

21 September 2022: Wouter
	- Patch for CVE-2022-3204 Non-Responsive Delegation Attack.
	- This patch was released in 1.16.3, the code repository continues
	  with the previous features and fixes for 1.17.0.
	- Fix doxygen warning in respip.h.

20 September 2022: George
	- Convert tdir tests to use the new skip_test functionality.
	- Remove unused testcode/mini_tpkg.sh file.

16 September 2022: George
	- Merge #753: ACL per interface. (New interface-* configuration
	  options).

2 September 2022: Wouter
	- Remove include that was there for debug purposes.
	- Fix to check pthread_t size after pthread has been detected.

1 September 2022: Wouter
	- Fix to update config tests to fix checking if nonblocking sockets
	  work on OpenBSD.
	- Slow down log frequency of write wait failures.
	- Fix to set out of file descriptor warning to operational verbosity.
	- Fix to log a verbose message at operational notice level if a
	  thread is not responding, to stats requests. It is logged with
	  thread identifiers.

31 August 2022: Wouter
	- Fix to avoid process wide fcntl calls mixed with nonblocking
	  operations after a blocked write.
	- Patch from Vadim Fedorenko that adds MSG_DONTWAIT to receive
	  operations, so that instruction reordering does not cause mistakenly
	  blocking socket operations.
	- Fix to wait for blocked write on UDP sockets, with a timeout if it
	  takes too long the packet is dropped.
	- Fix for wait for udp send to stop when packet is successfully sent.

22 August 2022: Wouter
	- Fix #741: systemd socket activation fails on IPv6.

12 August 2022: Wouter
	- Fix to log accept error ENFILE and EMFILE errno, but slowly, once
	  per 10 seconds. Also log accept failures when no slow down is used.

5 August 2022: Wouter
	- Fix #734 [FR] enable unbound-checkconf to detect more (basic)
	  errors.

4 August 2022: Wouter
	- Fix ratelimit inconsistency, for ip-ratelimits the value is the
	  amount allowed, like for ratelimits.

2 August 2022: Wouter
	- Fix edns subnet so that scope 0 answers only match sourcemask 0
	  queries for answers from cache if from a query with sourcemask 0.
	- Fix unittest for edns subnet change.
	- Merge #730 from luisdallos: Fix startup failure on Windows 8.1 due
	  to unsupported IPV6_USER_MTU socket option being set.

1 August 2022: Wouter
	- Fix the novel ghost domain issues CVE-2022-30698 and CVE-2022-30699.
	- Tests for ghost domain fixes.
	- Tag for 1.16.2 release. The code repo continues with 1.16.3.
	- Fix #728: alloc_reg_obtain() core dump. Stop double
	  alloc_reg_release when serviced_create fails.

19 July 2022: George
	- Update documentation for 'outbound-msg-retry:'.

19 July 2022: Wouter
	- Merge #718: Introduce infra-cache-max-rtt option to config max
	  retransmit timeout.

15 July 2022: Wouter
	- Merge PR 714: Avoid treat normal hosts as unresponsive servers.
	  And fixup the lock code.
	- iana portlist update.

12 July 2022: George
	- For windows crosscompile, fix setting the IPV6_MTU socket option
	  equivalent (IPV6_USER_MTU); allows cross compiling with latest
	  cross-compiler versions.

12 July 2022: Wouter
	- Fix dname count in sldns parse type descriptor for SVCB and HTTPS.

11 July 2022: Wouter
	- Fix verbose EDE error printout.

4 July 2022: George
	- Fix bug introduced in 'improve val_sigcrypt.c::algo_needs_missing for
	  one loop pass'.
	- Merge PR #668 from Cristian Rodríguez: Set IP_BIND_ADDRESS_NO_PORT on
	  outbound tcp sockets.

4 July 2022: Wouter
	- Tag for 1.16.1rc1 release. This became 1.16.1 on 11 July 2022.
	  The code repo continues with version 1.16.2 under development.

3 July 2022: George
	- Merge PR #671 from Petr Menšík: Disable ED25519 and ED448 in FIPS
	  mode on openssl3.
	- Merge PR #660 from Petr Menšík: Sha1 runtime insecure.
	- For #660: formatting, less verbose logging, add EDE information.
	- Fix for correct openssl error when adding windows CA certificates to
	  the openssl trust store.
	- Improve val_sigcrypt.c::algo_needs_missing for one loop pass.
	- Reintroduce documentation and more EDE support for
	  val_sigcrypt.c::dnskeyset_verify_rrset_sig.

1 July 2022: George
	- Merge PR #706: NXNS fallback.
	- From #706: Cached NXDOMAIN does not increase the target nx
	  responses.
	- From #706: Don't generate parent side queries if we already
	  have the lame records in cache.
	- From #706: When a lame address is the best choice, don't try to
	  generate target queries when the missing targets are all lame.

29 June 2022: Wouter
	- iana portlist update.
	- Fix detection of libz on windows compile with static option.
	- Fix compile warning for windows compile.

29 June 2022: George
	- Add debug option to the mini_tdir.sh test code.
	- Fix #704: [FR] Statistics counter for number of outgoing UDP queries
	  sent; introduces 'num.query.udpout' to the 'unbound-control stats'
	  command.
	- Fix to not count cached NXDOMAIN for MAX_TARGET_NX.
	- Allow fallback to the parent side when MAX_TARGET_NX is reached.
	  This will also allow MAX_TARGET_NX more NXDOMAINs.

28 June 2022: George
	- Show the output of the exact .rpl run that failed with 'make test'.
	- Fix for cached 0 TTL records to not trigger prefetching when
	  serve-expired-client-timeout is set.

28 June 2022: Wouter
	- Fix test program dohclient close to use portability routine.

23 June 2022: Tom
	- Clarify -v flag manpage entry (#705)

22 June 2022: Philip
	- Fix #663: use after free issue with edns options.

21 June 2022: Philip
	- Fix for loading locally stored zones that have lines with blanks or
	  blanks and comments.

20 June 2022: George
	- Remove unused LDNS function check for GOST Engine unloading.

14 June 2022: George
	- Merge PR #688: Rpz url notify issue.
	- Note in the unbound.conf text that NOTIFY is allowed from the url:
	  addresses for auth and rpz zones.

3 June 2022: George
	- Fix for edns client subnet to respect not looking in its cache when
	  instructed to do so (e.g., prefetch).

3 June 2022: Wouter
	- makedist.sh picks up 32bit libssp-0.dll when 32bit compile.

27 May 2022: Wouter
	- Fix #684: [FTBS] configure script error with libmnl on openSUSE 15.3 (and possibly other distributions)
	- Version is set to 1.16.0 for release. Release tag 1.16.0rc1. This
	  became release 1.16.0 on 2 June 2022. The source code branch
	  continues with version 1.16.1 under development.

20 May 2022: Wouter
	- Fix to silence test for ede error output to the console from the
	  test setup script.
	- Fix ede test to not use default pidfile, and use local interface.
	- Fix some lint type warnings.

18 May 2022: George
	- Fix typos in config_set_option for the 'num-threads' and
	  'ede-serve-expired' options.

15 May 2022: George
	- Fix #678: [FR] modify behaviour of unbound-control rpz_enable zone,
	  by updating unbound-control's documentation.

12 May 2022: George
	- Fix #417: prefetch and ECS causing cache corruption when used
	  together.

12 May 2022: Wouter
	- Merge #677: Allow using system certificates not only on Windows,
	  from pemensik.
	- For #677: Added tls-system-cert to config parser and documentation.

11 May 2022: Wouter
	- Fix #673: DNS over TLS: error: SSL_handshake syscall: No route to
	  host.

10 May 2022: George
	- Fix Python build in non-source directory; based on patch by
	  Michael Tokarev.

6 May 2022: Tom
	- Merge PR #604: Add basic support for EDE (RFC8914).

28 April 2022: Wouter
	- Fix #670: SERVFAIL problems with unbound 1.15.0 running on
	  OpenBSD 7.1.

8 April 2022: Wouter
	- Fix zonemd check to allow unsupported algorithms to load.
	  If there are only unsupported algorithms, or unsupported schemes,
	  and no failed or successful other ZONEMD records, or malformed
	  or bad ZONEMD records, the unsupported records allow the zone load.
	- Fix zonemd unsupported algo check.
	- Fix zonemd unsupported algo check reason to not copy to next record,
	  and check for success for debug printout.
	- Fix zonemd unsupported algo check to print unsupported reason before
	  zeroing it.
	- Fix zonemd unsupported algo check to set reason to NULL before the
	  check routine, but after malformed checks, to get the correct NULL
	  output when the digest matches.

25 March 2022: Wouter
	- Fix spelling error in comment in sldns_str2wire_svcparam_key_lookup.

23 March 2022: Wouter
	- Fix #651: [FR] Better logging for refused queries.

18 March 2022: George
	- Merge PR #648 from eaglegai: fix -q doesn't work when use with
	  'unbound-control stats_shm'.

17 March 2022: Wouter
	- Fix to describe auth-zone and other configuration at the local-zone
	  configuration option, to allow for more broadly view of the options.

16 March 2022: Wouter
	- Fix to ensure uniform handling of spaces and tabs when parsing RRs.

9 March 2022: Wouter
	- Merge #644: Make `install-lib` make target install the pkg-config
	  file.

7 March 2022: Wouter
	- Fix configure for python to use sysutils, because distutils is
	  deprecated. It uses sysutils when available, distutils otherwise.

3 March 2022: Wouter
	- Fix #637: Integer Overflow in sldns_str2period function.
	- Fix for #637: fix integer overflow checks in sldns_str2period.

2 March 2022: George
	- Merge PR #632 from scottrw93: Match cnames in ipset.
	- Various fixes for #632: variable initialisation, convert the qinfo
	  to str once, accept trailing dot in the local-zone ipset option.

2 March 2022: Wouter
	- Fix compile warnings for printf ll format on mingw compile.

1 March 2022: Wouter
	- Fix pythonmod for change in iter_dp_is_useless function prototype.

28 February 2022: George
	- Fix #630: Unify the RPZ log messages.
	- Merge #623 from rex4539: Fix typos.

28 February 2022: Wouter
	- Fix #633: Document unix domain socket support for unbound-control.
	- Fix for #633: updated fix with new text.
	- Fix edns client subnet to add the option based on the option list,
	  so that it is not state dependent, after the state fix of #605 for
	  double EDNS options.
	- Fix for edns client subnet option add fix in removal code, from review.

25 February 2022: Wouter
	- Fix to detect that no IPv6 support means that IPv6 addresses are
	  useless for delegation point lookups.
	- update Makefile dependencies.
	- Fix check interface existence for support detection in remote lookup.

18 February 2022: Wouter
	- Fix that address not available is squelched from the logs for
	  udp connect failures. It is visible on verbosity 4 and more.
	- Merge #631 from mollyim: Replace OpenSSL's ERR_PACK with
	  ERR_GET_REASON.

16 February 2022: Wouter
	- Fix for #628: fix rpz-passthru for qname trigger by localzone type.

15 February 2022: Wouter
	- Fix #628: A rpz-passthru action is not ending RPZ zone processing.

11 February 2022: Wouter
	- Fix #624: Unable to stop Unbound in Windows console (does not
	  respond to CTRL+C command).
	- Fix #618: enabling interface-automatic disables DNS-over-TLS.
	  Adds the option to list interface-automatic-ports.
	- Remove debug info from #618 fix.

7 February 2022: Wouter
	- Fix that TCP interface does not use TLS when TLS is also configured.

4 February 2022: Wouter
	- Fix #412: cache invalidation issue with CNAME+A.

3 February 2022: Wouter
	- Fix for #611: Integer overflow in sldns_wire2str_pkt_scan.
	- Tag for 1.15.0rc1 created. That became 1.15.0 on 10 feb 2022.
	  The repository continues with version 1.15.1.

2 February 2022: George
	- Merge PR #532 from Shchelk: Fix: buffer overflow bug.
	- Merge PR #616: Update ratelimit logic. It also introduces
	  ratelimit-backoff and ip-ratelimit-backoff configuration options.
	- Change aggressive-nsec default to yes.
	- Merge PR #617: Update stub/forward-host notation to accept port and
	  tls-auth-name.
	- Update stream_ssl.tdir test to also use the new forward-host
	  notation.

2 February 2022: Wouter
	- Update version number in repo to 1.15.0 for upcoming release,
	  since it changes the aggressive-nsec default and the ratelimit change.
	- Fix header comment for doxygen for authextstrtoaddr.
	- please clang analyzer for loop in test code.
	- Fix docker splint test to use more portable uname.
	- Update contrib/aaaa-filter-iterator.patch with diff for current
	  software version.

1 February 2022: George
	- Merge PR #603 from fobser: Use OpenSSL 1.1 API to access DSA and RSA
	  internals.

31 January 2022: George
	- Fix review comment for use-after-free when failing to send UDP out.

31 January 2022: Wouter
	- iana portlist update.

29 January 2022: George
	- Fix tls-* and ssl-* documented alternate syntax to also be available
	  through remote-control and unbound-checkconf.
	- Better cleanup on failed DoT/DoH listening socket creation.

26 January 2022: George
	- Fix #599: [FR] RFC 9156 (obsoletes RFC 7816), by noting the new RFC
	  document.

26 January 2022: Wouter
	- Test for NSID in SERVFAIL response due to DNSSEC bogus.

25 January 2022: George
	- Fix #588: Unbound 1.13.2 crashes due to p->pc is NULL in
	  serviced_udp_callback.
	- Merge PR #612: TCP race condition.

25 January 2022: Wouter
	- Fix #610: Undefine-shift in sldns_str2wire_hip_buf.

19 January 2022: George
	- For dnstap, do not wakeupnow right there. Instead zero the timer to
	  force the wakeup callback asap.

14 January 2022: George
	- Merge PR #605:
	  - Fix EDNS to upstream where the same option could be attached
	     more than once.
	  - Add a region to serviced_query for allocations.

14 January 2022: Wouter
	- Add rpz: for-downstream: yesno option, where the RPZ zone is
	  authoritatively answered for, so the RPZ zone contents can be
	  checked with DNS queries directed at the RPZ zone.
	- For #602: Allow the module-config "subnetcache validator cachedb
	  iterator".

11 January 2022: George
	- Fix prematurely terminated TCP queries when a reply has the same ID.

7 January 2022: Wouter
	- Merge #600 from pemensik: Change file mode before changing file
	  owner.

5 January 2022: Wouter
	- Fix for #596: fix that rpz return message is returned and not just
	  the rcode from the iterator return path. This fixes signal unset RA
	  after a CNAME.
	- Fix unit tests for rpz now that the AA flag returns successfully from
	  the iterator loop.
	- Fix for #596: add unit test for nsdname trigger and signal unset RA.
	- Fix for #596: add unit test for nsip trigger and signal unset RA.
	- Fix #598: Fix unbound-checkconf fatal error: module conf
	  'respip dns64 validator iterator' is not known to work.
	- Fix for #596: Fix rpz-signal-nxdomain-ra to work for clientip
	  triggered operation.

4 January 2022: Wouter
	- Fix #596: unset the RA bit when a query is blocked by an unbound
	  RPZ nxdomain reply. The option rpz-signal-nxdomain-ra allows to
	  signal that a domain is externally blocked to clients when it
	  is blocked with NXDOMAIN by unsetting RA.
	- Fix to add test for rpz-signal-nxdomain-ra.
	- Fix #596: only unset RA when NXDOMAIN is signalled.
	- Fix that RPZ does not set RD flag on replies, it should be copied
	  from the query.

22 December 2021: George
	- contrib/aaaa-filter-iterator.patch file renewed diff content to
	  apply cleanly to the current coderepo for the current code version.

20 December 2021: George
	- Fix #591: Unbound-anchor manpage links to non-existent license file.

13 December 2021: George
	- Add missing configure flags for optional features in the
	  documentation.
	- Fix Unbound capitalization in the documentation.

13 December 2021: Wouter
	- Fix to pick up other class local zone information before unlock.

10 December 2021: George
	- Allow local-data for classes other than IN to inherit a configured
	  local-zone's type if possible, instead of defaulting to type
	  transparent as per the implicit rule.

10 December 2021: Wouter
	- Add code similar to fix for ldns for tab between strings, for
	  consistency, the test case was not broken.

6 December 2021: Wouter
	- Merge PR #581 from fobser: Fix -Wmissing-prototypes and -Wshadow
	  warnings in rpz.
	- Fix validator debug output about DS support, print correct algorithm.

3 December 2021: Wouter
	- Fix compile warning for if_nametoindex on windows 64bit.

1 December 2021: Wouter
	- configure is set to 1.14.0, and release branch.
	  This was released as version 1.14.0 on 9 Dec 2021, with the doxygen
	  fix below included. The main branch continues as 1.14.1.
	- Fix doc/unbound.doxygen to remove obsolete tag warning.

1 December 2021: George
	- Merge PR #511 from yan12125: Reduce unnecessary linking.
	- Merge PR #493 from Jaap: Fix generation of libunbound.pc.
	- Merge PR #555 from fobser: Allow interface names as scope-id in IPv6
	  link-local addresses.
	- Merge PR #562 from Willem: Reset keepalive per new tcp session.
	- Merge PR #522 from sibeream: memory management violations fixed.
	- Merge PR #530 from Shchelk: Fix: dereferencing a null pointer.
	- Fix #454: listen_dnsport.c:825: error: ‘IPV6_TCLASS’ undeclared.
	- Fix #574: Review fixes for size allocation.

30 November 2021: Wouter
	- Fix to remove git tracking and ci information from release tarballs.
	- iana portlist update.

29 November 2021: Wouter
	- Merge PR #570 from rex4539: Fix typos.
	- Fix for #570: regen aclocal.m4, fix configure.ac for spelling.
	- Fix to make python module opt_list use opt_list_in.
	- Fix #574: unbound-checkconf reports fatal error if interface names
	  are used as value for interfaces:
	- Fix #574: Review fixes for it.
	- Fix #576: [FR] UB_* error codes in unbound.h
	- Fix #574: Review fix for spelling.

15 November 2021: Tom
	- Improve EDNS option handling, now also works for synthesised
	  responses such as local-data and server.id CH TXT responses.

5 November 2021: George
	- Fix for #558: fix loop in comm_point->tcp_free when a comm_point is
	  reclaimed more than once during callbacks.
	- Fix for #558: clear the UB_EV_TIMEOUT bit before adding an event.

5 November 2021: Wouter
	- Fix that forward-zone name is documented as the full name of the
	  zone. It is not relative but a fully qualified domain name.
	- Fix analyzer review failure in rpz action override code to not
	  crash on unlocking the local zone lock.
	- Fix to remove unused code from rpz resolve client and action
	  function.
	- Merge #565: unbound.service.in: Disable ProtectKernelTunables again.

2 November 2021: Wouter
	- Fix #552: Unbound assumes index.html exists on RPZ host.

11 October 2021: Wouter
	- Fix chaos replies to have truncation for short message lengths,
	  or long reply strings.
	- Fix to protect custom regional create against small values.

4 October 2021: Wouter
	- Fix to add example.conf note for outbound-msg-retry.

27 September 2021: Wouter
	- Implement RFC8375: Special-Use Domain 'home.arpa.'.

21 September 2021: Wouter
	- For crosscompile on windows, detect 64bit stackprotector library.
	- Fix crosscompile shell syntax.
	- Fix crosscompile windows to use libssp when it exists.
	- For the windows compile script disable gost.
	- Fix that on windows, use BIO_set_callback_ex instead of deprecated
	  BIO_set_callback.
	- Fix crosscompile script for the shared build flags.

20 September 2021: Wouter
	- Fix crosscompile on windows to work with openssl 3.0.0 the
	  link with ws2_32 needs -l:libssp.a for __strcpy_chk.
	  Also copy results from lib64 directory if needed.

10 September 2021: Wouter
	- Fix initialisation errors reported by gcc sanitizer.
	- Fix lock debug code for gcc sanitizer reports.
	- Fix more initialisation errors reported by gcc sanitizer.

8 September 2021: Wouter
	- Merged #41 from Moritz Schneider: made outbound-msg-retry
	  configurable.
	- Small fixes for #41: changelog, conflicts resolved,
	  processQueryResponse takes an iterator env argument like other
	  functions in the iterator, no colon in string for set_option,
	  and some whitespace style, to make it similar to the rest.
	- Fix for #41: change outbound retry to int to fix signed comparison
	  warnings.
	- Fix root_anchor test to check with new icannbundle date.

3 September 2021: Wouter
	- Fix #538: Fix subnetcache statistics.

1 September 2021: Wouter
	- Fix tcp fastopen failure when disabled, try normal connect instead.

27 August 2021: Wouter
	- Fix #533: Negative responses get cached even when setting
	  cache-max-negative-ttl: 1

25 August 2021: Wouter
	- Merge #401: RPZ triggers. This add additional RPZ triggers,
	  unbound supports a full set of rpz triggers, and this now
	  includes nsdname, nsip and clientip triggers. Also actions
	  are fully supported, and this now includes the tcp-only action.
	- Fix #536: error: RPZ: name of record (drop.spamhaus.org.rpz.local.)
	  to insert into RPZ.
	- Fix the stream wait stream_wait_count_lock and http2 buffer locks
	  setup and desetup from race condition.
	- Fix RPZ locks. Do not unlock zones lock if requested and rpz find
	  zone does not find the zone. Readlock the clientip that is found
	  for ipbased triggers. Unlock the nsdname zone lock when done.
	  Unlock zone and ip in rpz nsip and nsdname callback. Unlock
	  authzone and localzone if clientip found in rpz worker call.
	- Fix compile warning in libunbound for listen desetup routine.
	- Fix asynclook unit test for setup of lockchecks before log.

20 August 2021: Wouter
	- Fix #529: Fix: log_assert does nothing if UNBOUND_DEBUG is
	  undefined.
	- Fix #531: Fix: passed to proc after free.

17 August 2021: Wouter
	- Fix that --with-ssl can use "/usr/include/openssl11" to pass the
	  location of a different openssl version.
	- Fix #527: not sending quad9 cert to syslog (and may be more).
	- Fix sed script in ssldir split handling.

16 August 2021: George
	- Merge PR #528 from fobser: Make sldns_str2wire_svcparam_buf()
	  static.

16 August 2021: Wouter
	- Fix to support harden-algo-downgrade for ZONEMD dnssec checks.

13 August 2021: Wouter
	- Support using system-wide crypto policies.
	- Fix for #431: Squelch permission denied errors for udp connect,
	  and udp send, they are visible at higher verbosity settings.
	- Fix zonemd verification of key that is not in DNS but in the zone
	  and needs a chain of trust.
	- zonemd, fix order of bogus printout string manipulation.

12 August 2021: George
	- Merge PR #514, from ziollek: Docker environment for run tests.
	- For #514: generate configure.

12 August 2021: Wouter
	- And 1.13.2rc1 became the 1.13.2 with the fix for the python module
	  build. The current code repository continues with version 1.13.3.
	- Add test tool readzone to .gitignore.
	- Merge #521: Update mini_event.c.
	- Merge #523: fix: free() call more than once with the same pointer.
	- Merge #519: Support for selective enabling tcp-upstream for
	  stub/forward zones.
	- For #519: note stub-tcp-upstream and forward-tcp-upstream in
	  the example configuration file.
	- For #519: yacc and lex. And fix python bindings, and test program
	  unbound-dnstap-socket.
	- For #519: fix comments for doxygen.
	- Fix to print error from unbound-anchor for writing to the key
	  file, also when not verbose.

5 August 2021: Wouter
	- Tag for 1.13.2rc1 release.
	- Fix #520: Unbound 1.13.2rc1 fails to build python module.

4 August 2021: George
	- Merge PR #415 from sibeream: Use
	  /proc/sys/net/ipv4/ip_local_port_range to determine available outgoing
	  ports. (New --enable-linux-ip-local-port-range configuration option)
	- Bump MAX_RESTART_COUNT to 11 from 8; in relation to #438. This
	  allows longer CNAME chains in Unbound.

4 August 2021: Wouter
	- In unit test use openssl set security level to allow keys in test.
	- Fix static analysis warnings about localzone locks that are unused.
	- Fix missing locks in zonemd unit test.
	- Fix readzone compile under debug config.
	- Fix out of sourcedir run of zonemd unit tests.
	- Fix libnettle zonemd unit test.
	- Fix unit test zonemd_reload for use in run_vm.

3 August 2021: George
	- Listen to read or write events after the SSL handshake.
	  Sticky events on windows would stick on read when write was needed.

3 August 2021: Wouter
	- Merge PR #517 from dyunwei: #420 breaks the mesh reply list
	  function that need to reuse the dns answer.
	- Annotate assertion into error printout; we think it may be an
	  error, but the situation looks harmless.
	- Fix sign comparison warning on FreeBSD.

2 August 2021: Wouter
	- Prepare for OpenSSL 3.0.0 provider API usage, move the sldns
	  keyraw functions to produce EVP_PKEY results.
	- Move RSA and DSA to use OpenSSL 3.0.0 API.
	- Move ECDSA functions to use OpenSSL 3.0.0 API.
	- iana portlist update.
	- Fix verbose printout failure in tcp reuse unit test.

30 July 2021: Wouter
	- Fix #515: Compilation against openssl 3.0.0 beta2 is failing to
	  build unbound.
	- For #515: Fix compilation with openssl 3.0.0 beta2, lib64 dir and
	  SSL_get_peer_certificate.
	- Move acx_nlnetlabs.m4 to version 41, with lib64 openssl dir check.

26 July 2021: George
	- Merge #513: Stream reuse, attempt to fix #411, #439, #469. This
	  introduces a couple of fixes for the stream reuse functionality
	  that could result in broken internal structures.

26 July 2021: Wouter
	- Merge #512: unbound.service.in: upgrade hardening to latest
	  standards.
	- Fix readzone unknown type print for memory resize.

21 July 2021: Wouter
	- Fix that ldns_zone_new_frm_fp_l counts the line number for an empty
	  line after a comment.

16 July 2021: George
	- Introduce 'http-user-agent:' and 'hide-http-user-agent:' options.

16 July 2021: Wouter
	- Merge #510 from ndptech: Don't call a function which hasn't been
	  defined.
	- Fix for #510: in depth, use ifdefs for windows api event calls.
	- Fix spelling in doc/unbound.doxygen comment.
	- Fix spelling in localzone.h comment.
	- Fix unbound-control local_data and local_datas to print detailed
	  syntax errors.
	- review fix to remove duplicate error printout.
	- Insert header into testcode/readzone.c, it was missing.
	- Fix from lint for ignored return value.
	- Fix for older parsers for function call in serve expired get cached.

6 July 2021: Wouter
	- iana portlist update.

5 July 2021: George
	- Fix compiler warnings for #491.
	- Fix clang-analysis warnings for testcode/readzone.c.

4 July 2021: George
	- Fix Wunused-result compile warnings.

2 July 2021: Tom
	- Merge PR #491: Add SVCB and HTTPS types and handling according to
	  draft-ietf-dnsop-svcb-https.

2 July 2021: Wouter
	- Fix #506: Python Module Seems to Leak Memory if it Experiences an
	  Unhandled Exception.

25 June 2021: Wouter
	- Fix up permissions on rpl data file in tests.
	- Fix testbound newline treatment in moment_read and tempfile write.
	- Fix configure grep for reuseport default for failure.
	- Fix compat ctime_r return value
	- Fix configure does not require pkg-config if not needed.
	- Fix unit test in the ctime_r calls for autotrust and in testbound.
	- Fix auth zone download on windows to unlink before rename.

24 June 2021: Wouter
	- Add analyzer and port compile github workflow.

23 June 2021: Wouter
	- Fix #503: DNS over HTTPS response truncated.
	- Fix warnings reported by the gcc analyzer.

21 June 2021: George
	- Fix #495: Documentation or implementation of "verbosity" option.

18 June 2021: Wouter
	- Fix a number of warnings reported by the gcc analyzer.

15 June 2021: George
	- Merge #440 by kimheino: Various fixes to contrib/unbound_munin_ file.

14 June 2021: Wouter
	- Fix configure nonblocking test and onmingw test to use host.

10 June 2021: Wouter
	- Fix #500: SPEC file in version 1.13.1 references version 1.4;
	  unable to build RPM from source.
	- Fix contrib/unbound.spec, fixed url and comment.

9 June 2021: George
	- Merge #486 by fobster: Make VAL_MAX_RESTART_COUNT configurable.
	- Generated lexer and parser for #486; updated example.conf.
	- Fix #413 (based on patch by k-ronny): unbound: does not compile
	  on macOS 11.1-x86_64 host.
	- Use host_os instead of target_os in configure for Darwin8 build.

8 June 2021: George
	- Fix unused variable warning when compiling with --enable-dnstap.

7 June 2021: George
	- Merge #448 from shoeper: Update unbound-control.8.in, fix
	  rpz_disable typo.
	- Fix #425: Document auth-zone supports communication with DNS
	  primary on nondefault port.

1 June 2021: George
	- Fix test for zonemd-check option.

27 May 2021: Wouter
	- Merge #496 from banburybill: Use build system endianness if
	  available, otherwise try to work it out.
	- zonemd-check: yesno option, default no, enables the processing
	  of ZONEMD records for that zone.

25 May 2021: Wouter
	- Move the NSEC3 max iterations count in line with the 150 value
	  used by BIND, Knot and PowerDNS. This sets the default value
	  for it in the configuration to 150 for all key sizes.
	- Fix #492: module-config respip missing in unbound.conf.5.in man
	  page. Merges #494 from he32.
	- For #492: Fix font highlighting for the man page on emacs.

21 May 2021: Wouter
	- Test code has -q option for quiet output.

19 May 2021: George
	- Fix for #411, #439, #469: Reset the DNS message ID when moving queries
	  between TCP streams.
	- Refactor for uniform way to produce random DNS message IDs.

17 May 2021: Wouter
	- Fix #489: Compile using MSYS2 MinGW 64-bit.

12 May 2021: Wouter
	- Fix that auth-zone zonefiles use last TTL if no TTL is specified.

10 May 2021: Wouter
	- Merge PR #487: ifdef RLIMIT_AS in recently added check.

7 May 2021: Wouter
	- Fix #485: Unbound occasionally reports broken stats.
	- Add ./configure --with-deprecate-rsa-1024 that turns off RSA 1024.
	- Remove case fallthrough from deprecate-rsa-1024 code.

4 May 2021: George
	- Fix for #367: only attempt to get the interface for queries that are no
	  longer on the tcp_waiting_list.
	- Add more logging for out-of-memory cases.

4 May 2021: Wouter
	- Merge #478: Allow configuration of TCP timeout while waiting for
	  response.
	- Fix to squelch tcp socket bind failures when the interface is gone.
	- Rerun flex and bison.

3 May 2021: Wouter
	- Fix #481: Fix comment in configuration file.

29 April 2021: Wouter
	- Add that log-servfail prints an IP address and more information
	  about one of the last failures for that query.

28 April 2021: George
	- Fix compiler warning for signed/unsigned comparison for
	  max_reuse_tcp_queries.

28 April 2021: Wouter
	- Fix #474: always_null and others inside view.

26 April 2021: Wouter
	- Merge #470 from edevil: Allow configuration of persistent TCP
	  connections.

22 April 2021: Wouter
	- Merge #466 from FGasper: Support OpenSSLs that lack
	  SSL_get0_alpn_selected.
	- Fix #468: OpenSSL 1.0.1 can no longer build Unbound.
	- Further fix for #468: detect SSL_CTX_set_alpn_protos for build with
	  OpenSSL 1.0.1.
	- Fix that testcode dohclient has OpenSSL initialisation calls.

13 April 2021: George
	- Fix documentation comment for files previously residing in checkconf/.
	- Remove unused functions worker_handle_reply and libworker_handle_reply.

13 April 2021: Wouter
	- Fix that nxdomain synthesis does not happen above the stub or
	  forward definition.

12 April 2021: George
	- Fix (increase) verbosity level for iterator error log in
	  processQueryTargets().

12 April 2021: Wouter
	- Fix permission denied sendto log, squelch the log messages
	  unless high verbosity is set.

9 April 2021: Wouter
	- rebuild configure to set EXTRALINK to libunbound.la for #460.

7 April 2021: Wouter
	- Fix for #411: Depth protect for crash on deleted element timeout.

1 April 2021: Wouter
	- Merge #460 from orbea: build: Link with the libtool archive.
	- Fix to stop IPv6 PMTU discovery.

31 March 2021: George
	- Clean makedist.sh.

31 March 2021: Wouter
	- Fix stack-protector change to not override other CFLAGS options.

30 March 2021: George
	- Disable the use of stack-protector for cross compiled 32-bit windows
	  builds; relates to #444.

25 March 2021: Wouter
	- Fix #429: Also fix end of transfer for http download of auth zones.

24 March 2021: Wouter
	- Fix deprecation test to work for iOS TVOS and WatchOS, it uses
	  CFLAGS and CPPFLAGS and also checks if the item is unavailable.
	- Travis, fix script to fail when tasks fail.
	- Travis, fix warning in ubsan compile.
	- Fix configure Targetconfiditionals.h header check, to use compile.
	- Fix that cachedb does not produce empty object files when disabled.

23 March 2021: Wouter
	- Travis enable all tests again. Clang analyzer only a couple times,
	  when there is a difference. homebrew updates disabled, so it does
	  not hang. removed trailing slashes from configure paths. Moved iOS
	  tests to allow-failure.
	- travis, analyzer disabled on test without debug, that does not
	  run anyway.  Turn off failing tests except one.  Update iOS test
	  to xcode image 12.2.

22 March 2021: George
	- Fix unused-function warning when compiling with --enable-dnscrypt.
	- Fix for #367: fix memory leak when cannot bind to listening port.
	- Reformat pythonmod/pythonmod_utils.{c,h}.

22 March 2021: Wouter
	- Merge #449 from orbea: build: Add missing linker flags.
	- iana portlist update.
	- Comment out nonworking OSX and IOS travis tests, vm fails to start.
	- Fix compile error in listen_dnsport on Android.
	- Fix memory leak reported by asan in rpz SOA record query name.

19 March 2021: Wouter
	- Fix for #447: squelch connection refused tcp connection failures
	  from the log, unless verbosity is high.

17 March 2021: Wouter
	- Fix #441: Minimal NSEC range not accepted for top level domains.

11 March 2021: Wouter
	- Fix parse of LOC RR type for decimetres.

5 March 2021: Wouter
	- Workaround for #439: prevent loops in the reuse rbtree.
	- Debug output for #411 and #439: printout internal error and details.

4 March 2021: Wouter
	- iana portlist update.
	- Fix spurious errors about "Could not generate request: out of
	  memory".  The mesh detect cycle routine no longer wrongly stops
	  the check when the calling mesh state is unique.

26 February 2021: George
	- Fix for #367: rc_ports don't have ub_sock; skip cleaning up.

26 February 2021: Wouter
	- Fix: Resolve interface names on control-interface too.

25 February 2021: Wouter
	- Merge PR #367 : DNSTAP log local address.  With code from PR #365
	  and fixes #368 : dnstap does not log the DNS message ID for
	  FORWARDER_QUERY.
	- Fix to allow rpz with wildcard that applies to all TLDs at once.

24 February 2021: George
	- Fix #384: (1) A minor request to improve the log (2) A minor bug in one
	  log message.
	- ipsecmod: Better logging for detecting a cycle when attaching the
	  A/AAAA subquery.

24 February 2021: Wouter
	- On startup of unbound it checks if rlimits on memory size look
	  sufficient for the configured cache size, and logs warning if not.
	- Fix function documentation.
	- Fix unit test for added ulimit checks.
	- spelling fix in header.

23 February 2021: Wouter
	- Fix for zonemd, that domain-insecure zones work without dnssec.
	- Fix for zonemd, do not reject insecure result from trust anchor
	  validation step in dnssec chain of trust.

22 February 2021: Wouter
	- Fix #431: Squelch permission denied errors for tcp connect
	  and udp connect from the logs, unless at high verbosity.
	- Fix for zonemd, that nxdomain for the chain of trust is allowed
	  for island zones, it is treated as an insecure zone for verification.

18 February 2021: Wouter
	- Merge PR #317: ZONEMD Zone Verification, with RFC 8976 support.
	  ZONEMD records are checked for zones loaded as auth-zone,
	  with DNSSEC if available.  There is an added option
	  zonemd-permissive-mode that makes it log but not fail wrong zones.
	  With zonemd-reject-absence for an auth-zone the presence of a
	  zonemd can be mandated for specific zones.
	- Fix doxygen and pydoc warnings.
	- Fix #429: rpz: url: with https: broken (regression in 1.13.1).
	- rpz skip nsec3param records, and nicer log for unsupported actions.

15 February 2021: Wouter
	- Fix #422: IPv6 fallback issues when IPv6 is not properly
	  enabled/configured.
	- Fix to make tests work with support indicators set for iterator.
	- Fix build on Python 3.10.

10 February 2021: Wouter
	- Merge PR #420 from dyunwei: DOH not responding with
	  "http2_query_read_done failure" logged.

9 February 2021: Wouter
	- Fix for Python 3.9, no longer use deprecated functions of
	  PyEval_CallObject (now PyObject_Call), PyEval_InitThreads (now
	  none), PyParser_SimpleParseFile (now Py_CompileString).

4 February 2021: Wouter
	- release 1.13.1rc2 tag on branch-1.13.1 with added changes of 2 feb.
	  This became 1.13.1 release tag on 9 feb.  The main branch is set
	  to version 1.13.2.

2 February 2021: Wouter
	- branch-1.13.1 is created, with release-1.13.1rc1 tag.
	- Fix dynlibmod link on rhel8 for -ldl inclusion.
	- Fix windows dependency on libssp.dll because of default stack
	  protector in mingw.
	- Fix indentation of root anchor for use by windows install script.

1 February 2021: George
	- Attempt to fix NULL keys in the reuse_tcp tree; relates to #411.

29 January 2021: Wouter
	- Fix for doxygen 1.8.20 compatibility.

28 January 2021: Wouter
	- Annotate that we ignore the return value of if_indextoname.
	- Fix to use correct type for label count in rpz routine.
	- Fix empty clause warning in config_file nsid parse.
	- Fix to use correct type for label count in ipdnametoaddr rpz routine.
	- Fix empty clause warning in edns pass for padding.
	- Fix fwd ancil test post script when not supported.

26 January 2021: George
	- Merge PR #408 from fobser: Prevent a few more yacc clashes.
	- Merge PR #275 from Roland van Rijswijk-Deij: Add feature to return the
	  original instead of a decrementing TTL ('serve-original-ttl')
	- Merge PR #355 from noloader: Make ICANN Update CA and DS Trust Anchor
	  static data.
	- Ignore cache blacklisting when trying to reply with expired data from
	  cache (#394).

26 January 2021: Wouter
	- Fix compile of unbound-dnstap-socket without dnstap installed.

22 January 2021: Willem
	- Padding of queries and responses with DNS over TLS as specified in
	  RFC7830 and RFC8467.

22 January 2021: George
	- Fix TTL of SOA record for negative answers (localzone and
	  authzone data) to be the minimum of the SOA TTL and the SOA.MINIMUM.

19 January 2021: Willem
	- Support for RFC5001: DNS Name Server Identifier (NSID) Option
	  with the nsid: option in unbound.conf

18 January 2021: Wouter
	- Fix #404: DNS query with small edns bufsize fail.
	- Fix declaration before statement and signed comparison warning in
	  dns64.

15 January 2021: Wouter
	- Merge #402 from fobser: Implement IPv4-Embedded addresses according
	  to RFC6052.

14 January 2021: Wouter
	- Fix for #93: dynlibmodule import library is named libunbound.dll.a.

13 January 2021: Wouter
	- Merge #399 from xiangbao227: The lock of lruhash table should
	  unlocked after markdel entry.
	- Fix for #93: dynlibmodule link fix for Windows.

12 January 2021: Wouter
	- Fix #397: [Feature request] add new type always_null to local-zone
	  similar to always_nxdomain.
	- Fix so local zone types always_nodata and always_deny can be used
	  from the config file.

8 January 2021: Wouter
	- Merge PR #391 from fhriley: Add start_time to reply callbacks so
	  modules can compute the response time.
	- For #391: use struct timeval* start_time for callback information.
	- For #391: fix indentation.
	- For #391: more double casts in python start time calculation.
	- Add comment documentation.
	- Fix clang analysis warning.

6 January 2021: Wouter
	- Fix #379: zone loading over HTTP appears to have buffer issues.
	- Merge PR #395 from mptre: add missing null check.
	- Fix #387: client-subnet-always-forward seems to effectively bypass
	  any caching?

5 January 2021: Wouter
	- Fix #385: autoconf 2.70 impacts unbound build
	- Merge PR #375 by fhriley: Add rpz_enable and rpz_disable commands
	  to unbound-control.

4 January 2021: Wouter
	- For #376: Fix that comm point event is not double removed or double
	  added to event map.
	- iana portlist updated.

16 December 2020: George
	- Fix error cases when udp-connect is set and send() returns an error
	  (modified patch from Xin Li @delphij).

11 December 2020: Wouter
	- Fix #371: unbound-control timeout when Unbound is not running.
	- Fix to squelch permission denied and other errors from remote host,
	  they are logged at higher verbosity but not on low verbosity.
	- Merge PR #335 from fobser: Sprinkle in some static to prevent
	  missing prototype warnings.
	- Merge PR #373 from fobser: Warning: arithmetic on a pointer to void
	  is a GNU extension.
	- Fix missing prototypes in the code.

3 December 2020: Wouter
	- make depend.
	- iana portlist updated.

2 December 2020: Wouter
	- Fix #360: for the additionally reported TCP Fast Open makes TCP
	  connections fail, in that case we print a hint that this is
	  happening with the error in the logs.
	- Fix #356: deadlock when listening tcp.
	- Fix unbound-dnstap-socket to not use log routine from interrupt
	  handler and not print so frequently when invoked in sequence.
	- Fix on windows to ignore connection failure on UDP, unless verbose.
	- Fix for #283: fix stream reuse and tcp fast open.
	- Fix update, with write event check with streamreuse and fastopen.

1 December 2020: Wouter
	- Fix #358: Squelch udp connect 'no route to host' errors on low
	  verbosity.

30 November 2020: Wouter
	- Fix assertion failure on double callback when iterator loses
	  interest in query at head of line that then has the tcp stream
	  not kept for reuse.
	- tag for the 1.13.0rc4 release.  This also became the 1.13.0
	  release version on 3 dec 2020 with the streamreuse and fastopen
	  fix from 2 dec 2020.  The code repo continues for 1.13.1 in
	  development.

27 November 2020: Wouter
	- Fix compile warning for type cast in http2_submit_dns_response.
	- Fix when use free buffer to initialize rbtree for stream reuse.
	- Fix compile warnings for windows.
	- Fix compile warnings in rpz initialization.
	- Fix contrib/metrics.awk for FreeBSD awk compatibility.
	- tag for the 1.13.0rc3 release.

26 November 2020: Wouter
	- Fix to omit UDP receive errors from log, if verbosity low.
	  These happen because of udp-connect.
	- For #352: contrib/metrics.awk for Prometheus style metrics output.
	- Fix that after failed read, the readagain cannot activate.
	- Clear readagain upon decommission of pending tcp structure.

25 November 2020: Wouter
	- with udp-connect ignore connection refused with UDP timeouts.
	- Fix udp-connect on FreeBSD, do send calls on connected UDP socket.
	- Better fix for reuse tree comparison for is-tls sockets.  Where
	  the tree key identity is preserved after cleanup of the TLS state.
	- Remove debug commands from reuse tests.
	- Fix memory leak for edns client tag opcode config element.
	- Attempt fix for libevent state in tcp reuse cases after a packet
	  is written.
	- Fix readagain and writeagain callback functions for comm point
	  cleanup.
	- tag for the 1.13.0rc2 release.

24 November 2020: Wouter
	- Merge PR #283 : Stream reuse.  This implements upstream stream
	  reuse for performing several queries over the same TCP or TLS
	  channel.
	- set version of main branch to 1.13.0 for upcoming release.
	- iana portlist updated.
	- Fix one port unit test for udp-connect.
	- tag for the 1.13.0rc1 release.
	- Fix crash when TLS connection is closed prematurely, when
	  reuse tree comparison is not properly identical to insertion.
	- Fix padding of struct regional for 32bit systems.

23 November 2020: George
	- Merge PR #313 from Ralph Dolmans: Replace edns-client-tag with
	  edns-client-string option.

23 November 2020: Wouter
	- Merge #351 from dvzrv: Add AF_NETLINK to set of allowed socket
	  address families.
	- Fix #350: with the AF_NETLINK permission, to fix 1.12.0 error:
	  failed to list interfaces: getifaddrs: Address family not
	  supported by protocol.
	- Fix #347: IP_DONTFRAG broken on Apple xcode 12.2.
	- Option to toggle udp-connect, default is enabled.
	- Fix for #303 CVE-2020-28935 : Fix that symlink does not interfere
	  with chown of pidfile.
	- Further fix for it and retvalue 0 fix for it.

12 November 2020: Wouter
	- Fix to connect() to UDP destinations, default turned on,
	  this lowers vulnerability to ICMP side channels.
	- Retry for interfaces with unused ports if possible.

10 November 2020: Wouter
	- Fix #341: fixing a possible memory leak.
	- Fix memory leak after fix for possible memory leak failure.
	- Fix #343: Fail to build --with-libnghttp2 with error: 'SSIZE_MAX'
	  undeclared.

27 October 2020: Wouter
	- In man page note that tls-cert-bundle is read before permission
	  drop and chroot.

22 October 2020: Wouter
	- Fix #333: Unbound Segmentation Fault w/ log_info Functions From
	  Python Mod.
	- Fix that minimal-responses does not remove addresses from a priming
	  query response.

21 October 2020: George
	- Fix #327: net/if.h check fails on some darwin versions; contribution by
	  Joshua Root.
	- Fix #320: potential memory corruption due to size miscomputation upton
	  custom region alloc init.

21 October 2020: Wouter
	- Merge PR #228 : infra-keep-probing option to probe hosts that are
	  down.  Add infra-keep-probing: yes option. Hosts that are down are
	  probed more frequently.
	  With the option turned on, it probes about every 120 seconds,
	  eventually after exponential backoff, and that keeps that way. If
	  traffic keeps up for the domain. It probes with one at a time, eg.
	  one query is allowed to probe, other queries within that 120 second
	  interval are turned away.

19 October 2020: George
	- Merge PR #324 from James Renken: Add modern X.509v3 extensions to
	  unbound-control TLS certificates.
	- Fix for PR #324 to attach the x509v3 extensions to the client
	  certificate.

19 October 2020: Ralph
	- local-zone regional allocations outside of chunk

19 October 2020: Wouter
	- Fix that http settings have colon in set_option, for
	  http-endpoint, http-max-streams, http-query-buffer-size,
	  http-response-buffer-size, and http-nodelay.
	- Fix memory leak of https port string when reading config.
	- Fix #330: [Feature request] Add unencrypted DNS over HTTPS support.
	  This adds the option http-notls-downstream: yesno to change that,
	  and the dohclient test code has the -n option.
	- Fix python documentation warning on functions.rst inplace_cb_reply.
	- Fix dnstap test to wait for log timer to see if queries are logged.
	- Log ip address when http session recv fails, eg. due to tls fail.
	- Fix to set the tcp handler event toggle flag back to default when
	  the handler structure is reused.
	- Clean the fix for out of order TCP processing limits on number
	  of queries.  It was tested to work.

16 October 2020: Wouter
	- Fix that the out of order TCP processing does not limit the
	  number of outstanding queries over a connection.

15 October 2020: George
	- Fix that if there are reply callbacks for the given rcode, those
	  are called per reply and a new message created if that was modified
	  by the call.
	- Pass the comm_reply information to the inplace_cb_reply* functions
	  during the mesh state and update the documentation on that.

15 October 2020: Wouter
	- Merge PR #326 from netblue30: DoH: implement content-length
	  header field
	- DoH content length, simplify code, remove declaration after
	  statement and fix cast warning.

14 October 2020: Wouter
	- Fix for python reply callback to see mesh state reply_list member,
	  it only removes it briefly for the commpoint call so that it does
	  not drop it and attempt to modify the reply list during reply.
	- Fix that if there are on reply callbacks, those are called per
	  reply and a new message created if that was modified by the call.
	- Free up auth zone parse region after use for lookup of host

13 October 2020: Wouter
	- Fix #323: unbound testsuite fails on mock build in systemd-nspawn
	  if systemd support is build.

9 October 2020: Wouter
	- Fix dnstap socket and the chroot not applied properly to the dnstap
	  socket path.
	- Fix warning in libnss compile, nss_buf2dsa is not used without DSA.

8 October 2020: Wouter
	- Tag for 1.12.0 release.
	- Current repo is version 1.12.1 in development.
	- Fix #319: potential memory leak on config failure, in rpz config.

1 October 2020: Wouter
	- Current repo is version 1.12.0 for release.  Tag for 1.12.0rc1.

30 September 2020: Wouter
	- Fix doh tests when not compiled in.
	- Add dohclient test executable to gitignore.
	- Fix stream_ssl, ssl_req_order and ssl_req_timeout tests for
	  alloc check debug output.
	- Easier kill of unbound-dnstap-socket tool in test.
	- Fix memory leak of edns tags at libunbound context delete.
	- Fix double loopexit for unbound-dnstap-socket after sigterm.

29 September 2020: Ralph
	- DNS Flag Day 2020: change edns-buffer-size default to 1232.

28 September 2020: Wouter
	- Fix unit test for dnstap changes, so that it waits for the timer.

23 September 2020: Wouter
	- Fix #305: dnstap logging significantly affects unbound performance
	  (regression in 1.11).
	- Fix #305: only wake up thread when threshold reached.
	- Fix to ifdef fptr wlist item for dnstap.

23 September 2020: Ralph
	- Fix edns-client-tags get_option typo
	- Add edns-client-tag-opcode option
	- Use inclusive language in configuration

21 September 2020: Ralph
	- Fix #304: dnstap logging not recovering after dnstap process restarts

21 September 2020: Wouter
	- Merge PR #311 by luismerino: Dynlibmod leak.
	- Error message is logged for dynlibmod malloc failures.
	- iana portlist updated.

18 September 2020: Wouter
	- Fix that prefer-ip4 and prefer-ip6 can be get and set with
	  unbound-control, with libunbound and the unbound-checkconf option
	  output function.
	- iana portlist updated.

15 September 2020: George
	- Introduce test for statistics.

15 September 2020: Wouter
	- Spelling fix.

11 September 2020: Wouter
	- Remove x file mode on ipset/ipset.c and h files.

9 September 2020: Wouter
	- Fix num.expired statistics output.

31 August 2020: Wouter
	- Merge PR #293: Add missing prototype.  Also refactor to use the new
	  shorthand function to clean up the code.
	- Refactor to use sock_strerr shorthand function.
	- Fix #296: systemd nss-lookup.target is reached before unbound can
	  successfully answer queries. Changed contrib/unbound.service.in.

27 August 2020: Wouter
	- Similar to NSD PR#113, implement that interface names can be used,
	  eg. something like interface: eth0 is resolved at server start and
	  uses the IP addresses for that named interface.
	- Review fix, doxygen and assign null in case of error free.

26 August 2020: George
	- Update documentation in python example code.

24 August 2020: Wouter
	- Fix that dnstap reconnects do not spam the log with the repeated
	  attempts.  Attempts on the timer are only logged on high verbosity,
	  if they produce a connection failure error.
	- Fix to apply chroot to dnstap-socket-path, if chroot is enabled.
	- Change configure to use EVP_sha256 instead of HMAC_Update for
	  openssl-3.0.0.

20 August 2020: Ralph
	- Fix stats double count issue (#289).

13 August 2020: Ralph
	- Create and init edns tags data for libunbound.

10 August 2020: Ralph
	- Merge (modified) PR #277, use EVP_MAC_CTX_set_params if available,
	  by Vítězslav Čížek.

10 August 2020: Wouter
	- Fix #287: doc typo: "Additionaly".
	- Rerun autoconf

6 August 2020: Wouter
	- Merge PR #284 and Fix #246: Remove DLV entirely from Unbound.
	  The DLV has been decommissioned and in unbound 1.5.4, in 2015, there
	  was advise to stop using it.  The current code base does not contain
	  DLV code any more.  The use of dlv options displays a warning.

5 August 2020: Wouter
	- contrib/aaaa-filter-iterator.patch file renewed diff content to
	  apply cleanly to the current coderepo for the current code version.

5 August 2020: Ralph
	- Merge PR #272: Add EDNS client tag functionality.

4 August 2020: George
	- Improve error log message when inserting rpz RR.
	- Merge PR #280, Make tvOS & watchOS checks verify truthiness as well as
	  definedness, by Felipe Gasper.

4 August 2020: Wouter
	- Fix mini_event.h on OpenBSD cannot find fd_set.

31 July 2020: Wouter
	- Fix doxygen comment for no ssl for tls session ticket key callback
	  routine.

27 July 2020: George
	- Merge PR #268, draft-ietf-dnsop-serve-stale-10 has become RFC 8767 on
	  March 2020, by and0x000.

27 July 2020: Ralph
	- Merge PR #269, Fix python module len() implementations, by Torbjörn
	  Lönnemark

27 July 2020: Wouter
	- branch now named 1.11.1.  1.11.0rc1 became the 1.11.0 release.
	- Merge PR #270 from cgzones: munin plugin: always exit 0 in autoconf

20 July 2020: Wouter
	- Fix streamtcp to print packet data to stdout.  This makes the
	  stdout and stderr not mix together lines, when parsing its output.
	- Fix contrib/fastrpz.patch to apply cleanly.  It fixes for changes
	  due to added libdynmod, but it does not compile, it conflicts with
	  new rpz code.
	- branch now named 1.11.0 and 1.11.0rc1 tag.

17 July 2020: Wouter
	- Fix libnettle compile for session ticket key callback function
	  changes.
	- Fix lock dependency cycle in rpz zone config setup.

17 July 2020: Ralph
	- Merge PR #234 - Ensure proper alignment of cmsg buffers by Jérémie
	  Courrèges-Anglas.
	- Fix PR #234 log_assert sizeof to use union buffer.

16 July 2020: Wouter
	- Fix check conf test for referencing installation paths.
	- Fix unused variable warning for clang analyzer.

16 July 2020: George
	- Introduce 'include-toplevel:' configuration option.

16 July 2020: Ralph
	- Add bidirectional frame streams support.

8 July 2020: Wouter
	- Fix add missing DSA header, for compilation without deprecated
	  OpenSSL APIs.
	- Fix to use SSL_CTX_set_tlsext_ticket_key_evp_cb in OpenSSL
	  3.0.0-alpha4.
	- Longer keys for the test set, this avoids weak crypto errors.

7 July 2020: Wouter
	- Fix #259: Fix unbound-checkconf does not check view existence.
	  unbound-checkconf checks access-control-view, access-control-tags,
	  access-control-tag-actions and access-control-tag-datas.
	- Fix offset of error printout for access-control-tag-datas.
	- Review fixes for checkconf #259 change.

6 July 2020: Wouter
	- run_vm cleanup better and removes trailing slash on single argument.

29 June 2020: Wouter
	- Move reply list clean for serve expired mesh callback to after
	  the reply is sent, so that script callbacks have reply_info.
	- Also move reply list clean for mesh callbacks to the scrip callback
	  can see the reply_info.
	- Fix for mesh accounting if the reply list already empty to begin
	  with.
	- Fix for mesh accounting when rpz decides to drop a reply with a
	  tcp stream waiting for it.
	- Review fix for number of detached states due to use of variable
	  after end of loop.
	- Fix tcp req info drop due to size call into mesh accounting
	  removal of mesh state during mesh send reply.

24 June 2020: Wouter
	- iana portlist updated.
	- doxygen file comments for dynlibmodule.

17 June 2020: Wouter
	- Fix default explanation in man page for qname-minimisation-strict.
	- Fix display of event loop method with libev.

8 June 2020: Wouter
	- Mention tls name possible when tls is enabled for stub-addr in the
	  man page.

27 May 2020: George
	- Merge PR #241 by Robert Edmonds: contrib/libunbound.pc.in: Do not use
	  "Requires:".

25 May 2020: George
	- Update contrib/aaaa-filter-iterator.patch for the recent
	  generate_sub_request() change and to apply cleanly.

21 May 2020: George
	- Fix for integer overflow when printing RDF_TYPE_TIME.

19 May 2020: Wouter
	- CVE-2020-12662 Unbound can be tricked into amplifying an incoming
	  query into a large number of queries directed to a target.
	- CVE-2020-12663 Malformed answers from upstream name servers can be
	  used to make Unbound unresponsive.
	- Release 1.10.1 is 1.10.0 with fixes, code repository continues,
	  including those fixes, towards the next release.  Configure has
	  version 1.10.2 version number in it.
	- For PR #93: windows compile warnings removal
	- windows compile warnings removal for ip dscp option code.
	- For PR #93: unit test for dynlib module.

18 May 2020: Wouter
	- For PR #93: dynlibmod can handle reloads and deinit and inits again,
	  with dlclose and dlopen of the library again.  Also for multiple
	  modules.  Fix memory leak by not closing dlopened content.  Fix
	  to allow one dynlibmod instance by unbound-checkconf.
	- For PR #93: checkconf allows multiple dynlib in module-config, for
	  a couple cases.
	- For PR #93: checkconf allows python dynlib in module-config, for
	  a couple cases.
	- For PR #93: man page spelling reference fix.
	- For PR #93: fix link of other executables for dynlibmod dependency.

15 May 2020: Wouter
	- Merge PR #93: Add dynamic library support.
	- Fixed conflicts for PR #93 and make configure, yacc, lex.
	- For PR #93: Fix warnings for dynlibmodule.

15 May 2020: Ralph
	- Cache ECS answers with longest scope of CNAME chain.

22 April 2020: George
	- Explicitly use 'rrset-roundrobin: no' for test cases.

21 April 2020: Wouter
	- Merge #225 from akhait: KSK-2010 has been revoked. It removes the
	  KSK-2010 from the default list in unbound-anchor, now that the
	  revocation period is over.  KSK-2017 is the only trust anchor in
	  the shipped default now.

21 April 2020: George
	- Change default value for 'rrset-roundrobin' to yes.
	- Fix tests for new rrset-roundrobin default.

20 April 2020: Wouter
	- Fix #222: --enable-rpath, fails to rpath python lib.
	- Fix for count of reply states in the mesh.
	- Remove unneeded was_mesh_reply check.

17 April 2020: George
	- Add SNI support on more TLS connections (fixes #193).
	- Add SNI support to unbound-anchor.

16 April 2020: George
	- Add doxygen documentation for DSCP.

16 April 2020: Wouter
	- Fix help return code in unbound-control-setup script.
	- Fix for posix shell syntax for trap in nsd-control-setup.
	- Fix for posix shell syntax for trap in run_msg.sh test script.

15 April 2020: George
	- Fix #220: auth-zone section in config may lead to segfault.

7 April 2020: Wouter
	- Merge PR #214 from gearnode: unbound-control-setup recreate
	  certificates.  With the -r option the certificates are created
	  again, without it, only the files that do not exist are created.

6 April 2020: Ralph
	- Keep track of number of timeouts. Use this counter to determine if
	  capsforid fallback should be started.

6 April 2020: George
	- More documentation for redis-expire-records option.

1 April 2020: George
	- Merge PR #206: Redis TTL, by Talkabout.

30 March 2020: Wouter
	- Merge PR #207: Clarify if-automatic listens on 0.0.0.0 and ::
	- Merge PR #208: Fix uncached CLIENT_RESPONSE'es on stateful
	  transports.

27 March 2020: Wouter
	- Merge PR #203 from noloader: Update README-Travis.md with current
	  procedures.

27 March 2020: Ralph
	- Make unbound-control error returned on missing domain name more user
	  friendly.

26 March 2020: Ralph
	- Fix RPZ concurrency issue when using auth_zone_reload.

25 March 2020: George
	- Merge PR #201 from noloader: Fix OpenSSL cross-compaile warnings.
	- Fix on #201.

24 March 2020: Wouter
	- Merge PR #200 from yarikk: add ip-dscp option to specify the DSCP
	  tag for outgoing packets.
	- Fixes on #200.
	- Travis fix for ios by omitting tools from install.

23 March 2020: Wouter
	- Fix compile on Solaris for unbound-checkconf.

20 March 2020: George
	- Merge PR #198 from fobser: Declare lz_enter_rr_into_zone() static, it's
	  only used in this file.

20 March 2020: Wouter
	- Merge PR #197 from fobser: Make log_ident_revert_to_default() a
	  proper prototype.

19 March 2020: Ralph
	- Merge PR#191: Update iOS testing on Travis, by Jeffrey Walton.
	- Fix #158: open tls-session-ticket-keys as binary, for Windows. By
	  Daisuke HIGASHI.
	- Merge PR#134, Allow the kernel to provide random source ports. By
	  Florian Obser.
	- Log warning when using outgoing-port-permit and outgoing-port-avoid
	  while explicit port randomisation is disabled.
	- Merge PR#194: Add libevent testing to Travis, by Jeffrey Walton.
	- Fix .travis.yml error, missing 'env' option.

16 March 2020: Wouter
	- Fix #192: In the unbound-checkconf tool, the module config of
	  dns64 subnetcache respip validator iterator is whitelisted, it was
	  reported it seems to work.

12 March 2020: Wouter
	- Fix compile of test tools without protobuf.

11 March 2020: Ralph
	- Add check to make sure RPZ records are subdomains of configured
	  zone origin.

11 March 2020: George
	- Fix #189: mini_event.h:142:17: error: field 'ev_timeout' has incomplete
	  type, by noloader.
	- Changelog entry for (Fix #189, Merge PR #190).

11 March 2020: Wouter
	- Fix #188: unbound-control.c:882:6: error: 'execlp' is
	  unavailable: not available on tvOS.

6 March 2020: George
	- Merge PR #186, fix #183: Fix unrecognized 'echo -n' option on OS X, by
	  noloader

5 March 2020: Wouter
	- Fix PR #182 from noloader: Add iOS testing to Travis.

4 March 2020: Ralph
	- Update README-Travis.md (from PR #179), by Jeffrey Walton.

4 March 2020: George
	- Merge PR #181 from noloader: Fix OpenSSL -pie warning on Android.

4 March 2020: Wouter
	- Merge PR #180 from noloader: Avoid calling exit in Travis script.

3 March 2020: George
	- Upgrade config.guess(2020-01-01) and config.sub(2020-01-01).

2 March 2020: Ralph
	- Fix #175, Merge PR #176: fix link error when OpenSSL is configured
 	  with no-engine, thanks noloader.

2 March 2020: George
	- Fix compiler warning in dns64/dns64.c
	- Merge PR #174: Add Android to Travis testing, by noloader.
	- Move android build scripts to contrib/ and allow android tests to fail.

2 March 2020: Wouter
	- Fix #177: dnstap does not build on macOS.

28 February 2020: Ralph
	- Merge PR #172: Add IBM s390x arch for testing, by noloader.

28 February 2020: Wouter
	- Merge PR #173: updated makedist.sh for config.guess and
	  config.sub and sha256 digest for gpg, by noloader.
	- Merge PR #164: Framestreams, this branch implements dnstap
	  unidirectional connectivity in unbound. This has a number of
	  new features.

	  The dependency on libfstrm is removed. The fstrm protocol code
	  resides in dnstap/dnstap_fstrm.h and dnstap/dnstap_fstrm.c. This
	  contains a brief definition of what unbound needs.

	  The make unbound-dnstap-socket builds a debug tool,
	  unbound-dnstap-socket. It can listen, accept multiple DNSTAP
	  streams and print information. Commandline options control it.

	  Unbound can reconnect if the unix domain socket file socket is
	  closed. This uses exponential backoff after which it uses a
	  one second timer to throttle cpu down. There is also support
	  to use TCP and TLS for connecting to the log server. There
	  are new config options to turn them on, in the dnstap section
	  in the man page and example config file. dnstap-ip with IP
	  address of server for TCP or TLS use. dnstap-tls to turn
	  on TLS. And dnstap-tls-server-name, dnstap-tls-cert-bundle,
	  dnstap-tls-client-key-file and dnstap-tls-client-cert-file
	  to configure the certificates for server authentication and
	  client authentication, or leave at "" to not use that.

27 February 2020: George
	- Merge PR #171: Add additional compilers and platforms to Travis
	  testing, by noloader.

27 February 2020: Wouter
	- Fix #169: Fix warning for daemon/remote.c output may be truncated
	  from snprintf.
	- Fix #170: Fix gcc undefined sanitizer signed integer overflow
	  warning in signature expiry RFC1982 serial number arithmetic.
	- Fix more undefined sanitizer issues, in respip copy_rrset null
	  dname, and in the client_info_compare routine for null memcmp.

26 February 2020: Wouter
	- iana portlist updated.

25 February 2020: Wouter
	- Fix #165: Add prefer-ip4: yesno config option to prefer ipv4 for
	  using ipv4 filters, because the hosts ip6 netblock /64 is not owned
	  by one operator, and thus reputation is shared.

24 February 2020: George
	- Merge PR #166: Fix typo in unbound.service.in, by glitsj16.

20 February 2020: Wouter
	- Updated contrib/unbound_smf23.tar.gz with Solaris SMF service for
	  Unbound from Yuri Voinov.
	- master branch has 1.10.1 version.

18 February 2020: Wouter
	- protect X509_CHECK_FLAG_NO_PARTIAL_WILDCARDS with ifdef for
	  different openssl versions.

17 February 2020: Wouter
	- changelog point where the tag for 1.10.0rc2 release is.  And with
	  the unbound_smf23 commit added to it, that is the 1.10.0 release.

17 February 2020: Ralph
	- Add respip to supported module-config options in unbound-checkconf.

17 February 2020: George
	- Remove unused variable.

17 February 2020: Wouter
	- contrib/drop2rpz: perl script that converts the Spamhaus DROP-List
	  in RPZ-Format, contributed by Andreas Schulze.

14 February 2020: Wouter
	- Fix spelling in unbound.conf.5.in.
	- Stop unbound-checkconf from insisting that auth-zone and rpz
	  zonefiles have to exist.  They can not exist, and download later.

13 February 2020: Wouter
	- tag for 1.10.0rc1 release.

12 February 2020: Wouter
	- Fix with libnettle make test with dsa disabled.
	- Fix contrib/fastrpz.patch to apply cleanly.  Fix for serve-stale
	  fixes, but it does not compile, conflicts with new rpz code.
	- Fix to clean memory leak of respip_addr.lock when ip_tree deleted.
	- Fix compile warning when threads disabled.
	- updated version number to 1.10.0.

10 February 2020: George
	- Document 'ub_result.was_ratelimited' in libunbound.
	- Fix use after free on log-identity after a reload; Fixes #163.

6 February 2020: George
	- Fix num_reply_states and num_detached_states counting with
	  serve_expired_callback.
	- Cleaner code in mesh_serve_expired_lookup.
	- Document in unbound.conf manpage that configuration clauses can be
	  repeated in the configuration file.

6 February 2020: Wouter
	- Fix num_reply_addr counting in mesh and tcp drop due to size
	  after serve_stale commit.
	- Fix to create and destroy rpz_lock in auth_zones structure.
	- Fix to lock zone before adding rpz qname trigger.
	- Fix to lock and release once in mesh_serve_expired_lookup.
	- Fix to put braces around empty if body when threading is disabled.

5 February 2020: George
	- Added serve-stale functionality as described in
	  draft-ietf-dnsop-serve-stale-10. `serve-expired-*` options can be used
	  to configure the behavior.
	- Updated cachedb to honor `serve-expired-ttl`; Fixes #107.
	- Renamed statistic `num.zero_ttl` to `num.expired` as expired replies
	  come with a configurable TTL value (`serve-expired-reply-ttl`).
	- Fixed stats when replying with cached, cname-aliased records.
	- Added missing default values for redis cachedb backend.

3 February 2020: Ralph
	- Add assertion to please static analyzer

31 January 2020: Wouter
	- Fix fclose on error in TLS session ticket code.

30 January 2020: Ralph
	- Fix memory leak in error condition remote.c
	- Fix double free in error condition view.c
	- Fix memory leak in do_auth_zone_transfer on success
	- Merge RPZ support into master. Only QNAME and Response IP triggers are
	  supported.
	- Stop working on socket when socket() call returns an error.
	- Check malloc return values in TLS session ticket code

30 January 2020: Wouter
	- Fix subnet tests for disabled DSA algorithm by default.
	- Update contrib/fastrpz.patch for clean diff with current code.
	- Merge PR#151: Fixes for systemd units, by Maryse47, Edmonds
	  and Frzk.  Updates the unbound.service systemd file and adds
	  a portable systemd service file.
	- updated .gitignore for added contrib file.
	- Add build rule for ipset to Makefile
	- Add getentropy_freebsd.o to Makefile dependencies.

29 January 2020: Ralph
	- Merge PR#156 from Alexander Berkes; Added unbound-control
	  view_local_datas_remove command.

29 January 2020: Wouter
	- Fix #157: undefined reference to `htobe64'.

28 January 2020: Ralph
	- Merge PR#147; change rfc reference for reserved top level dns names.

28 January 2020: Wouter
	- iana portlist updated.
	- Fix to silence the tls handshake errors for broken pipe and reset
	  by peer, unless verbosity is set to 2 or higher.

27 January 2020: Ralph
	- Merge PR#154; Allow use of libbsd functions with configure option
	  --with-libbsd. By Robert Edmonds and Steven Chamberlain.
	- Merge PR#148; Add some TLS stats to unbound_munin_. By Fredrik Pettai.

27 January 2020: Wouter
	- Merge PR#155 from Robert Edmonds: contrib/libunbound.pc.in: Fixes
	  to Libs/Requires for crypto library dependencies.
	- Fix #153: Disable validation for DSA algorithms.  RFC 8624
	  compliance.

23 January 2020: Wouter
	- Merge PR#150 from Frzk: Systemd unit without chroot.  It add
	  contrib/unbound_nochroot.service.in, a systemd file for use with
	  chroot: "", see comments in the file, it uses systemd protections
	  instead.

14 January 2020: Wouter
	- Removed the dnscrypt_queries and dnscrypt_queries_chacha tests,
	  because dnscrypt-proxy (2.0.36) does not support the test setup
	  any more, and also the config file format does not seem to have
	  the appropriate keys to recreate that setup.
	- Fix crash after reload where a stats lookup could reference old key
	  cache and neg cache structures.
	- Fix for memory leak when edns subnet config options are read when
	  compiled without edns subnet support.
	- Fix auth zone support for NSEC3 records without salt.

10 January 2020: Wouter
	- Fix the relationship between serve-expired and prefetch options,
	  patch from Saksham Manchanda from Secure64.
	- Fix unreachable code in ssl set options code.

8 January 2020: Ralph
	- Fix #138: stop binding pidfile inside chroot dir in systemd service
	  file.

8 January 2020: Wouter
	- Fix 'make test' to work for --disable-sha1 configure option.
	- Fix out-of-bounds null-byte write in sldns_bget_token_par while
	  parsing type WKS, reported by Luis Merino from X41 D-Sec.
	- Updated sldns_bget_token_par fix for also space for the zero
	  delimiter after the character.  And update for more spare space.

6 January 2020: George
	- Downgrade compat/getentropy_solaris.c to version 1.4 from OpenBSD.
	  The dl_iterate_phdr() function introduced in newer versions raises
	  compilation errors on solaris 10.
	- Changes to compat/getentropy_solaris.c for,
	  ifdef stdint.h inclusion for older systems.
	  ifdef sha2.h inclusion for older systems.

6 January 2020: Wouter
	- Merge #135 from Florian Obser: Use passed in neg and key cache
	  if non-NULL.
	- Fix #140: Document slave not downloading new zonefile upon update.

16 December 2019: George
	- Update mailing list URL.

12 December 2019: Ralph
	- Master is 1.9.7 in development.
	- Fix typo to let serve-expired-ttl work with ub_ctx_set_option(), by
	  Florian Obser

10 December 2019: Wouter
	- Fix to make auth zone IXFR to fallback to AXFR if a single
	  response RR is received over TCP with the SOA in it.

6 December 2019: Wouter
	- Fix ipsecmod compile.
	- Fix Makefile.in for ipset module compile, from Adi Prasaja.
	- release-1.9.6 tag, which became the 1.9.6 release

5 December 2019: Wouter
	- unbound-fuzzers.tar.bz2: three programs for fuzzing, that are 1:1
	  replacements for unbound-fuzzme.c that gets created after applying
	  the contrib/unbound-fuzzme.patch.  They are contributed by
	  Eric Sesterhenn from X41 D-Sec.
	- tag for 1.9.6rc1.

4 December 2019: Wouter
	- Fix lock type for memory purify log lock deletion.
	- Fix testbound for alloccheck runs, memory purify and lock checks.
	- update contrib/fastrpz.patch to apply more cleanly.
	- Fix Make Test Fails when Configured With --enable-alloc-nonregional,
	  reported by X41 D-Sec.

3 December 2019: Wouter
	- Merge pull request #124 from rmetrich: Changed log lock
	  from 'quick' to 'basic' because this is an I/O lock.
	- Fix text around serial arithmetic used for RRSIG times to refer
	  to correct RFC number.
	- Fix Assert Causing DoS in synth_cname(),
	  reported by X41 D-Sec.
	- Fix similar code in auth_zone synth cname to add the extra checks.
	- Fix Assert Causing DoS in dname_pkt_copy(),
	  reported by X41 D-Sec.
	- Fix OOB Read in sldns_wire2str_dname_scan(),
	  reported by X41 D-Sec.
	- Fix Out of Bounds Write in sldns_str2wire_str_buf(),
	  reported by X41 D-Sec.
	- Fix Out of Bounds Write in sldns_b64_pton(),
	  fixed by check in sldns_str2wire_int16_data_buf(),
	  reported by X41 D-Sec.
	- Fix Insufficient Handling of Compressed Names in dname_pkt_copy(),
	  reported by X41 D-Sec.
	- Fix Out of Bound Write Compressed Names in rdata_copy(),
	  reported by X41 D-Sec.
	- Fix Hang in sldns_wire2str_pkt_scan(),
	  reported by X41 D-Sec.
	  This further lowers the max to 256.
	- Fix snprintf() supports the n-specifier,
	  reported by X41 D-Sec.
	- Fix Bad Indentation, in dnscrypt.c,
	  reported by X41 D-Sec.
	- Fix Client NONCE Generation used for Server NONCE,
	  reported by X41 D-Sec.
	- Fix compile error in dnscrypt.
	- Fix _vfixed not Used, removed from sbuffer code,
	  reported by X41 D-Sec.
	- Fix Hardcoded Constant, reported by X41 D-Sec.
	- make depend

2 December 2019: Wouter
	- Merge pull request #122 from he32: In tcp_callback_writer(),
	  don't disable time-out when changing to read.

22 November 2019: George
	- Fix compiler warnings.

22 November 2019: Wouter
	- Fix dname loop maximum, reported by Eric Sesterhenn from X41 D-Sec.
	- Add make distclean that removes everything configure produced,
	  and make maintainer-clean that removes bison and flex output.

20 November 2019: Wouter
	- Fix Out of Bounds Read in rrinternal_get_owner(),
	  reported by X41 D-Sec.
	- Fix Race Condition in autr_tp_create(),
	  reported by X41 D-Sec.
	- Fix Shared Memory World Writeable,
	  reported by X41 D-Sec.
	- Adjust unbound-control to make stats_shm a read only operation.
	- Fix Weak Entropy Used For Nettle,
	  reported by X41 D-Sec.
	- Fix Randomness Error not Handled Properly,
	  reported by X41 D-Sec.
	- Fix Out-of-Bounds Read in dname_valid(),
	  reported by X41 D-Sec.
	- Fix Config Injection in create_unbound_ad_servers.sh,
	  reported by X41 D-Sec.
	- Fix Local Memory Leak in cachedb_init(),
	  reported by X41 D-Sec.
	- Fix Integer Underflow in Regional Allocator,
	  reported by X41 D-Sec.
	- Upgrade compat/getentropy_linux.c to version 1.46 from OpenBSD.
	- Synchronize compat/getentropy_win.c with version 1.5 from
	  OpenBSD, no changes but makes the file, comments, identical.
	- Upgrade compat/getentropy_solaris.c to version 1.13 from OpenBSD.
	- Upgrade compat/getentropy_osx.c to version 1.12 from OpenBSD.
	- Changes to compat/getentropy files for,
	  no link to openssl if using nettle, and hence config.h for
	  HAVE_NETTLE variable.
	  compat definition of MAP_ANON, for older systems.
	  ifdef stdint.h inclusion for older systems.
	  ifdef sha2.h inclusion for older systems.
	- Fixed Compat Code Diverging from Upstream, reported by X41 D-Sec.
	- Fix compile with --enable-alloc-checks, reported by X41 D-Sec.
	- Fix Terminating Quotes not Written, reported by X41 D-Sec.
	- Fix Useless memset() in validator, reported by X41 D-Sec.
	- Fix Unrequired Checks, reported by X41 D-Sec.
	- Fix Enum Name not Used, reported by X41 D-Sec.
	- Fix NULL Pointer Dereference via Control Port,
	  reported by X41 D-Sec.
	- Fix Bad Randomness in Seed, reported by X41 D-Sec.
	- Fix python examples/calc.py for eval, reported by X41 D-Sec.
	- Fix comments for doxygen in dns64.

19 November 2019: Wouter
	- Fix CVE-2019-18934, shell execution in ipsecmod.
	- 1.9.5 is 1.9.4 with bugfix, trunk is 1.9.6 in development.
	- Fix authzone printout buffer length check.
	- Fixes to please lint checks.
	- Fix Integer Overflow in Regional Allocator,
	  reported by X41 D-Sec.
	- Fix Unchecked NULL Pointer in dns64_inform_super()
	  and ipsecmod_new(), reported by X41 D-Sec.
	- Fix Out-of-bounds Read in rr_comment_dnskey(),
	  reported by X41 D-Sec.
	- Fix Integer Overflows in Size Calculations,
	  reported by X41 D-Sec.
	- Fix Integer Overflow to Buffer Overflow in
	  sldns_str2wire_dname_buf_origin(), reported by X41 D-Sec.
	- Fix Out of Bounds Read in sldns_str2wire_dname(),
	  reported by X41 D-Sec.
	- Fix Out of Bounds Write in sldns_bget_token_par(),
	  reported by X41 D-Sec.

18 November 2019: Wouter
	- In unbound-host use separate variable for get_option to please
	  code checkers.
	- update to bison output of 3.4.1 in code repository.
	- Provide a prototype for compat malloc to remove compile warning.
	- Portable grep usage for reuseport configure test.
	- Check return type of HMAC_Init_ex for openssl 0.9.8.
	- gitignore .source tempfile used for compatible make.

13 November 2019: Wouter
	- iana portlist updated.
	- contrib/fastrpz.patch updated to apply for current code.
	- fixes for splint cleanliness, long vs int in SSL set_mode.

11 November 2019: Wouter
	- Fix #109: check number of arguments for stdin-pipes in
	  unbound-control and fail if too many arguments.
	- Merge #102 from jrtc27: Add getentropy emulation for FreeBSD.

24 October 2019: Wouter
	- Fix #99: Memory leak in ub_ctx (event_base will never be freed).

23 October 2019: George
	- Add new configure option `--enable-fully-static` to enable full static
	  build if requested; in relation to #91.

23 October 2019: Wouter
	- Merge #97: manpage: Add missing word on unbound.conf,
	  from Erethon.

22 October 2019: Wouter
	- drop-tld.diff: adds option drop-tld: yesno that drops 2 label
	  queries, to stop random floods.  Apply with
	  patch -p1 < contrib/drop-tld.diff and compile.
	  From Saksham Manchanda (Secure64).  Please note that we think this
	  will drop DNSKEY and DS lookups for tlds and hence break DNSSEC
	  lookups for downstream clients.

7 October 2019: Wouter
	- Add doxygen comments to unbound-anchor source address code, in #86.

3 October 2019: Wouter
	- Merge #90 from vcunat: fix build with nettle-3.5.
	- Merge 1.9.4 release with fix for vulnerability CVE-2019-16866.
	- Continue with development of 1.9.5.
	- Merge #86 from psquarejho: Added -b source address option to
	  smallapp/unbound-anchor.c, from Lukas Wunner.

26 September 2019: Wouter
	- Merge #87 from hardfalcon: Fix contrib/unbound.service.in,
	  Drop CAP_KILL, use + prefix for ExecReload= instead.

25 September 2019: Wouter
	- The unbound.conf includes are sorted ascending, for include
	  statements with a '*' from glob.

23 September 2019: Wouter
	- Merge #85 for #84 from sam-lunt: Add kill capability to systemd
	  service file to fix that systemctl reload fails.

20 September 2019: Wouter
	- Merge #82 from hardfalcon: Downgrade CAP_NET_ADMIN to CAP_NET_RAW
	  in unbound.service.
	- Merge #81 from Maryse47: Consistently use /dev/urandom instead
	  of /dev/random in scripts and docs.
	- Merge #83 from Maryse47: contrib/unbound.service.in: do not fork
	  into the background.

19 September 2019: Wouter
	- Fix #78: Memory leak in outside_network.c.
	- Merge pull request #76 from Maryse47: Improvements and fixes for
	  systemd unbound.service.
	- oss-fuzz badge on README.md.
	- Fix fix for #78 to also free service callback struct.
	- Fix for oss-fuzz build warning.
	- Fix wrong response ttl for prepended short CNAME ttls, this would
	  create a wrong zero_ttl response count with serve-expired enabled.
	- Merge #80 from stasic: Improve wording in man page.

11 September 2019: Wouter
	- Use explicit bzero for wiping clear buffer of hash in cachedb,
	  reported by Eric Sesterhenn from X41 D-Sec.

9 September 2019: Wouter
	- Fix #72: configure --with-syslog-facility=LOCAL0-7 with default
	  LOG_DAEMON (as before) can set the syslog facility that the server
	  uses to log messages.

4 September 2019: Wouter
	- Fix #71: fix openssl error squelch commit compilation error.

3 September 2019: Wouter
	- squelch DNS over TLS errors 'ssl handshake failed crypto error'
	  on low verbosity, they show on verbosity 3 (query details), because
	  there is a high volume and the operator cannot do anything for the
	  remote failure.  Specifically filters the high volume errors.

2 September 2019: Wouter
	- ipset module #28: log that an address is added, when verbosity high.
	- ipset: refactor long routine into three smaller ones.
	- updated Makefile dependencies.

23 August 2019: Wouter
	- Fix contrib/fastrpz.patch asprintf return value checks.

22 August 2019: Wouter
	- Fix that pkg-config is setup before --enable-systemd needs it.
	- 1.9.3rc2 release candidate tag.  And this became the 1.9.3 release.
	  Master is 1.9.4 in development.

21 August 2019: Wouter
	- Fix log_dns_msg to log irrespective of minimal responses config.

19 August 2019: Ralph
	- Document limitation of pidfile removal outside of chroot directory.

16 August 2019: Wouter
	- Fix unittest valgrind false positive uninitialised value report,
	  where if gcc 9.1.1 uses -O2 (but not -O1) then valgrind 3.15.0
	  issues an uninitialised value for the token buffer at the str2wire.c
	  rrinternal_get_owner() strcmp with the '@' value.  Rewritten to use
	  straight character comparisons removes the false positive.  Also
	  valgrinds --expensive-definedness-checks=yes can stop this false
	  positive.
	- Please doxygen's parser for "@" occurrence in doxygen comment.
	- Fixup contrib/fastrpz.patch
	- Remove warning about unknown cast-function-type warning pragma.

15 August 2019: Wouter
	- iana portlist updated.
	- Fix autotrust temp file uniqueness windows compile.
	- avoid warning about upcast on 32bit systems for autotrust.
	- escape commandline contents for -V.
	- Fix character buffer size in ub_ctx_hosts.
	- 1.9.3rc1 release candidate tag.
	- Option -V prints if TCP fastopen is available.

14 August 2019: George
	- Fix #59, when compiled with systemd support check that we can properly
	  communicate with systemd through the `NOTIFY_SOCKET`.

14 August 2019: Wouter
	- Generate configlexer with newer flex.
	- Fix warning for unused variable for compilation without systemd.

12 August 2019: George
	- Introduce `-V` option to print the version number and build options.
	  Previously reported build options like linked libs and linked modules
	  are now moved from `-h` to `-V` as well for consistency.
	- PACKAGE_BUGREPORT now also includes link to GitHub issues.

1 August 2019: Wouter
	- For #52 #53, second context does not close logfile override.
	- Fix #52 #53, fix for example fail program.
	- Fix to return after failed auth zone http chunk write.
	- Fix to remove unused test for task_probe existence.
	- Fix to timeval_add for remaining second in microseconds.
	- Check repinfo in worker_handle_request, if null, drop it.

29 July 2019: Wouter
	- Add verbose log message when auth zone file is written, at level 4.
	- Add hex print of trust anchor pointer to trust anchor file temp
	  name to make it unique, for libunbound created multiple contexts.

23 July 2019: Wouter
	- Fix question section mismatch in local zone redirect.

19 July 2019: Wouter
	- Fix #49: Set no renegotiation on the SSL context to stop client
	  session renegotiation.

12 July 2019: Wouter
	- Fix #48: Unbound returns additional records on NODATA response,
	  if minimal-responses is enabled, also the additional for negative
	  responses is removed.

9 July 2019: Ralph
	- Fix in respip addrtree selection. Absence of addr_tree_init_parents()
	  call made it impossible to go up the tree when the matching netmask is
	  too specific.

5 July 2019: Ralph
	- Fix for possible assertion failure when answering respip CNAME from
	  cache.

25 June 2019: Wouter
	- For #45, check that 127.0.0.1 and ::1 are not used in unbound.conf
	  when do-not-query-localhost is turned on, or at default on,
	  unbound-checkconf prints a warning if it is found in forward-addr or
	  stub-addr statements.

24 June 2019: Wouter
	- Fix memleak in unit test, reported from the clang 8.0 static analyzer.

18 June 2019: Wouter
	- PR #28: IPSet module, by Kevin Chou.  Created a module to support
	  the ipset that could add the domain's ip to a list easily.
	  Needs libmnl, and --enable-ipset and config it, doc/README.ipset.md.
	- Fix to omit RRSIGs from addition to the ipset.
	- Fix to make unbound-control with ipset, remove unused variable,
	  use unsigned type because of comparison, and assign null instead
	  of compare with it.  Remade lex and yacc output.
	- make depend
	- Added documentation to the ipset files (for doxygen output).
	- Merge PR #6: Python module: support multiple instances
	- Merge PR #5: Python module: define constant MODULE_RESTART_NEXT
	- Merge PR #4: Python module: assign something useful to the
	  per-query data store 'qdata'
	- Fix python dict reference and double free in config.

17 June 2019: Wouter
	- Master contains version 1.9.3 in development.
	- Fix #39: In libunbound, leftover logfile is close()d unpredictably.
	- Fix for #24: Fix abort due to scan of auth zone masters using old
	  address from previous scan.

12 June 2019: Wouter
	- Fix another spoolbuf storage code point, in prefetch.
	- 1.9.2rc3 release candidate tag.  Which became the 1.9.2 release
	  on 17 June 2019.

11 June 2019: Wouter
	- Fix that fixes the Fix that spoolbuf is not used to store tcp
	  pipelined response between mesh send and callback end, this fixes
	  error cases that did not use the correct spoolbuf.
	- 1.9.2rc2 release candidate tag.

6 June 2019: Wouter
	- 1.9.2rc1 release candidate tag.

4 June 2019: Wouter
	- iana portlist updated.

29 May 2019: Wouter
	- Fix to guard _OPENBSD_SOURCE from redefinition.

28 May 2019: Wouter
	- Fix to define _OPENBSD_SOURCE to get reallocarray on NetBSD.
	- gitignore config.h.in~.

27 May 2019: Wouter
	- Fix double file close in tcp pipelined response code.

24 May 2019: Wouter
	- Fix that spoolbuf is not used to store tcp pipelined response
	  between mesh send and callback end.

20 May 2019: Wouter
	- Note that so-reuseport at extreme load is better turned off,
	  otherwise queries are not distributed evenly, on Linux 4.4.x.

16 May 2019: Wouter
	- Fix #31: swig 4.0 and python module.

13 May 2019: Wouter
	- Squelch log messages from tcp send about connection reset by peer.
	  They can be enabled with verbosity at higher values for diagnosing
	  network connectivity issues.
	- Attempt to fix malformed tcp response.

9 May 2019: Wouter
	- Revert fix for oss-fuzz, error is in that build script that
	  unconditionally includes .o files detected by configure, also
	  when the machine architecture uses different LIBOBJS files.

8 May 2019: Wouter
	- Attempt to fix build failure in oss-fuzz because of reallocarray.
	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=14648.
	  Does not omit compile flags from commandline.

7 May 2019: Wouter
	- Fix edns-subnet locks, in error cases the lock was not unlocked.
	- Fix doxygen output error on readme markdown vignettes.

6 May 2019: Wouter
	- Fix #29: Solaris 11.3 and missing symbols be64toh, htobe64.
	- Fix #30: AddressSanitizer finding in lookup3.c.  This sets the
	  hash function to use a slower but better auditable code that does
	  not read beyond array boundaries.  This makes code better security
	  checkable, and is better for security.  It is fixed to be slower,
	  but not read outside of the array.

2 May 2019: Wouter
	- contrib/fastrpz.patch updated for code changes, and with git diff.
	- Fix .gitignore, add pythonmod and dnstap generated files.
	  And unit test generated files, and generated doc files.

1 May 2019: Wouter
	- Update makedist for git.
	- Nicer travis output for clang analysis.
	- PR #16: XoT support, AXFR over TLS, turn it on with
	  master: <ip>#<authname> in unbound.conf.  This uses TLS to
	  download the AXFR (or IXFR).

25 April 2019: Wouter
	- Fix wrong query name in local zone redirect answers with a CNAME,
	  the copy of the local alias is in unpacked form.

18 April 2019: Ralph
	- Scrub RRs from answer section when reusing NXDOMAIN message for
	  subdomain answers.
	- For harden-below-nxdomain: do not consider a name to be non-exitent
	  when message contains a CNAME record.

18 April 2019: Wouter
	- travis build file.

16 April 2019: Wouter
	- Better braces in if statement in TCP fastopen code.
	- iana portlist updated.

15 April 2019: Wouter
	- Fix tls write event for read state change to re-call SSL_write and
	  not resume the TLS handshake.

11 April 2019: George
	- Update python documentation for init_standard().
	- Typos.

11 April 2019: Wouter
	- Fix that auth zone uses correct network type for sockets for
	  SOA serial probes.  This fixes that probes fail because earlier
	  probe addresses are unreachable.
	- Fix that auth zone fails over to next master for timeout in tcp.
	- Squelch SSL read and write connection reset by peer and broken pipe 
	  messages.  Verbosity 2 and higher enables them.

8 April 2019: Wouter
	- Fix to use event_assign with libevent for thread-safety.
	- verbose information about auth zone lookup process, also lookup
	  start, timeout and fail.
	- Fix #17: Add python module example from Jan Janak, that is a
	  plugin for the Unbound DNS resolver to resolve DNS records in
	  multicast DNS [RFC 6762] via Avahi.  The plugin communicates
	  with Avahi via DBus. The comment section at the beginning of
	  the file contains detailed documentation.
	- Fix to wipe ssl ticket keys from memory with explicit_bzero,
	  if available.

5 April 2019: Wouter
	- Fix to reinit event structure for accepted TCP (and TLS) sockets.

4 April 2019: Wouter
	- Fix spelling error in log output for event method.

3 April 2019: Wouter
	- Move goto label in answer_from_cache to the end of the function
	  where it is more visible.
	- Fix auth-zone NSEC3 response for wildcard nodata answers,
	  include the closest encloser in the answer.

2 April 2019: Wouter
	- Fix auth-zone NSEC3 response for empty nonterminals with exact
	  match nsec3 records.
	- Fix for out of bounds integers, thanks to OSTIF audit.  It is in
	  allocation debug code.
	- Fix for auth zone nsec3 ent fix for wildcard nodata.

25 March 2019: Wouter
	- Fix that tls-session-ticket-keys: "" on its own in unbound.conf
	  disables the tls session ticker key calls into the OpenSSL API.
	- Fix crash if tls-servic-pem not filled in when necessary.

21 March 2019: Wouter
	- Fix #4240: Fix whitespace cleanup in example.conf.

19 March 2019: Wouter
	- add type CAA to libpyunbound (accessing libunbound from python).

18 March 2019: Wouter
	- Add log message, at verbosity 4, that says the query is encrypted
	  with TLS, if that is enabled for the query.
	- Fix #4239: set NOTIMPL when deny-any is enabled, for RFC8482.

7 March 2019: Wouter
	- Fix for #4233: guard use of NDEBUG, so that it can be passed in
	  CFLAGS into configure.

5 March 2019: Wouter
	- Tag release 1.9.1rc1.  Which became 1.9.1 on 12 March 2019.  Trunk
	  has 1.9.2 in development.

1 March 2019: Wouter
	- output forwarder log in ssl_req_order test.

28 February 2019: Wouter
	- Remove memory leak on pythonmod python2 script file init.
	- Remove swig gcc8 python function cast warnings, they are ignored.
	- Print correct module that failed when module-config is wrong.

27 February 2019: Wouter
	- Fix #4229: Unbound man pages lack information, about access-control
	  order and local zone tags, and elements in views.
	- Fix #14: contrib/unbound.init: Fix wrong comparison judgment
	  before copying.
	- Fix for python module on Windows, fix fopen.

25 February 2019: Wouter
	- Fix #4227: pair event del and add for libevent for tcp_req_info.

21 February 2019: Wouter
	- Fix the error for unknown module in module-config is understandable,
	  and explains it was not compiled in and where to see the list.
	- In example.conf explain where to put cachedb module in module-config.
	- In man page and example config explain that most modules have to
	  be listed at the start of module-config.

20 February 2019: Wouter
	- Fix pythonmod include and sockaddr_un ifdefs for compile on
	  Windows, and for libunbound.

18 February 2019: Wouter
	- Print query name with ip_ratelimit exceeded log lines.
	- Spaces instead of tabs in that log message.
	- Print query name and IP address when domain rate limit exceeded.

14 February 2019: Wouter
	- Fix capsforid canonical sort qsort callback.

11 February 2019: Wouter
	- Note default for module-config in man page.
	- Fix recursion lame test for qname minimisation asked queries,
	  that were not present in the set of prepared answers.
	- Fix #13: Remove left-over requirements on OpenSSL >= 1.1.0 for
	  cert name matching, from man page.
	- make depend, with newer gcc, nicer layout.

7 February 2019: Wouter
	- Fix #4206: OpenSSL 1.0.2 hostname verification for FreeBSD 11.2.
	- Fix that qname minimisation does not skip a label when missing
	  nameserver targets need to be fetched.
	- Fix #4225: clients seem to erroneously receive no answer with
	  DNS-over-TLS and qname-minimisation.

4 February 2019: Wouter
	- Fix that log-replies prints the correct name for local-alias
	  names, for names that have a CNAME in local-data configuration.
	  It logs the original query name, not the target of the CNAME.
	- Add local-zone type inform_redirect, which logs like type inform,
	  and redirects like type redirect.
	- Perform canonical sort for 0x20 capsforid compare of replies,
	  this sorts rrsets in the authority and additional section before
	  comparison, so that out of order rrsets do not cause failure.

31 January 2019: Wouter
	- Set ub_ctx_set_tls call signature in ltrace config file for
	  libunbound in contrib/libunbound.so.conf.
	- improve documentation for tls-service-key and forward-first.
	- #10: fixed pkg-config operations, PKG_PROG_PKG_CONFIG moved out of
	  conditional section, fixes systemd builds, from Enrico Scholz.
	- #9: For openssl 1.0.2 use the CRYPTO_THREADID locking callbacks,
	  still supports the set_id_callback previous API.  And for 1.1.0
	  no locking callbacks are needed.
	- #8: Fix OpenSSL without ENGINE support compilation.
	- Wipe TLS session key data from memory on exit.

30 January 2019: Ralph
	- Fix case in which query timeout can result in marking delegation
	  as edns_lame_known.

29 January 2019: Wouter
	- Fix spelling of tls-ciphers in example.conf.in.
	- Fix #4224: auth_xfr_notify.rpl test broken due to typo
	- Fix locking for libunbound context setup with broken port config.

28 January 2019: Wouter
	- ub_ctx_set_tls call for libunbound that enables DoT for the machines
	  set with ub_ctx_set_fwd.  Patch from Florian Obser.
	- Set build system for added call in the libunbound API.
	- List example config for root zone copy locally hosted with auth-zone
	  as suggested from draft-ietf-dnsop-7706-bis-02.  But with updated
	  B root address.
	- set version to 1.9.0 for release.  And this was released with the
	  spelling for tls-ciphers fix as 1.9.0 on Feb 5.  Trunk has 1.9.1 in
	  development.

25 January 2019: Wouter
	- Fix that tcp for auth zone and outgoing does not remove and
	  then gets the ssl read again applied to the deleted commpoint.
	- updated contrib/fastrpz.patch to cleanly diff.
	- no lock when threads disabled in tcp request buffer count.
	- remove compile warnings from libnettle compile.
	- output of newer lex 2.6.1 and bison 3.0.5.

24 January 2019: Wouter
	- Newer aclocal and libtoolize used for generating configure scripts,
	  aclocal 1.16.1 and libtoolize 2.4.6.
	- Fix unit test for python 3.7 new keyword 'async'.
	- clang analysis fixes, assert arc4random buffer in init,
	  no check for already checked delegation pointer in iterator,
	  in testcode check for NULL packet matches, in perf do not copy
	  from NULL start list when growing capacity.  Adjust host and file
	  only when present in test header read to please checker.  In
	  testcode for unknown macro operand give zero result. Initialise the
	  passed argv array in test code.  In test code add EDNS data
	  segment copy only when nonempty.
	- Patch from Florian Obser fixes some compiler warnings:
	  include mini_event.h to have a prototype for mini_ev_cmp
	  include edns.h to have a prototype for apply_edns_options
	  sldns_wire2str_edns_keepalive_print is only called in the wire2str,
	  module declare it static to get rid of compiler warning:
	  no previous prototype for function
	  infra_find_ip_ratedata() is only called in the infra module,
	  declare it static to get rid of compiler warning:
	  no previous prototype for function
	  do not shadow local variable buf in authzone
	  auth_chunks_delete and az_nsec3_findnode are only called in the
	  authzone module, declare them static to get rid of compiler warning:
	  no previous prototype for function...
	  copy_rrset() is only called in the respip module, declare it
	  static to get rid of compiler warning:
	  no previous prototype for function 'copy_rrset'
	  no need for another variable "r"; gets rid of compiler warning:
	  declaration shadows a local variable in libunbound.c
	  no need for another variable "ns"; gets rid of compiler warning:
	  declaration shadows a local variable in iterator.c
	- Moved includes and make depend.

23 January 2019: Wouter
	- Patch from Manabu Sonoda with tls-ciphers and tls-ciphersuites
	  options for unbound.conf.
	- Fixes for the patch, and man page entry.
	- Fix configure to detect SSL_CTX_set_ciphersuites, for better
	  library compatibility when compiling.
	- Patch for TLS session resumption from Manabu Sonoda,
	  enable with tls-session-ticket-keys in unbound.conf.
	- Fixes for patch (includes, declarations, warnings).  Free at end
	  and keep config options in order read from file to keep the first
	  one as the first one.
	- Fix for IXFR fallback to reset counter when IXFR does not timeout.

22 January 2019: Wouter
	- Fix space calculation for tcp req buffer size.
	- Doc for stream-wait-size and unit test.
	- unbound-control stats has mem.streamwait that counts TCP and TLS
	  waiting result buffers.
	- Fix for #4219: secondaries not updated after serial change, unbound
	  falls back to AXFR after IXFR gives several timeout failures.
	- Fix that auth zone after IXFR fallback tries the same master.

21 January 2019: Wouter
	- Fix tcp idle timeout test, for difference in the tcp reply code.
	- Unit test for tcp request reorder and timeouts.
	- Unit tests for ssl out of order processing.
	- Fix that multiple dns fragments can be carried in one TLS frame.
	- Add stream-wait-size: 4m config option to limit the maximum
	  memory used by waiting tcp and tls stream replies.  This avoids
	  a denial of service where these replies use up all of the memory.

17 January 2019: Wouter
	- For caps-for-id fallback, use the whitelist to avoid timeout
	  starting a fallback sequence for it.
	- increase mesh max activation count for capsforid long fetches.

16 January 2019: Ralph
	- Get ready for the DNS flag day: remove EDNS lame procedure, do not
	  re-query without EDNS after timeout.

15 January 2019: Wouter
	- In the out of order processing, reset byte count for (potential)
	  partial read.
	- Review fixes in out of order processing.

14 January 2019: Wouter
	- streamtcp option -a send queries consecutively and prints answers
	  as they arrive.
	- Fix for out of order processing administration quit cleanup.
	- unit test for tcp out of order processing.

11 January 2019: Wouter
	- Initial commit for out-of-order processing for TCP and TLS.

9 January 2019: Wouter
	- Log query name for looping module errors.

8 January 2019: Wouter
	- Fix syntax in comment of local alias processing.
	- Fix NSEC3 record that is returned in wildcard replies from
	  auth-zone zones with NSEC3 and wildcards.

7 January 2019: Wouter
	- On FreeBSD warn if systcl settings do not allow server TCP FASTOPEN,
	  and server tcp fastopen is enabled at compile time.
	- Document interaction between the tls-upstream option in the server
	  section and forward-tls-upstream option in the forward-zone sections.
	- Add contrib/unbound-fuzzme.patch from Jacob Hoffman-Andrews,
	  the patch adds a program used for fuzzing.

12 December 2018: Wouter
	- Fix for crash in dns64 module if response is null.

10 December 2018: Wouter
	- Fix config parser memory leaks.
	- ip-ratelimit-factor of 1 allows all traffic through, instead of the
	  previous blocking everything.
	- Fix for FreeBSD port make with dnscrypt and dnstap enabled.
	- Fix #4206: support openssl 1.0.2 for TLS hostname verification,
	  alongside the 1.1.0 and later support that is already there.
	- Fixup openssl 1.0.2 compile

6 December 2018: Wouter
	- Fix dns64 allocation in wrong region for returned internal queries.

3 December 2018: Wouter
	- Fix icon, no ragged edges and nicer resolutions available, for eg.
	  Win 7 and Windows 10 display.
	- cache-max-ttl also defines upperbound of initial TTL in response.

30 November 2018: Wouter
	- Patch for typo in unbound.conf man page.
	- log-tag-queryreply: yes in unbound.conf tags the log-queries and
	  log-replies in the log file for easier log filter maintenance.

29 November 2018: Wouter
	- iana portlist updated.
	- Fix chroot auth-zone fix to remove chroot prefix.
	- tag for 1.8.2rc1, which became 1.8.2 on 4 dec 2018, with icon
	  updated.  Trunk contains 1.8.3 in development.
	  Which became 1.8.3 on 11 december with only the dns64 fix of 6 dec.
	  Trunk then became 1.8.4 in development.
	- Fix that unbound-checkconf does not complains if the config file
	  is not placed inside the chroot.
	- Refuse to start with no ports.
	- Remove clang analysis warnings.

28 November 2018: Wouter
	- Fix leak in chroot fix for auth-zone.
	- Fix clang analysis for outside directory build test.

27 November 2018: Wouter
	- Fix DNS64 to not store intermediate results in cache, this avoids
	  other threads from picking up the wrong data.  The module restores
	  the previous no_cache_store setting when the the module is finished.
	- Fix #4208: 'stub-no-cache' and 'forward-no-cache' not work.
	- New and better fix for Fix #4193: Fix that prefetch failure does
	  not overwrite valid cache entry with SERVFAIL.
	- auth-zone give SERVFAIL when expired, fallback activates when
	  expired, and this is documented in the man page.
	- stat count SERVFAIL downstream auth-zone queries for expired zones.
	- Put new logos into windows installer.
	- Fix windows compile for new rrset roundrobin fix.
	- Update contrib fastrpz patch for latest release.

26 November 2018: Wouter
	- Fix to not set GLOB_NOSORT so the unbound.conf include: files are
	  sorted and in a predictable order.
	- Fix #4193: Fix that prefetch failure does not overwrite valid cache
	  entry with SERVFAIL.
	- Add unbound-control view_local_datas command, like local_datas.
	- Fix that unbound-control can send file for view_local_datas.

22 November 2018: Wouter
	- With ./configure --with-pyunbound --with-pythonmodule
	  PYTHON_VERSION=3.6 or with 2.7 unbound can compile and unit tests
	  succeed for the python module.
	- pythonmod logs the python error and traceback on failure.
	- ignore debug python module for test in doxygen output.
	- review fixes for python module.
	- Fix #4209: Crash in libunbound when called from getdns.
	- auth zone zonefiles can be in a chroot, the chroot directory
	  components are removed before use.
	- Fix that empty zonefile means the zonefile is not set and not used.
	- make depend.

21 November 2018: Wouter
	- Scrub NS records from NODATA responses as well.

20 November 2018: Wouter
	- Scrub NS records from NXDOMAIN responses to stop fragmentation
	  poisoning of the cache.
	- Add patch from Jan Vcelak for pythonmod,
	  add sockaddr_storage getters, add support for query callbacks,
	  allow raw address access via comm_reply and update API documentation.
	- Removed compile warnings in pythonmod sockaddr routines.

19 November 2018: Wouter
	- Support SO_REUSEPORT_LB in FreeBSD 12 with the so-reuseport: yes
	  option in unbound.conf.

6 November 2018: Ralph
	- Bugfix min-client-subnet-ipv6

25 October 2018: Ralph
	- Add min-client-subnet-ipv6 and min-client-subnet-ipv4 options.

25 October 2018: Wouter
	- Fix #4191: NXDOMAIN vs SERVFAIL during dns64 PTR query.
	- Fix #4190: Please create a "ANY" deny option, adds the option
	  deny-any: yes in unbound.conf.  This responds with an empty message
	  to queries of type ANY.
	- Fix #4141: More randomness to rrset-roundrobin.
	- Fix #4132: Openness/closeness of RANGE intervals in rpl files.
	- Fix #4126: RTT_band too low on VSAT links with 600+ms latency,
	  adds the option unknown-server-time-limit to unbound.conf that
	  can be increased to avoid the problem.
	- remade makefile dependencies.
	- Fix #4152: Logs shows wrong time when using log-time-ascii: yes.

24 October 2018: Ralph
	- Add markdel function to ECS slabhash.
	- Limit ECS scope returned to client to the scope used for caching.
	- Make lint like previous #4154 fix.

22 October 2018: Wouter
	- Fix #4192: unbound-control-setup generates keys not readable by
	  group.
	- check that the dnstap socket file can be opened and exists, print
	  error if not.
	- Fix #4154: make ECS_MAX_TREESIZE configurable, with
	  the max-ecs-tree-size-ipv4 and max-ecs-tree-size-ipv6 options.

22 October 2018: Ralph
	- Change fast-server-num default to 3.

8 October 2018: Ralph
	- Add fast-server-permil and fast-server-num options.
	- Deprecate low-rtt and low-rtt-permil options.

8 October 2018: Wouter
	- Squelch log of failed to tcp initiate after TCP Fastopen failure.

5 October 2018: Wouter
	- Squelch EADDRNOTAVAIL errors when the interface goes away,
	  this omits 'can't assign requested address' errors unless
	  verbosity is set to a high value.
	- Set default for so-reuseport to no for FreeBSD.  It is enabled
	  by default for Linux and DragonFlyBSD.  The setting can 
	  be configured in unbound.conf to override the default.
	- iana port update.

2 October 2018: Wouter
	- updated contrib/fastrpz.patch to apply for this version
	- dnscrypt.c removed sizeof to get array bounds.
	- Fix testlock code to set noreturn on error routine.
	- Remove unused variable from contrib fastrpz/rpz.c and
	  remove unused diagnostic pragmas that themselves generate warnings
	- clang analyze test is used only when assertions are enabled.

1 October 2018: Wouter
	- tag for release 1.8.1rc1.  Became release 1.8.1 on 8 oct, with
	  fastrpz.patch fix included.  Trunk has 1.8.2 in development.

27 September 2018: Wouter
	- Fix #4188: IPv6 forwarders without ipv6 result in SERVFAIL, fixes
	  qname minimisation with a forwarder when connectivity has issues
	  from rejecting responses.

25 September 2018: Wouter
	- Perform TLS SNI indication of the host that is being contacted
	  for DNS over TLS service.  It sets the configured tls auth name.
	  This is useful for hosts that apart from the DNS over TLS services
	  also provide other (web) services.
	- Fix #4149: Add SSL cleanup for tcp timeout.

17 September 2018: Wouter
	- Fix compile on Mac for unbound, provide explicit_bzero when libc
	  does not have it.
	- Fix unbound for openssl in FIPS mode, it uses the digests with
	  the EVP call contexts.
	- Fix that with harden-below-nxdomain and qname minisation enabled
	  some iterator states for nonresponsive domains can get into a
	  state where they waited for an empty list.
	- Stop UDP to TCP failover after timeouts that causes the ping count
	  to be reset by the TCP time measurement (that exists for TLS),
	  because that causes the UDP part to not be measured as timeout.
	- Fix #4156: Fix systemd service manager state change notification.

13 September 2018: Wouter
	- Fix seed for random backup code to use explicit zero when wiped.
	- exit log routine is annotated as noreturn function.
	- free memory leaks in config strlist and str2list insert functions.
	- do not move unused argv variable after getopt.
	- Remove unused if clause in testcode.
	- in testcode, free async ids, initialise array, and check for null
	  pointer during test of the test.  And use exit for return to note
	  irregular program stop.
	- Free memory leak in config strlist append.
	- make sure nsec3 comparison salt is initialized.
	- unit test has clang analysis.
	- remove unused variable assignment from iterator scrub routine.
	- check for null in delegation point during iterator refetch
	  in forward zone.
	- neater pointer cast in libunbound context quit routine.
	- initialize statistics totals for printout.
	- in authzone check that node exists before adding rrset.
	- in unbound-anchor, use readwrite memory BIO.
	- assertion in autotrust that packed rrset is formed correctly.
	- Fix memory leak when message parse fails partway through copy.
	- remove unused udpsize assignment in message encode.
	- nicer bio free code in unbound-anchor.
	- annotate exit functions with noreturn in unbound-control.

11 September 2018: Wouter
	- Fixed unused return value warnings in contrib/fastrpz.patch for
	  asprintf.
	- Fix to squelch respip warning in unit test, it is printed at
	  higher verbosity settings.
	- Fix spelling errors.
	- Fix initialisation in remote.c

10 September 2018: Wouter
	- 1.8.1 in svn trunk. (changes from 4,5,.. sep apply).
	- iana port update.

5 September 2018: Wouter
	- Fix spelling error in header, from getdns commit by Andreas Gelmini.

4 September 2018: Ralph
	- More explicitly mention the type of ratelimit when applying
	  ip-ratelimit.

4 September 2018: Wouter
	- Tag for 1.8.0rc1 release, became 1.8.0 release on 10 Sep 2018.

31 August 2018: Wouter
	- Disable minimal-responses in subnet unit tests.

30 August 2018: Wouter
	- Fix that a local-zone with a local-zone-type that is transparent
	  in a view with view-first, makes queries check for answers from the
	  local-zones defined outside of views.

28 August 2018: Ralph
	- Disable minimal-responses in ipsecmod unit tests.
	- Added serve-expired-ttl and serve-expired-ttl-reset options.

27 August 2018: Wouter
	- Set defaults to yes for a number of options to increase speed and
	  resilience of the server.  The so-reuseport, harden-below-nxdomain,
	  and minimal-responses options are enabled by default.  They used
	  to be disabled by default, waiting to make sure they worked.  They
	  are enabled by default now, and can be disabled explicitly by
	  setting them to "no" in the unbound.conf config file.  The reuseport
	  and minimal options increases speed of the server, and should be
	  otherwise harmless.  The harden-below-nxdomain option works well
	  together with the recently default enabled qname minimisation, this
	  causes more fetches to use information from the cache.
	- next release is called 1.8.0.
	- Fix lintflags for lint on FreeBSD.

22 August 2018: George
	- #4140: Expose repinfo (comm_reply) to the inplace_callbacks. This
	  gives access to reply information for the client's communication
	  point when the callback is called before the mesh state (modules).
	  Changes to C and Python's inplace_callback signatures were also
	  necessary.

21 August 2018: Wouter
	- log-local-actions: yes option for unbound.conf that logs all the
	  local zone actions, a patch from Saksham Manchanda (Secure64).
	- #4146: num.query.subnet and num.query.subnet_cache counters.
	- Fix only misc failure from log-servfail when val-log-level is not
	  enabled.

17 August 2018: Ralph
	- Fix classification for QTYPE=CNAME queries when QNAME minimisation is
 	  enabled.

17 August 2018: Wouter
	- Set libunbound to increase current, because the libunbound change
	  to the event callback function signature.  That needs programs,
	  that use it, to recompile against the new header definition.
	- print servfail info to log as error.
	- added more servfail printout statements, to the iterator.
	- log-servfail: yes prints log lines that say why queries are
	  returning SERVFAIL to clients.

16 August 2018: Wouter
	- Fix warning on compile without threads.
	- Fix contrib/fastrpz.patch.

15 August 2018: Wouter
	- Fix segfault in auth-zone read and reorder of RRSIGs.

14 August 2018: Wouter
	- Fix that printout of error for cycle targets is a verbosity 4
	  printout and does not wrongly print it is a memory error.
	- Upgraded crosscompile script to include libunbound DLL in the
	  zipfile.

10 August 2018: Wouter
	- Fix #4144: dns64 module caches wrong (negative) information.

9 August 2018: Wouter
	- unbound-checkconf checks if modules exist and prints if they are
	  not compiled in the name of the wrong module.
	- document --enable-subnet in doc/README.
	- Patch for stub-no-cache and forward-no-cache options that disable
	  caching for the contents of that stub or forward, for when you
	  want immediate changes visible, from Bjoern A. Zeeb.

7 August 2018: Ralph
	- Make capsforid fallback QNAME minimisation aware.

7 August 2018: Wouter
	- Fix #4142: unbound.service.in: improvements and fixes.
	  Add unit dependency ordering (based on systemd-resolved).
	  Add 'CAP_SYS_RESOURCE' to 'CapabilityBoundingSet' (fixes warnings
	  about missing privileges during startup). Add 'AF_INET6' to
	  'RestrictAddressFamilies' (without it IPV6 can't work). From
	  Guido Shanahan.
	- Patch to implement tcp-connection-limit from Jim Hague (Sinodun).
	  This limits the number of simultaneous TCP client connections
	  from a nominated netblock.
	- make depend, yacc, lex, doc, headers.  And log the limit exceeded
	  message only on high verbosity, so as to not spam the logs when
	  it is busy.

6 August 2018: Wouter
	- Fix for #4136: Fix to unconditionally call destroy in daemon.c.

3 August 2018: George
	- Expose if a query (or a subquery) was ratelimited (not src IP
	  ratelimiting) to libunbound under 'ub_result.was_ratelimited'.
	  This also introduces a change to 'ub_event_callback_type' in
	  libunbound/unbound-event.h.
	- Tidy pylib tests.

3 August 2018: Wouter
	- Revert previous change for #4136: because it introduces build
	  problems.
	- New fix for #4136: This one ignores lex without without
	  yylex_destroy.

1 August 2018: Wouter
	- Fix to remove systemd sockaddr function check, that is not
	  always present.  Make socket activation more lenient.  But not
	  different when socket activation is not used.
	- iana port list update.

31 July 2018: Wouter
	- Patches from Jim Hague (Sinodun) for EDNS KeepAlive.
	- Sort out test runs when the build directory isn't the project
	  root directory.
	- Add config tcp-idle-timeout (default 30s). This applies to
	  client connections only; the timeout on TCP connections upstream
	  is unaffected.
	- Error if EDNS Keepalive received over UDP.
	- Add edns-tcp-keepalive and edns-tcp-keepalive timeout options
	  and implement option in client responses.
	- Correct and expand manual page entries for keepalive and idle timeout.
	- Implement progressive backoff of TCP idle/keepalive timeout.
	- Fix 'make depend' to work when build dir is not project root.
	- Add delay parameter to streamtcp, -d secs.
	  To be used when testing idle timeout.
	- From Wouter: make depend, the dependencies in the patches did not
	  apply cleanly.  Also remade yacc and lex.
	- Fix mesh.c incompatible pointer pass.
	- Please doxygen so it passes.
	- Fix #4139: Fix unbound-host leaks memory on ANY.

30 July 2018: Wouter
	- Fix #4136: insufficiency from mismatch of FLEX capability between
	  released tarball and build host.

27 July 2018: Wouter
	- Fix man page, say that chroot is enabled by default.

26 July 2018: Wouter
	- Fix #4135: 64-bit Windows Installer Creates Entries Under The
	  Wrong Registry Key, reported by Brian White.

23 July 2018: Wouter
	- Fix use-systemd readiness signalling, only when use-systemd is yes
	  and not in signal handler.

20 July 2018: Wouter
	- Fix #4130: print text describing -dd and unbound-checkconf on
	  config file read error at startup, the errors may have been moved
	  away by the startup process.
	- Fix #4131: for solaris, error YY_CURRENT_BUFFER undeclared.

19 July 2018: Wouter
	- Fix #4129 unbound-control error message with wrong cert permissions
	  is too cryptic.

17 July 2018: Wouter
	- Fix #4127 unbound -h does not list -p help.
	- Print error if SSL name verification configured but not available
	  in the ssl library.
	- Fix that ratelimit and ip-ratelimit are applied after reload of
	  changed config file.
	- Resize ratelimit and ip-ratelimit caches if changed on reload.

16 July 2018: Wouter
	- Fix qname minimisation NXDOMAIN validation lookup failures causing
	  error_supers assertion fails.
	- Squelch can't bind socket errors with Permission denied unless
	  verbosity is 4 or higher, for UDP outgoing sockets.

12 July 2018: Wouter
	- Fix to improve systemd socket activation code file descriptor
	  assignment.
	- Fix for 4126 that the #define for UNKNOWN_SERVER_NICENESS can be more
	  easily changed to adjust default rtt assumptions.

10 July 2018: Wouter
	- Note in documentation that the cert name match code needs
	  OpenSSL 1.1.0 or later to be enabled.

6 July 2018: Wouter
	- Fix documentation ambiguity for tls-win-cert in tls-upstream and
	  forward-tls-upstream docs.
	- iana port update.
	- Note RFC8162 support.  SMIMEA record type can be read in by the
	  zone record parser.
	- Fix round robin for failed addresses with prefer-ip6: yes

4 July 2018: Wouter
	- Fix #4112: Fix that unbound-anchor -f /etc/resolv.conf will not pass
	  if DNSSEC is not enabled.  New option -R allows fallback from
	  resolv.conf to direct queries.

3 July 2018: Wouter
	- Better documentation for unblock-lan-zones and insecure-lan-zones
	  config statements.
	- Fix permission denied printed for auth zone probe random port nrs.

2 July 2018: Wouter
	- Fix checking for libhiredis printout in configure output.
	- Fix typo on man page in ip-address description.
	- Update libunbound/python/examples/dnssec_test.py example code to
	  also set the 20326 trust anchor for the root in the example code.

29 June 2018: Wouter
	- dns64-ignore-aaaa: config option to list domain names for which the
	  existing AAAA is ignored and dns64 processing is used on the A
	  record.

28 June 2018: Wouter
	- num.queries.tls counter for queries over TLS.
	- log port number with err_addr logs.

27 June 2018: Wouter
	- #4109: Fix that package config depends on python unconditionally.
	- Patch, do not export python from pkg-config, from Petr Menšík.

26 June 2018: Wouter
	- Partial fix for permission denied on IPv6 address on FreeBSD.
	- Fix that auth-zone master reply with current SOA serial does not
	  stop scan of masters for an updated zone.
	- Fix that auth-zone does not start the wait timer without checking
	  if the wait timer has already been started.

21 June 2018: Wouter
	- #4108: systemd reload hang fix.
	- Fix usage printout for unbound-host, hostname has to be last
	  argument on BSDs and Windows.

19 June 2018: Wouter
	- Fix for unbound-control on Windows and set TCP socket parameters
	  more closely.
	  This fix is part of 1.7.3.
	- Windows example service.conf edited with more windows specific
	  configuration.
	- Fix windows unbound-control no cert bad file descriptor error.
	  This fix is part of 1.7.3.

18 June 2018: Wouter
	- Fix that control-use-cert: no works for 127.0.0.1 to disable certs.
	  This fix is part of 1.7.3rc2.
	- Fix unbound-checkconf for control-use-cert.
	  This fix is part of 1.7.3.

15 June 2018: Wouter
	- tag for 1.7.3rc1.
	- trunk has 1.7.4.
	- unbound-control auth_zone_reload _zone_ option rereads the zonefile.
	- unbound-control auth_zone_transfer _zone_ option starts the probe
	  sequence for a master to transfer the zone from and transfers when
	  a new zone version is available.

14 June 2018: Wouter
	- #4103: Fix that auth-zone does not insist on SOA record first in
	  file for url downloads.
	- Fix that first control-interface determines if TLS is used.  Warn
	  when IP address interfaces are used without TLS.
	- Fix nettle compile.

12 June 2018: Ralph
	- Don't count CNAME response types received during qname minimisation as
	  query restart.

12 June 2018: Wouter
	- #4102 for NSD, but for Unbound.  Named unix pipes do not use
	  certificate and key files, access can be restricted with file and
	  directory permissions.  The option control-use-cert is no longer
	  used, and ignored if found in unbound.conf.
	- Rename tls-additional-ports to tls-additional-port, because every
	  line adds one port.
	- Fix buffer size warning in unit test.
	- remade dependencies in the Makefile.

6 June 2018: Wouter
	- Patch to fix openwrt for mac os build darwin detection in configure.

5 June 2018: Wouter
	- Fix crash if ratelimit taken into use with unbound-control
	  instead of with unbound.conf.

4 June 2018: Wouter
	- Fix deadlock caused by incoming notify for auth-zone.
	- tag for 1.7.2rc1, became 1.7.2 release on 11 June 2018,
	  trunk is 1.7.3 in development from this point.
	- #4100: Fix stub reprime when it becomes useless.

1 June 2018: Wouter
	- Rename additional-tls-port to tls-additional-ports.
	  The older name is accepted for backwards compatibility.

30 May 2018: Wouter
	- Patch from Syzdek: Add ability to ignore RD bit and treat all
	  requests as if the RD bit is set.

29 May 2018: Wouter
	- in compat/arc4random call getentropy_urandom when getentropy fails
	  with ENOSYS.
	- Fix that fallback for windows port.

28 May 2018: Wouter
	- Fix windows tcp and tls spin on events.
	- Add routine from getdns to add windows cert store to the SSL_CTX.
	- tls-win-cert option that adds the system certificate store for
	  authenticating DNS-over-TLS connections.  It can be used instead
	  of the tls-cert-bundle option, or with it to add certificates.

25 May 2018: Wouter
	- For TCP and TLS connections that don't establish, perform address
	  update in infra cache, so future selections can exclude them.
	- Fix that tcp sticky events are removed for closed fd on windows.
	- Fix close events for tcp only.

24 May 2018: Wouter
	- Fix that libunbound can do DNS-over-TLS, when configured.
	- Fix that windows unbound service can use DNS-over-TLS.
	- unbound-host initializes ssl (for potential DNS-over-TLS usage
	  inside libunbound), when ssl upstream or a cert-bundle is configured.

23 May 2018: Wouter
	- Use accept4 to speed up incoming TCP (and TLS) connections,
	  available on Linux, FreeBSD and OpenBSD.

17 May 2018: Ralph
	- Qname minimisation default changed to yes.

15 May 2018: Wouter
	- Fix low-rtt-pct to low-rtt-permil, as it is parts in one thousand.

11 May 2018: Wouter
	- Fix contrib/libunbound.pc for libssl libcrypto references,
	  from https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=226914

7 May 2018: Wouter
	- Fix windows to not have sticky TLS events for TCP.
	- Fix read of DNS over TLS length and data in one read call.
	- Fix mesh state assertion failure due to callback removal.

3 May 2018: Wouter
	- Fix that configure --with-libhiredis also turns on cachedb.
	- Fix gcc 8 buffer warning in testcode.
	- Fix function type cast warning in libunbound context callback type.

2 May 2018: Wouter
	- Fix fail to reject dead peers in forward-zone, with ssl-upstream.

1 May 2018: Wouter
	- Fix that unbound-control reload frees the rrset keys and returns
	  the memory pages to the system.

30 April 2018: Wouter
	- Fix spelling error in man page and note defaults as no instead of
	  off.

26 April 2018: Wouter
	- Fix for crash in daemon_cleanup with dnstap during reload,
	  from Saksham Manchanda.
	- Also that for dnscrypt.
	- tag for 1.7.1rc1 release.  Became 1.7.1 release on 3 May, trunk
	  is from here 1.7.2 in development.

25 April 2018: Ralph
	- Fix memory leak when caching wildcard records for aggressive NSEC use

24 April 2018: Wouter
	- Fix contrib/fastrpz.patch for this release.
	- Fix auth https for libev.

24 April 2018: Ralph
	- Added root-key-sentinel support

23 April 2018: Wouter
	- makedist uses bz2 for expat code, instead of tar.gz.
	- Fix #4092: libunbound: use-caps-for-id lacks colon in
	  config_set_option.
	- auth zone http download stores exact copy of downloaded file,
	  including comments in the file.
	- Fix sldns parse failure for CDS alternate delete syntax empty hex.
	- Attempt for auth zone fix; add of callback in mesh gets from
	  callback does not skip callback of result.
	- Fix cname classification with qname minimisation enabled.
	- list_auth_zones unbound-control command.

20 April 2018: Wouter
	- man page documentation for dns-over-tls forward-addr '#' notation.
	- removed free from failed parse case.
	- Fix #4091: Fix that reload of auth-zone does not merge the zonefile
	  with the previous contents.
	- Delete auth zone when removed from config.

19 April 2018: Wouter
	- Can set tls authentication with forward-addr: IP#tls.auth.name
	  And put the public cert bundle in tls-cert-bundle: "ca-bundle.pem".
	  such as forward-addr: 9.9.9.9@853#dns.quad9.net or
	  1.1.1.1@853#cloudflare-dns.com
	- Fix #658: unbound using TLS in a forwarding configuration does not
	  verify the server's certificate (RFC 8310 support).
	- For addr with #authname and no @port notation, the default is 853.

18 April 2018: Wouter
	- Fix auth-zone retry timer to be on schedule with retry timeout,
	  with backoff.  Also time a refresh at the zone expiry.

17 April 2018: Wouter
	- auth zone notify work.
	- allow-notify: config statement for auth-zones.
	- unit test for allow-notify

16 April 2018: Wouter
	- Fix auth zone target lookup iterator.
	- auth zone notify with prefix
	- auth zone notify work.

13 April 2018: Wouter
	- Fix for max include depth for authzones.
	- Fix memory free on fail for $INCLUDE in authzone.
	- Fix that an internal error to look up the wrong rr type for
	  auth zone gets stopped, before trying to send there.
	- auth zone notify work.

10 April 2018: Ralph
	- num.query.aggressive.NOERROR and num.query.aggressive.NXDOMAIN
	  statistics counters.

10 April 2018: Wouter
	- documentation for low-rtt and low-rtt-pct.
	- auth zone notify work.

9 April 2018: Wouter
	- Fix that flush_zone sets prefetch ttl expired, so that with
	  serve-expired enabled it'll start prefetching those entries.
	- num.query.authzone.up and num.query.authzone.down statistics counters.
	- Fix downstream auth zone, only fallback when auth zone fails to
	  answer and fallback is enabled.
	- Accept both option names with and without colon for get_option
	  and set_option.
	- low-rtt and low-rtt-pct in unbound.conf enable the server selection
	  of fast servers for some percentage of the time.

5 April 2018: Wouter
	- Combine write of tcp length and tcp query for dns over tls.
	- nitpick fixes in example.conf.
	- Fix above stub queries for type NS and useless delegation point.
	- Fix unbound-control over pipe with openssl 1.1.1, the TLSv1.3
	  tls_choose_sigalg routine does not allow the ciphers for the pipe,
	  so use TLSv1.2.
	- ED448 support.

3 April 2018: Wouter
	- Fix #4043: make test fails due to v6 presentation issue in macOS.
	- Fix unable to resolve after new WLAN connection, due to auth-zone
	  failing with a forwarder set.  Now, auth-zone is only used for
	  answers (not referrals) when a forwarder is set.

29 March 2018: Ralph
	- Check "result" in dup_all(), by Florian Obser.

23 March 2018: Ralph
	- Fix unbound-control get_option aggressive-nsec

21 March 2018: Ralph
	- Do not use cached NSEC records to generate negative answers for
	  domains under DNSSEC Negative Trust Anchors.

19 March 2018: Wouter
	- iana port update.

16 March 2018: Wouter
	- corrected a minor typo in the changelog.
	- move htobe64/be64toh portability code to cachedb.c.

15 March 2018: Wouter
	- Add --with-libhiredis, unbound support for a new cachedb backend
	  that uses a Redis server as the storage.  This implementation
	  depends on the hiredis client library (https://redislabs.com/lp/hiredis/).
	  And unbound should be built with both --enable-cachedb and
	  --with-libhiredis[=PATH] (where $PATH/include/hiredis/hiredis.h
	  should exist).  Patch from Jinmei Tatuya (Infoblox).
	- Fix #3817: core dump happens in libunbound delete, when queued
	  servfail hits deleted message queue.
	- Create additional tls service interfaces by opening them on other
	  portnumbers and listing the portnumbers as additional-tls-port: nr.

13 March 2018: Wouter
	- Fix typo in documentation.
	- Fix #3736: Fix 0 TTL domains stuck on SERVFAIL unless manually
	  flushed with serve-expired on.

12 March 2018: Wouter
	- Added documentation for aggressive-nsec: yes.
	- tag 1.7.0rc3.  That became the 1.7.0 release on 15 Mar, trunk
	  now has 1.7.1 in development.
	- Fix #3727: Protocol name is TLS, options have been renamed but
	  documentation is not consistent.
	- Check IXFR start serial.

9 March 2018: Wouter
	- Fix #3598: Fix swig build issue on rhel6 based system.
	  configure --disable-swig-version-check stops the swig version check.

8 March 2018: Wouter
	- tag 1.7.0rc2.

7 March 2018: Wouter
	- Fixed contrib/fastrpz.patch, even though this already applied
	  cleanly for me, now also for others.
	- patch to log creates keytag queries, from A. Schulze.
	- patch suggested by Debian lintian: allow to -> allow one to, from 
	  A. Schulze.
	- Attempt to remove warning about trailing whitespace.

6 March 2018: Wouter
	- Reverted fix for #3512, this may not be the best way forward;
	  although it could be changed at a later time, to stay similar to
	  other implementations.
	- svn trunk contains 1.7.0, this is the number for the next release.
	- Fix for windows compile.
	- tag 1.7.0rc1.

5 March 2018: Wouter
	- Fix to check define of DSA for when openssl is without deprecated.
	- iana port update.
	- Fix #3582: Squelch address already in use log when reuseaddr option
	  causes same port to be used twice for tcp connections.

27 February 2018: Wouter
	- Fixup contrib/fastrpz.patch so that it applies.
	- Fix compile without threads, and remove unused variable.
	- Fix compile with staticexe and python module.
	- Fix nettle compile.

22 February 2018: Ralph
	- Save wildcard RRset from answer with original owner for use in
 	  aggressive NSEC.

21 February 2018: Wouter
	- Fix #3512: unbound incorrectly reports SERVFAIL for CAA query
	  when there is a CNAME loop.
	- Fix validation for CNAME loops.  When it detects a cname loop,
	  by finding the cname, cname in the existing list, it returns
	  the partial result with the validation result up to then.
	- more robust cachedump rrset routine.

19 February 2018: Wouter
	- Fix #3505: Documentation for default local zones references
	  wrong RFC.
	- Fix #3494: local-zone noview can be used to break out of the view
	  to the global local zone contents, for queries for that zone.
	- Fix for more maintainable code in localzone.

16 February 2018: Wouter
	- Fixes for clang static analyzer, the missing ; in
	  edns-subnet/addrtree.c after the assert made clang analyzer
	  produce a failure to analyze it.

13 February 2018: Ralph
	- Aggressive NSEC tests

13 February 2018: Wouter
	- tls-cert-bundle option in unbound.conf enables TLS authentication.
	- iana port update.

12 February 2018: Wouter
	- Unit test for auth zone https url download.

12 February 2018: Ralph
	- Added tests with wildcard expanded NSEC records (CVE-2017-15105 test)
	- Processed aggressive NSEC code review remarks Wouter

8 February 2018: Ralph
	- Aggressive use of NSEC implementation. Use cached NSEC records to
	  generate NXDOMAIN, NODATA and positive wildcard answers.

8 February 2018: Wouter
	- iana port update.
	- auth zone url config.

5 February 2018: Wouter
	- Fix #3451: dnstap not building when you have a separate build dir.
	  And removed protoc warning, set dnstap.proto syntax to proto2.
	- auth-zone provides a way to configure RFC7706 from unbound.conf,
	  eg. with auth-zone: name: "." for-downstream: no for-upstream: yes
	  fallback-enabled: yes and masters or a zonefile with data.

2 February 2018: Wouter
	- Fix unfreed locks in log and arc4random at exit of unbound.
	- unit test with valgrind
	- Fix lock race condition in dns cache dname synthesis.
	- lock subnet new item before insertion to please checklocks,
	  no modification of critical regions outside of lock region.

1 February 2018: Wouter
	- fix unaligned structure making a false positive in checklock
	  uninitialised memory.

29 January 2018: Ralph
	- Use NSEC with longest ce to prove wildcard absence.
	- Only use *.ce to prove wildcard absence, no longer names.

25 January 2018: Wouter
	- ltrace.conf file for libunbound in contrib.

23 January 2018: Wouter
	- Fix that unbound-checkconf -f flag works with auto-trust-anchor-file
	  for startup scripts to get the full pathname(s) of anchor file(s).
	- Print fatal errors about remote control setup before log init,
	  so that it is printed to console.

22 January 2018: Wouter
	- Accept tls-upstream in unbound.conf, the ssl-upstream keyword is
	  also recognized and means the same.  Also for tls-port,
	  tls-service-key, tls-service-pem, stub-tls-upstream and
	  forward-tls-upstream.
	- Fix #3397: Fix that cachedb could return a partial CNAME chain.
	- Fix #3397: Fix that when the cache contains an unsigned DNAME in
	  the middle of a cname chain, a result without the DNAME could
	  be returned.

19 January 2018: Wouter
	- tag 1.6.8 for release with CVE fix.
	- trunk has 1.6.9 with fix and previous commits.
	- patch for CVE-2017-15105: vulnerability in the processing of
	  wildcard synthesized NSEC records.
	- iana port update.
	- make depend: code dependencies updated in Makefile.

4 January 2018: Ralph
	- Copy query and correctly set flags on REFUSED answers when cache
	  snooping is not allowed.

3 January 2018: Ralph
	- Fix queries being leaked above stub when refetching glue.

2 January 2017: Wouter
	- Fix that DS queries with referral replies are answered straight
	  away, without a repeat query picking the DS from cache.
	  The correct reply should have been an answer, the reply is fixed
	  by the scrubber to have the answer in the answer section.
	- Remove clang optimizer disable,
	  Fix that expiration date checks don't fail with clang -O2.

15 December 2017: Wouter
	- Fix timestamp failure because of clang optimizer failure, by
	  disabling -O2 when the compiler --version is clang.
	- iana port update.
	- Also disable -flto for clang, to make incep-expi signature check
	  work.

12 December 2017: Ralph
	- Fix qname-minimisation documentation (A QTYPE, not NS)

12 December 2017: Wouter
	- authzone work, transfer connect.

7 December 2017: Ralph
	- Check whether --with-libunbound-only is set when using --with-nettle
	  or --with-nss.

4 December 2017: Wouter 
	- Fix link failure on OmniOS.

1 December 2017: Wouter 
	- auth zone work.

30 November 2017: Wouter 
	- Fix #3299 - forward CNAME daisy chain is not working

14 November 2017: Wouter 
	- Fix #2882: Unbound behaviour changes (wrong) when domain-insecure is
	  set for stub zone.  It no longer searches for DNSSEC information.
	- auth xfer work on probe timer and lookup.

13 November 2017: Wouter 
	- Fix #2801: Install libunbound.pc.
	- Fix qname minimisation to send AAAA queries at zonecut like type A.
	- reverted AAAA change.

7 November 2017: Wouter 
	- Fix #2492: Documentation libunbound.

3 November 2017: Wouter 
	- Fix #2362: TLS1.3/openssl-1.1.1 not working.
	- Fix #2034 - Autoconf and -flto.
	- Fix #2141 - for libsodium detect lack of entropy in chroot, print
	  a message and exit.

2 November 2017: Wouter 
	- Fix #1913: ub_ctx_config is under circumstances thread-safe.
	- make ip-transparent option work on OpenBSD.

31 October 2017: Wouter 
	- Document that errno is left informative on libunbound config read
	  fail.
	- lexer output.
	- iana port update.

25 October 2017: Ralph
	- Fixed libunbound manual typo.
	- Fix #1949: [dnscrypt] make provider name mismatch more obvious.
	- Fix #2031: Double included headers

24 October 2017: Ralph
	- Update B root ipv4 address.

19 October 2017: Wouter 
	- authzone work, probe timer setup.

18 October 2017: Wouter 
	- lint for recent authzone commit.

17 October 2017: Wouter 
	- Fix #1749: With harden-referral-path: performance drops, due to
	  circular dependency in NS and DS lookups.
	- [dnscrypt] prevent dnscrypt-secret-key, dnscrypt-provider-cert
	  duplicates
	- [dnscrypt] introduce dnscrypt-provider-cert-rotated option,
	  from Manu Bretelle.
	This option allows handling multiple cert/key pairs while only
	distributing some of them.
	In order to reliably match a client magic with a given key without
	strong assumption as to how those were generated, we need both key and
	cert. Likewise, in order to know which ES version should be used.
	On the other hand, when rotating a cert, it can be desirable to only
	serve the new cert but still be able to handle clients that are still
	using the old certs's public key.
	The `dnscrypt-provider-cert-rotated` allow to instruct unbound to not
	publish the cert as part of the DNS's provider_name's TXT answer.
	- Better documentation for cache-max-negative-ttl.
	- Work on local root zone code.

10 October 2017: Wouter 
	- tag 1.6.7
	- trunk has version 1.6.8.

6 October 2017: Wouter 
	- Fix spelling in unbound-control man page.

5 October 2017: Wouter 
	- Fix trust-anchor-signaling works in libunbound.
	- Fix some more crpls in testdata for different signaling default.
	- tag 1.6.7rc1

5 October 2017: Ralph 
	- Set trust-anchor-signaling default to yes
	- Use RCODE from A query on DNS64 synthesized answer.

2 October 2017: Wouter
	- Fix param unused warning for windows exportsymbol compile.

25 September 2017: Ralph
	- Fix #1450: Generate again patch contrib/aaaa-filter-iterator.patch
	   (by Danilo G. Baio).

21 September 2017: Ralph
	- Log name of looping module

19 September 2017: Wouter
	- use a cachedb answer even if it's "expired" when serve-expired is yes
	  (patch from Jinmei Tatuya).
	- trigger refetching of the answer in that case (this will bypass
	  cachedb lookup)
	- allow storing a 0-TTL answer from cachedb in the in-memory message
	  cache when serve-expired is yes
	- Fix DNSCACHE_STORE_ZEROTTL to be bigger than 0xffff.

18 September 2017: Ralph
	- Fix #1400: allowing use of global cache on ECS-forwarding unless
	  always-forward.

18 September 2017: Wouter
	- tag 1.6.6 (is 1.6.6rc2)
	- Fix that looping modules always stop the query, and don't pass
	  control.
	- Fix #1435: Please allow UDP to be disabled separately upstream and
	  downstream.
	- Fix #1440: [dnscrypt] client nonce cache.

15 September 2017: Wouter
	- Fix unbound-host to report error for DNSSEC state of failed lookups.
	- Spelling fixes, from Josh Soref.

13 September 2017: Wouter
	- tag 1.6.6rc2, became 1.6.6 on 18 sep.  trunk 1.6.7 in development.

12 September 2017: Wouter
	- Add dns64 for client-subnet in unbound-checkconf.

4 September 2017: Ralph
	- Fix #1412: QNAME minimisation strict mode not honored
	- Fix #1434: Fix windows openssl 1.1.0 linking.

4 September 2017: Wouter
	- tag 1.6.6rc1
	- makedist fix for windows binaries, with openssl 1.1.0 windres fix,
	  and expat 2.2.4 install target fix.

1 September 2017: Wouter
	- Recommend 1472 buffer size in unbound.conf

31 August 2017: Wouter
	- Fix #1424: cachedb:testframe is not thread safe.
	- For #1417: escape ; in dnscrypt tests.
	- but reverted that, tests fails with that escape.
	- Fix #1417: [dnscrypt] shared secret cache counters, and works when
	  dnscrypt is not enabled.  And cache size configuration option.
	- make depend
	- Fix #1418: [ip ratelimit] initialize slabhash using
	  ip-ratelimit-slabs.

30 August 2017: Wouter
	- updated contrib/fastrpz.patch to apply with configparser changes.
	- Fix 1416: qname-minimisation breaks TLSA lookups with CNAMEs.

29 August 2017: Wouter
	- Fix #1414: fix segfault on parse failure and log_replies.
	- zero qinfo in handle_request, this zeroes local_alias and also the
	  qname member.
	- new keys and certs for dnscrypt tests.
	- fixup WKS test on buildhost without servicebyname.

28 August 2017: Wouter
	- Fix #1415: patch to free dnscrypt environment on reload.
	- iana portlist update
	- Fix #1415: [dnscrypt] shared secret cache, patch from
	  Manu Bretelle.
	- Small fixes for the shared secret cache patch.
	- Fix WKS records on kvm autobuild host, with default protobyname
	  entries for udp and tcp.

23 August 2017: Wouter
	- Fix #1407: Add ECS options check to unbound-checkconf.
	- make depend
	- Fix to reclaim tcp handler when it is closed due to dnscrypt buffer
	  allocation failure.

22 August 2017: Wouter
	- Fix install of trust anchor when two anchors are present, makes both
	  valid. Checks hash of DS but not signature of new key. This fixes
	  the root.key file if created when unbound is installed between
	  sep11 and oct11 2017.
	- tag 1.6.5 with pointrelease 1.6.5 (1.6.4 plus 5011 fix).
	- trunk version 1.6.6 in development.
	- Fix issue on macOX 10.10 where TCP fast open is detected but not
	  implemented causing TCP to fail. The fix allows fallback to regular
	  TCP in this case and is also more robust for cases where connectx()
	  fails for some reason.
	- Fix #1402: squelch invalid argument error for fd_set_block on windows.

10 August 2017: Wouter
	- Patch to show DNSCrypt status in help output, from Carsten
	  Strotmann.

8 August 2017: Wouter
	- Fix #1398: make cachedb secret configurable.
	- Remove spaces from Makefile.

7 August 2017: Wouter
	- Fix #1397: Recursive DS lookups for AS112 zones names should recurse.

3 August 2017: Ralph
	- Remove unused iter_env member (ip6arpa_dname)
	- Do not reset rrset.bogus stats when called using stats_noreset.
	- Added stats for queries that have been ratelimited by domain
	  recursion.
	- Do not add rrset_bogus and query ratelimiting stats per thread, these
	  module stats are global.

3 August 2017: Wouter
	- Fix #1394: mix of serve-expired and response-ip could cause a crash.

24 July 2017: Wouter
	- upgrade aclocal(pkg.m4 0.29.1), config.guess(2016-10-02),
	  config.sub(2016-09-05).
	- annotate case statement fallthrough for gcc 7.1.1.
	- flex output from flex 2.6.1.
	- snprintf of thread number does not warn about truncated string.
	- squelch TCP fast open error on FreeBSD when kernel has it disabled,
	  unless verbosity is high.
	- remove warning from windows compile.
	- Fix compile with libnettle
	- Fix DSA configure switch (--disable dsa) for libnettle and libnss.
	- Fix #1365: Add Ed25519 support using libnettle.
	- iana portlist update

17 July 2017: Wouter
	- Fix #1350: make cachedb backend configurable (from JINMEI Tatuya).
	- Fix #1349: allow suppression of pidfiles (from Daniel Kahn Gillmor).
	  With the -p option unbound does not create a pidfile.

11 July 2017: Wouter
	- Fix #1344: RFC6761-reserved domains: test. and invalid.
	- Redirect all localhost names to localhost address for RFC6761.

6 July 2017: Wouter
	- Fix tests to use .tdir (from Manu Bretelle) instead of .tpkg.
	- Fix svn hooks for tdir (selected if testcode/mini_tdir.sh exists)..

4 July 2017: Wouter
	- Fix 1332: Bump verbosity of failed chown'ing of the control socket.

3 July 2017: Wouter
	- Fix for unbound-checkconf, check ipsecmod-hook if ipsecmod is turned
	  on.
	- Fix #1331: libunbound segfault in threaded mode when context is
	  deleted.
	- Fix pythonmod link line option flag.
	- Fix openssl 1.1.0 load of ssl error strings from ssl init.

29 June 2017: Wouter
	- Fix python example0 return module wait instead of error for pass.
	- iana portlist update
	- enhancement for hardened-tls for DNS over TLS.  Removed duplicated
	  security settings.

27 June 2017: Wouter
	- Tag 1.6.4 is created with the 1.6.4rc2 contents.
	- Trunk contains 1.6.5, with changes from 26, 27 june.
	- Remove signed unsigned warning from authzone.
	- Fix that infra cache host hash does not change after reconfig.

26 June 2017: Wouter
	- (for 1.6.5)
	  Better fixup of dnscrypt_cert_chacha test for different escapes.
	- First fix for zero b64 and hex text zone format in sldns.
	- unbound-control dump_infra prints port number for address if not 53.

23 June 2017: Wouter
	- (for 1.6.5): fixup of dnscrypt_cert_chacha test (from Manu Bretelle).

22 June 2017: Wouter
	- Tag 1.6.4rc2

22 June 2017: Ralph
	- Added fastrpz patch to contrib

21 June 2017: Wouter
	- Fix #1316: heap read buffer overflow in parse_edns_options.

20 June 2017: Wouter
	- Fix warning in pythonmod under clang compiler.
	- Tag 1.6.4rc1
	- Fix lintian typo.

16 June 2017: Ralph
	- Fix #1277: disable domain ratelimit by setting value to 0.

16 June 2017: Wouter
	- Fix #1301: memory leak in respip and tests.
	- Free callback in edns-subnetmod on exit and restart.
	- Fix memory leak in sldns_buffer_new_frm_data.
	- Fix memory leak in dnscrypt config read.
	- Fix dnscrypt chacha cert support ifdefs.
	- Fix dnscrypt chacha cert unit test escapes in grep.
	- Remove asynclook tests that cause test and purifier problems.
	- Fix to unlock view in view test.

15 June 2017: Wouter
	- Fix stub zone queries leaking to the internet for
	  harden-referral-path ns checks.
	- Fix query for refetch_glue of stub leaking to internet.

13 June 2017: Wouter
	- Fix #1279: Memory leak on reload when python module is enabled.
	- Fix #1280: Unbound fails assert when response from authoritative
	  contains malformed qname.  When 0x20 caps-for-id is enabled, when
	  assertions are not enabled the malformed qname is handled correctly.
	- 1.6.3 tag created, with only #1280 fix, trunk is 1.6.4 development.
	- More fixes in depth for buffer checks in 0x20 qname checks.

12 June 2017: Wouter
	- Fix #1278: Incomplete wildcard proof.

8 June 2017: Ralph
	- Added domain name based ECS whitelist.

8 June 2017: Wouter
	- Detect chacha for dnscrypt at configure time.
	- dnscrypt unit tests with chacha.

7 June 2017: Wouter
	- Fix that unbound-control can set val_clean_additional and val_permissive_mode.
	- Add dnscrypt XChaCha20 tests.

6 June 2017: Wouter
	- Add an explicit type cast for TCP FASTOPEN fix.
	- renumbering B-Root's IPv6 address to 2001:500:200::b.
	- Fix #1275: cached data in cachedb is never used.
	- Fix #1276: [dnscrypt] add XChaCha20-Poly1305 cipher.

1 June 2017: Ralph
	- Fix #1274: automatically trim chroot path from dnscrypt key/cert paths
	  (from Manu Bretelle).

1 June 2017: Wouter
	- Fix fastopen EPIPE fallthrough to perform connect.

31 May 2017: Ralph
	- Also use global local-zones when there is a matching view that does
	  not have any local-zone specified.

31 May 2017: Wouter
	- Fix #1273: cachedb.c doesn't compile with -Wextra.
	- If MSG_FASTOPEN gives EPIPE fallthrough to try normal tcp write.

30 May 2017: Ralph
	- Fix #1269: inconsistent use of built-in local zones with views.
	- Add defaults for new local-zone trees added to views using
	  unbound-control.

30 May 2017: Wouter
	- Support for openssl EVP_DigestVerify.
	- Support for the ED25519 algorithm with openssl (from openssl 1.1.1).

29 May 2017: Wouter
	- Fix assertion for low buffer size and big edns payload when worker
	  overrides udpsize.

26 May 2017: Ralph
	- Added redirect-bogus.patch to contrib directory.

26 May 2017: Wouter
	- Fix #1270: unitauth.c doesn't compile with higher warning level
	  and optimization
	- exec_prefix is by default equal to prefix.
	- printout localzone for duplicate local-zone warnings.

24 May 2017: Wouter
	- authzone cname chain, no rrset duplicates, wildcard doesn't change
	  rrsets added for cname chain.

23 May 2017: Wouter
	- first services/authzone check in, it compiles and reads and writes
	  zonefiles.
	- iana portlist update

22 May 2017: Wouter
	- Fix #1268: SIGSEGV after log_reopen.

18 May 2017: Wouter
	- Fix #1265 to use /bin/kill.
	- Fix #1267: Libunbound validator/val_secalgo.c uses obsolete APIs,
	  and compatibility with BoringSSL.

17 May 2017: Wouter
	- Fix #1265: contrib/unbound.service contains hardcoded path.

17 May 2017: George
	- Use qstate's region for IPSECKEY rrset (ipsecmod).

16 May 2017: George
	- Implemented opportunistic IPsec support module (ipsecmod).
	- Some whitespace fixup.

16 May 2017: Wouter
	- updated dependencies in the makefile.
	- document trust-anchor-signaling in example config file.
	- updated configure, dependencies and flex output.
	- better module memory lookup, fix of unbound-control shm names for
	  module memory printout of statistics.
	- Fix type AVC sldns rrdef.

12 May 2017: Wouter
	- Adjust servfail by iterator to not store in cache when serve-expired
	  is enabled, to avoid overwriting useful information there.
	- Fix queries for nameservers under a stub leaking to the internet.

9 May 2017: Ralph
	- Add 'c' to getopt() in testbound.
	- iana portlist update

8 May 2017: Wouter
	- Fix tcp-mss failure printout text.
	- Set SO_REUSEADDR on outgoing tcp connections to fix the bind before
	  connect limited tcp connections.  With the option tcp connections
	  can share the same source port (for different destinations).

2 May 2017: Ralph
	- Added mesh_add_sub to add detached mesh entries.
	- Use mesh_add_sub for key tag signaling query.

2 May 2017: Wouter
	- Added test for leak of stub information.
	- Fix sldns wire2str printout of RR type CAA tags.
	- Fix sldns int16_data parse.
	- Fix sldns parse and printout of TSIG RRs.
	- sldns SMIMEA and AVC definitions, same as getdns definitions.

1 May 2017: Wouter
	- Fix #1259: "--disable-ecdsa" argument overwritten 
	  by "#ifdef SHA256_DIGEST_LENGTH@daemon/remote.c".
	- iana portlist update
	- Fix #1258: Windows 10 X64 unbound 1.6.2 service will not start.
	  and fix that 64bit getting installed in C:\Program Files (x86).

26 April 2017: Ralph
	- Implemented trust anchor signaling using key tag query.

26 April 2017: Wouter
	- Based on #1257: check parse limit before t increment in sldns RR
	  string parse routine.

24 April 2017: Wouter
	- unbound-checkconf -o allows query of dnstap config variables.
	  Also unbound-control get_option.  Also for dnscrypt.
	- trunk contains 1.6.3 version number (changes from 1.6.2 back from
	  when the 1.6.2rc1 tag has been created).

21 April 2017: Ralph
	- Fix #1254: clarify ratelimit-{for,below}-domain (from Manu Bretelle).
	- iana portlist update
	
18 April 2017: Ralph
	- Fix #1252: more indentation inconsistencies.
	- Fix #1253: unused variable in edns-subnet/addrtree.c:getbit().

13 April 2017: Ralph
	- Added ECS unit test (from Manu Bretelle).
	- ECS documentation fix (from Manu Bretelle).

13 April 2017: Wouter
	- Fix #1250: inconsistent indentation in services/listen_dnsport.c.
	- tag for 1.6.2rc1
	- (for 1.6.3:) unbound.h exports the shm stats structures.  They use
	  type long long and no ifdefs, and ub_ before the typenames.

12 April 2017: Wouter
	- subnet mem value is available in shm, also when not enabled,
	  to make the struct easier to memmap by other applications,
	  independent of the configuration of unbound.

12 April 2017: Ralph
	- Fix #1247: unbound does not shorten source prefix length when
	  forwarding ECS.
	- Properly check for allocation failure in local_data_find_tag_datas.
	- Fix #1249: unbound doesn't return FORMERR to bogus ECS.
	- Set SHM ECS memory usage to 0 when module not loaded.

11 April 2017: Ralph
	- Display ECS module memory usage.

10 April 2017: Wouter
	- harden-algo-downgrade: no also makes unbound more lenient about
	  digest algorithms in DS records.

10 April 2017: Ralph
	- Remove ECS option after REFUSED answer.
	- Fix small memory leak in edns_opt_copy_alloc.
	- Respip dereference after NULL check.
	- Zero initialize addrtree allocation.
	- Use correct identifier for SHM destroy.

7 April 2017: George
	- Fix pythonmod for cb changes.
	- Some whitespace fixup.

7 April 2017: Ralph
	- Unlock view in respip unit test

6 April 2017: Ralph
	- Generalise inplace callback (de)registration
	- (de)register inplace callbacks for module id
	- No unbound-control set_option for ECS options
	- Deprecated client-subnet-opcode config option
	- Introduced client-subnet-always-forward config option
	- Changed max-client-subnet-ipv6 default to 56 (as in RFC)
	- Removed extern ECS config options
	- module_restart_next now calls clear on all following modules
	- Also create ECS module qstate on module_event_pass event
	- remove malloc from inplace_cb_register

6 April 2017: Wouter
	- Small fixup for documentation.
	- iana portlist update
	- Fix respip for braces when locks arent used.
	- Fix pythonmod for cb changes.

4 April 2017: Wouter
	- Fix #1244: document that use of chroot requires trust anchor file to
	  be under chroot.
	- iana portlist update

3 April 2017: Ralph
	- Do not add current time twice to TTL before ECS cache store.
	- Do not touch rrset cache after ECS cache message generation.
	- Use LDNS_EDNS_CLIENT_SUBNET as default ECS opcode.

3 April 2017: Wouter
	- Fix #1217: Add metrics to unbound-control interface showing
	  crypted, cert request, plaintext and malformed queries (from
	  Manu Bretelle).
	- iana portlist update

27 March 2017: Wouter
	- Remove (now unused) event2 include from dnscrypt code.

24 March 2017: George
	- Fix to prevent non-referral query from being cached as referral when
	  the no_cache_store flag was set.

23 March 2017: Wouter
	- Fix #1239: configure fails to find python distutils if python
	  prints warning.

22 March 2017: Wouter
	- Fix #1238: segmentation fault when adding through the remote
	  interface a per-view local zone to a view with no previous
	  (configured) local zones.
	- Fix #1229: Systemd service sandboxing, options in wrong sections.

21 March 2017: Ralph
	- Merge EDNS Client subnet implementation from feature branch into main
	  branch, using new EDNS processing framework. 

21 March 2017: Wouter
	- Fix doxygen for dnscrypt files.

20 March 2017: Wouter
	- #1217. DNSCrypt support, with --enable-dnscrypt, libsodium and then
	  enabled in the config file from Manu Bretelle.
	- make depend, autoconf, remove warnings about statement before var.
	- lru_demote and lruhash_insert_or_retrieve functions for getdns.
	- fixup for lruhash (whitespace and header file comment).
	- dnscrypt tests.

17 March 2017: Wouter
	- Patch for view functionality for local-data-ptr from Björn Ketelaars.
	- Fix #1237 - Wrong resolving in chain, for norec queries that get
	  SERVFAIL returned.

16 March 2017: Wouter
	- Fix that SHM is not inited if not enabled.
	- Add trustanchor.unbound CH TXT that gets a response with a number
	  of TXT RRs with a string like "example.com. 2345 1234" with
	  the trust anchors and their keytags.
	- Fix that looped DNAMEs do not cause unbound to spend effort.
	- trustanchor tags are sorted.  reusable routine to fetch taglist.

13 March 2017: Wouter
	- testbound understands Deckard MATCH rcode question answer commands.
	- Fix #1235: Fix too long DNAME expansion produces SERVFAIL instead
	  of YXDOMAIN + query loop, reported by Petr Spacek.

10 March 2017: Wouter
	- Fix #1234: shortening DNAME loop produces duplicate DNAME records
	  in ANSWER section.

9 March 2017: Wouter
	- --disable-sha1 disables SHA1 support in RRSIG, so from DNSKEY and
	  DS records.  NSEC3 is not disabled.
	- fake-sha1 test option; print warning if used.  To make unit tests.
	- unbound-control list local zone and data commands listed in the
	  help output.

8 March 2017: Wouter
	- make depend for build dependencies.
	- swig version 2.0.1 required.
	- fix enum conversion warnings

7 March 2017: Wouter
	- Fix #1230: swig version 2.0.0 is required for pythonmod, with
	  1.3.40 it crashes when running repeatedly unbound-control reload.
	- Response actions based on IP address from Jinmei Tatuya (Infoblox).

6 March 2017: Wouter
	- Fix #1229: Systemd service sandboxing in contrib/unbound.service.
	- iana portlist update

28 February 2017: Ralph
	- Fix testpkts.c, check if DO bit is set, not only if there is an OPT
	  record.

28 February 2017: Wouter
	- For #1227: if we have sha256, set the cipher list to have no
	  known vulns.

27 February 2017: Wouter
	- Fix #1227: Fix that Unbound control allows weak ciphersuites.
	- Fix #1226: provide official 32bit binary for windows.

24 February 2017: Wouter
	- include sys/time.h for new shm code on NetBSD.

23 February 2017: Wouter
	- Fix doc/CNAME-basedRedirectionDesignNotes.pdf zone static to
	  redirect.
	- Patch from Luiz Fernando Softov for Stats Shared Memory.
	- unbound-control stats_shm command prints stats using shared memory,
	  which uses less cpu.
	- make depend, autoconf, doxygen and lint fixed up.

22 February 2017: Wouter
	- Fix #1224: Fix that defaults should not fall back to "Program Files
	  (x86) if Unbound is 64bit by default on windows.

21 February 2017: Wouter
	- iana portlist update

16 February 2017: Wouter
	- sldns updated for vfixed and buffer resize indication from getdns.

15 February 2017: Wouter
	- sldns has ED25519 and ED448 algorithm number and name for display.

14 February 2017: Wouter
	- tag 1.6.1rc3. -- which became 1.6.1 on 21feb, trunk has 1.6.2

13 February 2017: Wouter
	- Fix autoconf of systemd check for lack of pkg-config.

10 February 2017: Wouter
	- Fix pythonmod for typedef changes.
	- Fix dnstap for warning of set but not used.
	- tag 1.6.1rc2.

9 February 2017: Wouter
	- tag 1.6.1rc1.

8 February 2017: Wouter
	- Fix for type name change and fix warning on windows compile.

7 February 2017: Wouter
	- Include root trust anchor id 20326 in unbound-anchor.

6 February 2017: Wouter
	- Fix compile on solaris of the fix to use $host detect.

4 February 2017: Wouter
	- fix root_anchor test for updated icannbundle.pem lower certificates.

26 January 2017: Wouter
	- Fix 1211: Fix can't enable interface-automatic if no IPv6 with
	  more helpful error message.

20 January 2017: Wouter
	- Increase MAX_MODULE to 16.

19 January 2017: Wouter
	- Fix to Rename ub_callback_t to ub_callback_type, because POSIX
	  reserves _t typedefs.
	- Fix to rename internally used types from _t to _type, because _t
	  type names are reserved by POSIX.
	- iana portlist update

12 January 2017: Wouter
	- Fix to also block meta types 128 through to 248 with formerr. 
	- Fix #1206: Some view-related commands are missing from 'unbound-control -h'

9 January 2017: Wouter
	- Fix #1202: Fix code comment that packed_rrset_data is not always
	  'packed'.

6 January 2017: Wouter
	- Fix #1201: Fix missing unlock in answer_from_cache error condition.

5 January 2017: Wouter
	- Fix to return formerr for queries for meta-types, to avoid
	  packet amplification if this meta-type is sent on to upstream.
	- Fix #1184: Log DNS replies. This includes the same logging
	  information that DNS queries and response code and response size,
	  patch from Larissa Feng.
	- Fix #1187: Source IP rate limiting, patch from Larissa Feng.

3 January 2017: Wouter
	- configure --enable-systemd and lets unbound use systemd sockets if
	  you enable use-systemd: yes in unbound.conf.
	  Also there are contrib/unbound.socket and contrib/unbound.service:
	  systemd files for unbound, install them in /usr/lib/systemd/system.
	  Contributed by Sami Kerola and Pavel Odintsov.
	- Fix reload chdir failure when also chrooted to that directory.

2 January 2017: Wouter
	- Fix #1194: Cross build fails when $host isn't `uname` for getentropy.

23 December 2016: Ralph
	- Fix #1190: Do not echo back EDNS options in local-zone error response.
	- iana portlist update

21 December 2016: Ralph
	- Fix #1188: Unresolved symbol 'fake_dsa' in libunbound.so when built
	  with Nettle

19 December 2016: Ralph
	- Fix #1191: remove comment about view deletion.

15 December 2016: Wouter
	- iana portlist update
	- 64bit is default for windows builds.
	- Fix inet_ntop and inet_pton warnings in windows compile.

14 December 2016: Wouter
	- Fix #1178: attempt to fix setup error at end, pop result values
	  at end of install.

13 December 2016: Wouter
	- Fix #1182: Fix Resource leak (socket), at startup.
	- Fix unbound-control and ipv6 only.

9 December 2016: Wouter
	- Fix #1176: stack size too small for Alpine Linux.

8 December 2016: Wouter
	- Fix downcast warnings from visual studio in sldns code.
	- tag 1.6.0rc1 which became 1.6.0 on 15 dec, and trunk is 1.6.1.

7 December 2016: Ralph
	- Add DSA support for OpenSSL 1.1.0
	- Fix remote control without cert for LibreSSL

6 December 2016: George
	- Added generic EDNS code for registering known EDNS option codes,
	  bypassing the cache response stage and uniquifying mesh states. Four EDNS
	  option lists were added to module_qstate (module_qstate.edns_opts_*) to
	  store EDNS options from/to front/back side.
	- Added two flags to module_qstate (no_cache_lookup, no_cache_store) that
	  control the modules' cache interactions.
	- Added code for registering inplace callback functions. The registered
	  functions can be called just before replying with local data or Chaos,
	  replying from cache, replying with SERVFAIL, replying with a resolved
	  query, sending a query to a nameserver. The functions can inspect the
	  available data and maybe change response/query related data (i.e. append
	  EDNS options).
	- Updated Python module for the above.
	- Updated Python documentation.

5 December 2016: Ralph
	- Fix #1173: differ local-zone type deny from unset
	  tag_actions element.

5 December 2016: Wouter
	- Fix #1170: document that 'inform' local-zone uses local-data.

1 December 2016: Ralph
	- hyphen as minus fix, by Andreas Schulze

30 November 2016: Ralph
	- Added local-zones and local-data bulk addition and removal
	  functionality in unbound-control (local_zones, local_zones_remove,
	  local_datas and local_datas_remove).
	- iana portlist update

29 November 2016: Wouter
	- version 1.6.0 is in the development branch.
	- braces in view.c around lock statements.

28 November 2016: Wouter
	- new install-sh.

25 November 2016: Wouter
	- Fix that with openssl 1.1 control-use-cert: no uses less cpu, by
	  using no encryption over the unix socket.

22 November 2016: Ralph
	- Make access-control-tag-data RDATA absolute. This makes the RDATA
	  origin consistent between local-data and access-control-tag-data.
	- Fix NSEC ENT wildcard check. Matching wildcard does not have to be a
	  subdomain of the NSEC owner.
	- QNAME minimisation uses QTYPE=A, therefore always check cache for
	  this type in harden-below-nxdomain functionality.
	- Added unit test for QNAME minimisation + harden below nxdomain
	  synergy.

22 November 2016: Wouter
	- iana portlist update.
	- Fix unit tests for DS hash processing for fake-dsa test option.
	- patch from Dag-Erling Smorgrav that removes code that relies
	  on sbrk().

21 November 2016: Wouter
	- Fix #1158: reference RFC 8020 "NXDOMAIN: There Really Is Nothing
	  Underneath" for the harden-below-nxdomain option.

10 November 2016: Ralph
	- Fix #1155: test status code of unbound-control in 04-checkconf,
	  not the status code from the tee command.

4 November 2016: Ralph
	- Added stub-ssl-upstream and forward-ssl-upstream options.

4 November 2016: Wouter
	- configure detects ssl security level API function in the autoconf
	  manner.  Every function on its own, so that other libraries (eg.
	  LibreSSL) can develop their API without hindrance.
	- Fix #1154: segfault when reading config with duplicate zones.
	- Note that for harden-below-nxdomain the nxdomain must be secure,
	  this means nsec3 with optout is insufficient.

3 November 2016: Ralph
	- Set OpenSSL security level to 0 when using aNULL ciphers.

3 November 2016: Wouter
	- .gitattributes line for githubs code language display.
	- log-identity: config option to set sys log identity, patch from
	  "Robin H. Johnson" <robbat2@gentoo.org>

2 November 2016: Wouter
	- iana portlist update.

31 October 2016: Wouter
	- Fix failure to build on arm64 with no sbrk.
	- iana portlist update.

28 October 2016: Wouter
	- Patch for server.num.zero_ttl stats for count of expired replies,
	  from Pavel Odintsov.

26 October 2016: Wouter
	- Fix unit tests for openssl 1.1, with no DSA, by faking DSA, enabled
	  with the undocumented switch 'fake-dsa'.  It logs a warning.

25 October 2016: Wouter
	- Fix #1134: unbound-control set_option -- val-override-date: -1 works
	  immediately to ignore datetime, or back to 0 to enable it again.
	  The -- is to ignore the '-1' as an option flag.

24 October 2016: Wouter
	- serve-expired config option: serve expired responses with TTL 0.
	- g.root-servers.net has AAAA address.

21 October 2016: Wouter
	- Ported tests for local_cname unit test to testbound framework.

20 October 2016: Wouter
	- suppress compile warning in lex files.
	- init lzt variable, for older gcc compiler warnings.
	- fix --enable-dsa to work, instead of copying ecdsa enable.
	- Fix DNSSEC validation of query type ANY with DNAME answers.
	- Fixup query_info local_alias init.

19 October 2016: Wouter
	- Fix #1130: whitespace in example.conf.in more consistent.

18 October 2016: Wouter
	- Patch that resolves CNAMEs entered in local-data conf statements that
	  point to data on the internet, from Jinmei Tatuya (Infoblox).
	- Removed patch comments from acllist.c and msgencode.c
	- Added documentation doc/CNAME-basedRedirectionDesignNotes.pdf,
	  from Jinmei Tatuya (Infoblox).
	- Fix #1125: unbound could reuse an answer packet incorrectly for
	  clients with different EDNS parameters, from Jinmei Tatuya.
	- Fix #1118: libunbound.pc sets strange Libs, Libs.private values.
	- Added Requires line to libunbound.pc
	- Please doxygen by modifying mesh.h

17 October 2016: Wouter
	- Re-fix #839 from view commit overwrite.
	- Fixup const void cast warning.

12 October 2016: Ralph
	- Free view config elements.

11 October 2016: Ralph
	- Added qname-minimisation-strict config option.
	- iana portlist update.
	- fix memoryleak logfile when in debug mode.

5 October 2016: Ralph
	- Added views functionality.
	- Fix #1117: spelling errors, from Robert Edmonds.

30 September 2016: Wouter
	- Fix Nits for 1.5.10 reported by Dag-Erling Smorgrav.

29 September 2016: Wouter
	- Fix #838: 1.5.10 cannot be built on Solaris, undefined PATH_MAX.
	- Fix #839: Memory grows unexpectedly with large RPZ files.
	- Fix #840: infinite loop in unbound_munin_ plugin on unowned lockfile.
	- Fix #841: big local-zone's make it consume large amounts of memory.

27 September 2016: Wouter
	- tag for 1.5.10 release
	- trunk contains 1.5.11 in development.
	- Fix dnstap relaying "random" messages instead of resolver/forwarder
	  responses, from Nikolay Edigaryev.
	- Fix #836: unbound could echo back EDNS options in an error response.

20 September 2016: Wouter
	- iana portlist update.
	- Fix #835: fix --disable-dsa with nettle verify.
	- tag for 1.5.10rc1 release.

15 September 2016: Wouter
	- Fix 883: error for duplicate local zone entry.
	- Test for openssl init_crypto and init_ssl functions.

15 September 2016: Ralph
	- fix potential memory leak in daemon/remote.c and nullpointer
	  dereference in validator/autotrust.
	- iana portlist update.

13 September 2016: Wouter
	- Silenced flex-generated sign-unsigned warning print with gcc
	  diagnostic pragma.
	- Fix for new splint on FreeBSD.  Fix cast for sockaddr_un.sun_len.

9 September 2016: Wouter
	- Fix #831: workaround for spurious fread_chk warning against petal.c

5 September 2016: Ralph
	- Take configured minimum TTL into consideration when reducing TTL
	  to original TTL from RRSIG.

5 September 2016: Wouter
	- Fix #829: doc of sldns_wire2str_rdata_buf() return value has an
	  off-by-one typo, from Jinmei Tatuya (Infoblox).
	- Fix incomplete prototypes reported by Dag-Erling Smørgrav.
	- Fix #828: missing type in access-control-tag-action redirect results
	  in NXDOMAIN.

2 September 2016: Wouter
	- Fix compile with openssl 1.1.0 with api=1.1.0.

1 September 2016: Wouter
	- RFC 7958 is now out, updated docs for unbound-anchor.
	- Fix for compile without warnings with openssl 1.1.0.
	- Fix #826: Fix refuse_non_local could result in a broken response.
	- iana portlist update.

29 August 2016: Wouter
	- Fix #777: OpenSSL 1.1.0 compatibility, patch from Sebastian A.
	  Siewior.
	- Add default root hints for IPv6 E.ROOT-SERVERS.NET, 2001:500:a8::e.

25 August 2016: Ralph
	- Clarify local-zone-override entry in unbound.conf.5 
	
25 August 2016: Wouter
	- 64bit build option for makedist windows compile, -w64.

24 August 2016: Ralph
	- Fix #820: set sldns_str2wire_rr_buf() dual meaning len parameter
	  in each iteration in find_tag_datas().
	- unbound.conf.5 entries for define-tag, access-control-tag,
	  access-control-tag-action, access-control-tag-data, local-zone-tag,
	  and local-zone-override.
	  
23 August 2016: Wouter
	- Fix #804: unbound stops responding after outage.  Fixes queries
	  that attempt to wait for an empty list of subqueries.
	- Fix #804: lower num_target_queries for iterator also for failed
	  lookups.

8 August 2016: Wouter
	- Note that OPENPGPKEY type is RFC 7929.

4 August 2016: Wouter
	- Fix #807: workaround for possible some "unused" function parameters
	  in test code, from Jinmei Tatuya.

3 August 2016: Wouter
	- use sendmsg instead of sendto for TFO.

28 July 2016: Wouter
	- Fix #806: wrong comment removed.

26 July 2016: Wouter
	- nicer ratelimit-below-domain explanation.

22 July 2016: Wouter
	- Fix #801: missing error condition handling in
	  daemon_create_workers().
	- Fix #802: workaround for function parameters that are "unused"
	  without log_assert.
	- Fix #803: confusing (and incorrect) code comment in daemon_cleanup().

20 July 2016: Wouter
	- Fix typo in unbound.conf.

18 July 2016: Wouter
	- Fix #798: Client-side TCP fast open fails (Linux).

14 July 2016: Wouter
	- TCP Fast open patch from Sara Dickinson.
	- Fixed unbound.doxygen for 1.8.11.

7 July 2016: Wouter
	- access-control-tag-data implemented. verbose(4) prints tag debug.

5 July 2016: Wouter
	- Fix dynamic link of anchor-update.exe on windows.
	- Fix detect of mingw for MXE package build.
	- Fixes for 64bit windows compile.
	- Fix #788 for nettle 3.0: Failed to build with Nettle >= 3.0 and
	  --with-libunbound-only --with-nettle.

4 July 2016: Wouter
	- For #787: prefer-ip6 option for unbound.conf prefers to send
	  upstream queries to ipv6 servers.
	- Fix #787: outgoing-interface netblock/64 ipv6 option to use linux
	  freebind to use 64bits of entropy for every query with random local
	  part.

30 June 2016: Wouter
	- Document always_transparent, always_refuse, always_nxdomain types.

29 June 2016: Wouter
	- Fix static compile on windows missing gdi32.

28 June 2016: Wouter
	- Create a pkg-config file for libunbound in contrib.

27 June 2016: Wouter
	- Fix #784: Build configure assumess that having getpwnam means there
	  is endpwent function available.
	- Updated repository with newer flex and bison output.

24 June 2016: Ralph
	- Possibility to specify local-zone type for an acl/tag pair
	- Possibility to specify (override) local-zone type for a source address
	  block
16 June 2016: Ralph
	- Decrease dp attempts at each QNAME minimisation iteration

16 June 2016: Wouter
	- Fix tcp timeouts in tv.usec.

15 June 2016: Wouter
	- TCP_TIMEOUT is specified in milliseconds.
	- If more than half of tcp connections are in use, a shorter timeout
	  is used (200 msec, vs 2 minutes) to pressure tcp for new connects.

14 June 2016: Ralph
	- QNAME minimisation unit test for dropped QTYPE=A queries.

14 June 2016: Wouter
	- Fix 775: unbound-host and unbound-anchor crash on windows, ignore
	  null delete for wsaevent.
	- Fix spelling in freebind option man page text.
	- Fix windows link of ssl with crypt32.
	- Fix 779: Union casting is non-portable.
	- Fix 780: MAP_ANON not defined in HP-UX 11.31.
	- Fix 781: prealloc() is an HP-UX system library call.

13 June 2016: Ralph
	- Use QTYPE=A for QNAME minimisation.
	- Keep track of number of time-outs when performing QNAME minimisation.
	  Stop minimising when number of time-outs for a QNAME/QTYPE pair is
	  more than three.

13 June 2016: Wouter
	- Fix #778: unbound 1.5.9: -h segfault (null deref).
	- Fix directory: fix for unbound-checkconf, it restores cwd.

10 June 2016: Wouter
	- And delete service.conf.shipped on uninstall.
	- In unbound.conf directory: dir immediately changes to that directory,
	  so that include: file below that is relative to that directory.
	  With chroot, make the directory an absolute path inside chroot.
	- keep debug symbols in windows build.
	- do not delete service.conf on windows uninstall.
	- document directory immediate fix and allow EXECUTABLE syntax in it
	  on windows.

9 June 2016: Wouter
	- Trunk is called 1.5.10 (with previous fixes already in there to 2
	  june).
	- Revert fix for NetworkService account on windows due to breakage
	  it causes.
	- Fix that windows install will not overwrite existing service.conf
	  file (and ignore gui config choices if it exists).

7 June 2016: Ralph
	- Lookup localzones by taglist from acl.
	- Possibility to lookup local_zone, regardless the taglist.
	- Added local_zone/taglist/acl unit test.

7 June 2016: Wouter
	- Fix #773: Non-standard Python location build failure with pyunbound.
	- Improve threadsafety for openssl 0.9.8 ecdsa dnssec signatures.

6 June 2016: Wouter
	- Better help text from -h (from Ray Griffith).
	- access-control-tag config directive.
	- local-zone-override config directive.
	- access-control-tag-action and access-control-tag-data config
	  directives.
	- free acl-tags, acltag-action and acltag-data config lists during
	  initialisation to free up memory for more entries.

3 June 2016: Wouter
	- Fix to not ignore return value of chown() in daemon startup.

2 June 2016: Wouter
	- Fix libubound for edns optlist feature.
	- Fix distinction between free and CRYPTO_free in dsa and ecdsa alloc.
	- Fix #752: retry resource temporarily unavailable on control pipe.
	- un-document localzone tags.
	- tag for release 1.5.9rc1.
	  And this also became release 1.5.9.
	- Fix (for 1.5.10): Fix unbound-anchor.exe file location defaults to
	  Program Files with (x86) appended.
	- re-documented localzone tags in example.conf.

31 May 2016: Wouter
	- Fix windows service to be created run with limited rights, as a
	  network service account, from Mario Turschmann.
	- compat strsep implementation.
	- generic edns option parse and store code.
	- and also generic edns options for upstream messages (and replies).
	  after parse use edns_opt_find(edns.opt_list, LDNS_EDNS_NSID),
	  to insert use edns_opt_append(edns, region, code, len, bindata) on
	  the opt_list passed to send_query, or in edns_opt_inplace_reply.

30 May 2016: Wouter
	- Fix time in case answer comes from cache in ub_resolve_event().
	- Attempted fix for #765: _unboundmodule missing for python3.

27 May 2016: Wouter
	- Fix #770: Small subgroup attack on DH used in unix pipe on localhost
	  if unbound control uses a unix local named pipe.
	- Document write permission to directory of trust anchor needed.
	- Fix #768:  Unbound Service Sometimes Can Not Shutdown
	  Completely, WER Report Shown Up.  Close handle before closing WSA.

26 May 2016: Wouter
	- Updated patch from Charles Walker.

24 May 2016: Wouter
	- disable-dnssec-lame-check config option from Charles Walker.
	- remove memory leak from lame-check patch.
	- iana portlist update.

23 May 2016: Wouter
	- Fix #767:  Reference to an expired Internet-Draft in
	  harden-below-nxdomain documentation.

20 May 2016: Ralph
	- No QNAME minimisation fall-back for NXDOMAIN answers from DNSSEC 
	  signed zones.
	- iana portlist update.

19 May 2016: Wouter
	- Fix #766: dns64 should synthesize results on timeout/errors.

18 May 2016: Wouter
	- Fix #761: DNSSEC LAME false positive resolving nic.club.

17 May 2016: Wouter
	- trunk updated with output of flex 2.6.0.

6 May 2016: Wouter
	- Fix memory leak in out-of-memory conditions of local zone add.

29 April 2016: Wouter
	- Fix sldns with static checking fixes copied from getdns.

28 April 2016: Wouter
	- Fix #759: 0x20 capsforid no longer checks type PTR, for
	  compatibility with cisco dns guard.  This lowers false positives.

18 April 2016: Wouter
	- Fix some malformed responses to edns queries get fallback to nonedns.

15 April 2016: Wouter
	- cachedb module event handling design.

14 April 2016: Wouter
	- cachedb module framework (empty).
	- iana portlist update.

12 April 2016: Wouter
	- Fix #753: document dump_requestlist is for first thread.

24 March 2016: Wouter
	- Document permit-small-holddown for 5011 debug.
	- Fix #749: unbound-checkconf gets SIGSEGV when use against a
	  malformatted conf file.

23 March 2016: Wouter
	- OpenSSL 1.1.0 portability, --disable-dsa configure option.

21 March 2016: Wouter
	- Fix compile of getentropy_linux for SLES11 servicepack 4.
	- Fix dnstap-log-resolver-response-messages, from Nikolay Edigaryev.
	- Fix test for openssl to use HMAC_Update for 1.1.0.
	- acx_nlnetlabs.m4 to v33, with HMAC_Update.
	- acx_nlnetlabs.m4 to v34, with -ldl -pthread test for libcrypto.
	- ERR_remove_state deprecated since openssl 1.0.0.
	- OPENSSL_config is deprecated, removing.

18 March 2016: Ralph
	- Validate QNAME minimised NXDOMAIN responses.
	- If QNAME minimisation is enabled, do cache lookup for QTYPE NS in
	  harden-below-nxdomain.

17 March 2016: Ralph
	- Limit number of QNAME minimisation iterations.

17 March 2016: Wouter
	- Fix #746: Fix unbound sets CD bit on all forwards.
	  If no trust anchors, it'll not set CD bit when forwarding to another
	  server.  If a trust anchor, no CD bit on the first attempt to a
	  forwarder, but CD bit thereafter on repeated attempts to get DNSSEC.
	- iana portlist update.

16 March 2016: Wouter
	- Fix ip-transparent for ipv6 on FreeBSD, thanks to Nick Hibma.
	- Fix ip-transparent for tcp on freebsd.

15 March 2016: Wouter
	- ip_freebind: yesno option in unbound.conf sets IP_FREEBIND for
	  binding to an IP address while the interface or address is down.

14 March 2016: Wouter
	- Fix warnings in ifdef corner case, older or unknown libevent.
	- Fix compile for ub_event code with older libev.

11 March 2016: Wouter
	- Remove warning about unused parameter in event_pluggable.c.
	- Fix libev usage of dispatch return value.
	- No side effects in tolower() call, in case it is a macro.
	- For test put free in pluggable api in parenthesis.

10 March 2016: Wouter
	- Fixup backend2str for libev.

09 March 2016: Willem
	- User defined pluggable event API for libunbound
	- Fixup of compile fix for pluggable event API from P.Y. Adi
	  Prasaja.

09 March 2016: Wouter
	- Updated configure and ltmain.sh.
	- Updated L root IPv6 address.

07 March 2016: Wouter
	- Fix #747: assert in outnet_serviced_query_stop.
	- iana ports fetched via https.
	- iana portlist update.

03 March 2016: Wouter
	- configure tests for the weak attribute support by the compiler.

02 March 2016: Wouter
	- 1.5.8 release tag
	- trunk contains 1.5.9 in development.
	- iana portlist update.
	- Fix #745: unbound.py - idn2dname throws UnicodeError when idnname
	  contains trailing dot.

24 February 2016: Wouter
	- Fix OpenBSD asynclook lock free that gets used later (fix test code).
	- Fix that NSEC3 negative cache is used when there is no salt.

23 February 2016: Wouter
	- ub_ctx_set_stub() function for libunbound to config stub zones.
	- sorted ubsyms.def file with exported libunbound functions.

19 February 2016: Wouter
	- Print understandable debug log when unusable DS record is seen.
	- load gost algorithm if digest is seen before key algorithm.
	- iana portlist update.

17 February 2016: Wouter
	- Fix that "make install" fails due to "text file busy" error.

16 February 2016: Wouter
	- Set IPPROTO_IP6 for ipv6 sockets otherwise invalid argument error.

15 February 2016: Wouter
	- ip-transparent option for FreeBSD with IP_BINDANY socket option.
	- wait for sendto to drain socket buffers when they are full.

9 February 2016: Wouter
	- Test for type OPENPGPKEY.
	- insecure-lan-zones: yesno config option, patch from Dag-Erling
	  Smørgrav.

8 February 2016: Wouter
	- Fix patch typo in prevuous commit for 734 from Adi Prasaja.
	- RR Type CSYNC support RFC 7477, in debug printout and config input.
	- RR Type OPENPGPKEY support (draft-ietf-dane-openpgpkey-07).

29 January 2016: Wouter
	- Neater cmdline_verbose increment patch from Edgar Pettijohn.

27 January 2016: Wouter
	- Made netbsd sendmsg test nonfatal, in case of false positives.
	- Fix #741: log message for dnstap socket connection is more clear.

26 January 2016: Wouter
	- Fix #734: chown the pidfile if it resides inside the chroot.
	- Use arc4random instead of random in tests (because it is
	  available, possibly as compat, anyway).
	- Fix cmsg alignment for argument to sendmsg on NetBSD.
	- Fix that unbound complains about unimplemented IP_PKTINFO for
	  sendmsg on NetBSD (for interface-automatic).

25 January 2016: Wouter
	- Fix #738: Swig should not be invoked with CPPFLAGS.

19 January 2016: Wouter
	- Squelch 'cannot assign requested address' log messages unless
	  verbosity is high, it was spammed after network down.

14 January 2016: Wouter
	- Fix to simplify empty string checking from Michael McConville.
	- iana portlist update.

12 January 2016: Wouter
	- Fix #734: Do not log an error when the PID file cannot be chown'ed.
	  Patch from Simon Deziel.

11 January 2016: Wouter
	- Fix test if -pthreads unused to use better grep for portability.

06 January 2016: Wouter
	- Fix mingw crosscompile for recent mingw.
	- Update aclocal, autoconf output with new versions (1.15, 2.4.6).

05 January 2016: Wouter
	- #731: tcp-mss, outgoing-tcp-mss options for unbound.conf, patch
	  from Daisuke Higashi.
	- Support RFC7686: handle ".onion" Special-Use Domain. It is blocked
	  by default, and can be unblocked with "nodefault" localzone config.

04 January 2016: Wouter
	- Define DEFAULT_SOURCE together with BSD_SOURCE when that is defined,
	  for Linux glibc 2.20.
	- Fixup contrib/aaaa-filter-iterator.patch for moved contents in the
	  source code, so it applies cleanly again.  Removed unused variable
	  warnings.

15 December 2015: Ralph
	- Fix #729: omit use of escape sequences in echo since they are not 
	  portable (unbound-control-setup).

11 December 2015: Wouter
	- remove NULL-checks before free, patch from Michael McConville.
	- updated ax_pthread.m4 to version 21 with clang support, this
	  removes a warning from compilation.
	- OSX portability, detect if sbrk is deprecated.
	- OSX clang, stop -pthread unused during link stage warnings.
	- OSX clang new flto check.

10 December 2015: Wouter
	- 1.5.7 release
	- trunk has 1.5.8 in development.

8 December 2015: Wouter
	- Fixup 724 for unbound-control.

7 December 2015: Ralph
	- Do not minimise forwarded requests.

4 December 2015: Wouter
	- Removed unneeded whitespace from example.conf.

3 December 2015: Ralph
	- (after rc1 tag)
	- Committed fix to qname minimisation and unit test case for it.
	
3 December 2015: Wouter
	- iana portlist update.
	- 1.5.7rc1 prerelease tag.

2 December 2015: Wouter
	- Fixup 724: Fix PCA prompt for unbound-service-install.exe.
	  re-enable stdout printout.
	- For 724: Add Changelog to windows binary dist.

1 December 2015: Ralph
	- Qname minimisation review fixes

1 December 2015: Wouter
	- Fixup 724 fix for fname_after_chroot() calls.
	- Remove stdout printout for unbound-service-install.exe
	- .gitignore for git users.

30 November 2015: Ralph
	- Implemented qname minimisation

30 November 2015: Wouter
	- Fix for #724: conf syntax to read files from run dir (on Windows).

25 November 2015: Wouter
	- Fix for #720, fix unbound-control-setup windows batch file.

24 November 2015: Wouter
	- Fix #720: add windows scripts to zip bundle.
	- iana portlist update.

20 November 2015: Wouter
	- Added assert on rrset cache correctness.
	- Fix that malformed EDNS query gets a response without malformed EDNS.

18 November 2015: Wouter
	- newer acx_nlnetlabs.m4.
	- spelling fixes from Igor Sobrado Delgado.

17 November 2015: Wouter
	- Fix #594. libunbound: optionally use libnettle for crypto.
	  Contributed by Luca Bruno.  Added --with-nettle for use with
	  --with-libunbound-only.
	- refactor nsec3 hash implementation to be more library-portable.
	- iana portlist update.
	- Fixup DER encoded DSA signatures for libnettle.

16 November 2015: Wouter
	- Fix for lenient accept of reverse order DNAME and CNAME.

6 November 2015: Wouter
	- Change example.conf: ftp.internic.net to https://www.internic.net

5 November 2015: Wouter
	- ACX_SSL_CHECKS no longer adds -ldl needlessly.

3 November 2015: Wouter
	- Fix #718: Fix unbound-control-setup with support for env
	  without HEREDOC bash support.

29 October 2015: Wouter
	- patch from Doug Hogan for SSL_OP_NO_SSLvx options.
	- Fix #716: nodata proof with empty non-terminals and wildcards.

28 October 2015: Wouter
	- Fix checklock testcode for linux threads on exit.

27 October 2015: Wouter
	- isblank() compat implementation.
	- detect libexpat without xml_StopParser function.
	- portability fixes.
	- portability, replace snprintf if return value broken.

23 October 2015: Wouter
	- Fix #714: Document config to block private-address for IPv4
	  mapped IPv6 addresses.

22 October 2015: Wouter
	- Fix #712: unbound-anchor appears to not fsync root.key.

20 October 2015: Wouter
	- 1.5.6 release.
	- trunk tracks development of 1.5.7.

15 October 2015: Wouter
	- Fix segfault in the dns64 module in the formaterror error path.
	- Fix sldns_wire2str_rdata_scan for malformed RRs.
	- tag for 1.5.6rc1 release.

14 October 2015: Wouter
	- ANY responses include DNAME records if present, as per Evan Hunt's
	  remark in dnsop.
	- Fix manpage to suggest using SIGTERM to terminate the server.

9 October 2015: Wouter
	- Default for ssl-port is port 853, the temporary port assignment
	  for secure domain name system traffic.
	  If you used to rely on the older default of port 443, you have
	  to put a clause in unbound.conf for that.  The new value is likely
	  going to be the standardised port number for this traffic.
	- iana portlist update.

6 October 2015: Wouter
	- 1.5.5 release.
	- trunk tracks the development of 1.5.6.

28 September 2015: Wouter
	- MAX_TARGET_COUNT increased to 64, to fix up sporadic resolution
	  failures.
	- tag for 1.5.5rc1 release.
	- makedist.sh: pgp sig echo commands.

25 September 2015: Wouter
	- Fix unbound-control flush that does not succeed in removing data.

22 September 2015: Wouter
	- Fix config globbed include chroot treatment, this fixes reload of
	  globs (patch from Dag-Erling Smørgrav).
	- iana portlist update.
	- Fix #702: New IPs for for h.root-servers.net.
	- Remove confusion comment from canonical_compare() function.
	- Fix #705: ub_ctx_set_fwd() return value mishandled on windows.
	- testbound selftest also works in non-debug mode.
	- Fix minor error in unbound.conf.5.in
	- Fix unbound.conf(5) access-control description for precedence
	  and default.

31 August 2015: Wouter
	- changed windows setup compression to be more transparent.

28 August 2015: Wouter
	- Fix #697: Get PY_MAJOR_VERSION failure at configure for python
	  2.4 to 2.6.
	- Feature #699: --enable-pie option to that builds PIE binary.
	- Feature #700: --enable-relro-now option that enables full read-only
	  relocation.

24 August 2015: Wouter
	- Fix deadlock for local data add and zone add when unbound-control
	  list_local_data printout is interrupted.
	- iana portlist update.
	- Change default of harden-algo-downgrade to off.  This is lenient
	  for algorithm rollover.

13 August 2015: Wouter
	- 5011 implementation does not insist on all algorithms, when
	  harden-algo-downgrade is turned off.
	- Reap the child process that libunbound spawns.

11 August 2015: Wouter
	- Fix #694: configure script does not detect LibreSSL 2.2.2

4 August 2015: Wouter
	- Document that local-zone nodefault matches exactly and transparent
	  can be used to release a subzone.

3 August 2015: Wouter
	- Document in the manual more text about configuring locally served
	  zones.
	- Fix 5011 anchor update timer after reload.
	- Fix mktime in unbound-anchor not using UTC.

30 July 2015: Wouter
	- please afl-gcc (llvm) for uninitialised variable warning.
	- Added permit-small-holddown config to debug fast 5011 rollover.

24 July 2015: Wouter
	- Fix #690: Reload fails when so-reuseport is yes after changing
	  num-threads.
	- iana portlist update.

21 July 2015: Wouter
	- Fix configure to detect SSL_CTX_set_ecdh_auto.
	- iana portlist update.

20 July 2015: Wouter
	- Enable ECDHE for servers.  Where available, use
	  SSL_CTX_set_ecdh_auto() for TLS-wrapped server configurations to
	  enable ECDHE.  Otherwise, manually offer curve p256.
	  Client connections should automatically use ECDHE when available.
	  (thanks Daniel Kahn Gillmor)

18 July 2015: Willem
	- Allow certificate chain files to allow for intermediate certificates.
	  (thanks Daniel Kahn Gillmor)

13 July 2015: Wouter
	- makedist produces sha1 and sha256 files for created binaries too.

9 July 2015: Wouter
	- 1.5.4 release tag
	- trunk has 1.5.5 in development.
	- Fix #681: Setting forwarders with unbound-control forward
	  implicitly turns on forward-first.

29 June 2015: Wouter
	- iana portlist update.
	- Fix alloc with log for allocation size checks.

26 June 2015: Wouter
	- Fix #677 Fix DNAME responses from cache that failed internal chain
	  test.
	- iana portlist update.

22 June 2015: Wouter
	- Fix #677 Fix CNAME corresponding to a DNAME was checked incorrectly
	  and was therefore always synthesized (thanks to Valentin Dietrich).

4 June 2015: Wouter
	- RFC 7553 RR type URI support, is now enabled by default.

2 June 2015: Wouter
	- Fix #674: Do not free pointers given by getenv.

29 May 2015: Wouter
	- Fix that unparsable error responses are ratelimited.
	- SOA negative TTL is capped at minimumttl in its rdata section.
	- cache-max-negative-ttl config option, default 3600.

26 May 2015: Wouter
	- Document that ratelimit works with unbound-control set_option.

21 May 2015: Wouter
	- iana portlist update.
	- documentation proposes ratelimit of 1000 (closer to what upstream
	  servers expect from us).

20 May 2015: Wouter
	- DLV is going to be decommissioned.  Advice to stop using it, and
	  put text in the example configuration and man page to that effect.

10 May 2015: Wouter
	- Change syntax of particular validator error to be easier for
	  machine parse, swap rrset and ip address info so it looks like:
	  validation failure <www.example.nl. TXT IN>: signature crypto
	  failed from 2001:DB8:7:bba4::53 for <*.example.nl. NSEC IN>

1 May 2015: Wouter
	- caps-whitelist in unbound.conf allows whitelist of loadbalancers
	  that cannot work with caps-for-id or its fallback.

30 April 2015: Wouter
	- Unit test for type ANY synthesis.

22 April 2015: Wouter
	- Removed contrib/unbound_unixsock.diff, because it has been
	  integrated, use control-interface: /path in unbound.conf.
	- iana portlist update.

17 April 2015: Wouter
	- Synthesize ANY responses from cache.  Does not search exhaustively,
	  but MX,A,AAAA,SOA,NS also CNAME.
	- Fix leaked dns64prefix configuration string.

16 April 2015: Wouter
	- Add local-zone type inform_deny, that logs query and drops answer.
	- Ratelimit does not apply to prefetched queries, and ratelimit-factor
	  is default 10.  Repeated normal queries get resolved and with
	  prefetch stay in the cache.
	- Fix bug#664: libunbound python3 related fixes (from Tomas Hozza)
	  Use print_function also for Python2.
	  libunbound examples: produce sorted output.
	  libunbound-Python: libldns is not used anymore.
	  Fix issue with Python 3 mapping of FILE* using file_py3.i from ldns.

10 April 2015: Wouter
	- unbound-control ratelimit_list lists high rate domains.
	- ratelimit feature, ratelimit: 100, or some sensible qps, can be
	  used to turn it on.  It ratelimits recursion effort per zone.
	  For particular names you can configure exceptions in unbound.conf.
	- Fix that get_option for cache-sizes does not print double newline.
	- Fix#663: ssl handshake fails when using unix socket because dh size
	  is too small.

8 April 2015: Wouter
	- Fix crash in dnstap: Do not try to log TCP responses after timeout.

7 April 2015: Wouter
	- Libunbound skips dos-line-endings from etc/hosts.
	- Unbound exits with a fatal error when the auto-trust-anchor-file
	  fails to be writable.  This is seconds after startup.  You can
	  load a readonly auto-trust-anchor-file with trust-anchor-file.
	  The file has to be writable to notice the trust anchor change,
	  without it, a trust anchor change will be unnoticed and the system
	  will then become inoperable.
	- unbound-control list_insecure command shows the negative trust
	  anchors currently configured, patch from Jelte Jansen.

2 April 2015: Wouter
	- Fix #660: Fix interface-automatic broken in the presence of
	  asymmetric routing.

26 March 2015: Wouter
	- remote.c probedelay line is easier to read.
	- rename ldns subdirectory to sldns to avoid name collision.

25 March 2015: Wouter
	- Fix #657:  libunbound(3) recommends deprecated
	  CRYPTO_set_id_callback.
	- If unknown trust anchor algorithm, and libressl is used, error
	  message encourages upgrade of the libressl package.

23 March 2015: Wouter
	- Fix segfault on user not found at startup (from Maciej Soltysiak).

20 March 2015: Wouter
	- Fixed to add integer overflow checks on allocation (defense in depth).

19 March 2015: Wouter
	- Add ip-transparent config option for bind to non-local addresses.

17 March 2015: Wouter
	- Use reallocarray for integer overflow protection, patch submitted
	  by Loganaden Velvindron.

16 March 2015: Wouter
	- Fixup compile on cygwin, more portable openssl thread id.

12 March 2015: Wouter
	- Updated default keylength in unbound-control-setup to 3k.

10 March 2015: Wouter
	- Fix lintian warning in unbound-checkconf man page (from Andreas
	  Schulze).
	- print svnroot when building windows dist.
	- iana portlist update.
	- Fix warning on sign compare in getentropy_linux.

9 March 2015: Wouter
	- Fix #644: harden-algo-downgrade option, if turned off, fixes the
	  reported excessive validation failure when multiple algorithms
	  are present.  It allows the weakest algorithm to validate the zone.
	- iana portlist update.

5 March 2015: Wouter
	- contrib/unbound_smf22.tar.gz: Solaris SMF installation/removal
	  scripts.  Contributed by Yuri Voinov.
	- Document that incoming-num-tcp increase is good for large servers.
	- stats reports tcp usage, of incoming-num-tcp buffers.

4 March 2015: Wouter
	- Patch from Brad Smith that syncs compat/getentropy_linux with
	  OpenBSD's version (2015-03-04).
	- 0x20 fallback improved: servfail responses do not count as missing
	  comparisons (except if all responses are errors),
	  inability to find nameservers does not fail equality comparisons,
	  many nameservers does not try to compare more than max-sent-count,
	  parse failures start 0x20 fallback procedure.
	- store caps_response with best response in case downgrade response
	  happens to be the last one.
	- Document windows 8 tests.

3 March 2015: Wouter
	- tag 1.5.3rc1
	[ This became 1.5.3 on 10 March, trunk is 1.5.4 in development ]

2 March 2015: Wouter
	- iana portlist update.

20 February 2015: Wouter
	- Use the getrandom syscall introduced in Linux 3.17 (from Heiner
	  Kallweit).
	- Fix #645 Portability to Solaris 10, use AF_LOCAL.
	- Fix #646 Portability to Solaris, -lrt for getentropy_solaris.
	- Fix #647 crash in 1.5.2 because pwd.db no longer accessible after
	  reload.

19 February 2015: Wouter
	- 1.5.2 release tag.
	- svn trunk contains 1.5.3 under development.

13 February 2015: Wouter
	- Fix #643: doc/example.conf.in: unnecessary whitespace.

12 February 2015: Wouter
	- tag 1.5.2rc1

11 February 2015: Wouter
	- iana portlist update.

10 February 2015: Wouter
	- Fix scrubber with harden-glue turned off to reject NS (and other
	  not-address) records.

9 February 2015: Wouter
	- Fix validation failure in case upstream forwarder (ISC BIND) does
	  not have the same trust anchors and decides to insert unsigned NS
	  record in authority section.

2 February 2015: Wouter
	- infra-cache-min-rtt patch from Florian Riehm, for expected long
	  uplink roundtrip times.

30 January 2015: Wouter
	- Fix 0x20 capsforid fallback to omit gratuitous NS and additional
	  section changes.
	- Portability fix for Solaris ('sun' is not usable for a variable).

29 January 2015: Wouter
	- Fix pyunbound byte string representation for python3.

26 January 2015: Wouter
	- Fix unintended use of gcc extension for incomplete enum types,
	  compile with pedantic c99 compliance (from Daniel Dickman).

23 January 2015: Wouter
	- windows port fixes, no AF_LOCAL, no chown, no chmod(grp).

16 January 2015: Wouter
	- unit test for local unix connection.  Documentation and log_addr
	  does not inspect port for AF_LOCAL.
	- unbound-checkconf -f prints chroot with pidfile path.

13 January 2015: Wouter
	- iana portlist update.

12 January 2015: Wouter
	- Cast sun_len sizeof to socklen_t.
	- Fix pyunbound ord call, portable for python 2 and 3.

7 January 2015: Wouter
	- Fix warnings in pythonmod changes.

6 January 2015: Wouter
	- iana portlist update.
	- patch for remote control over local sockets, from Dag-Erling
	  Smorgrav, Ilya Bakulin.  Use control-interface: /path/sock and
	  control-use-cert: no.
	- Fixup that patch and uid lookup (only for daemon).
	- coded the default of control-use-cert, to yes.

5 January 2015: Wouter
	- getauxval test for ppc64 linux compatibility.
	- make strip works for unbound-host and unbound-anchor.
	- patch from Stephane Lapie that adds to the python API, that
	  exposes struct delegpt, and adds the find_delegation function.
	- print query name when max target count is exceeded.
	- patch from Stuart Henderson that fixes DESTDIR in
	  unbound-control-setup for installs where config is not in
	  the prefix location.
	- Fix #634: fix fail to start on Linux LTS 3.14.X, ignores missing
	  IP_MTU_DISCOVER OMIT option (fix from Remi Gacogne).
	- Updated contrib warmup.cmd/sh to support two modes - load
	  from pre-defined list of domains or (with filename as argument)
	  load from user-specified list of domains, and updated contrib
	  unbound_cache.sh/cmd to support loading/save/reload cache to/from
	  default path or (with secondary argument) arbitrary path/filename,
	  from Yuri Voinov.
	- Patch from Philip Paeps to contrib/unbound_munin_ that uses
	  type ABSOLUTE.  Allows munin.conf: [idleserver.example.net]
	  unbound_munin_hits.graph_period minute

9 December 2014: Wouter
	- svn trunk has 1.5.2 in development.
	- config.guess and config.sub update from libtoolize.
	- local-zone: example.com inform makes unbound log a message with
	  client IP for queries in that zone.  Eg. for finding infected hosts.

8 December 2014: Wouter
	- Fix CVE-2014-8602: denial of service by making resolver chase
	  endless series of delegations.

1 December 2014: Wouter
	- Fix bug#632: unbound fails to build on AArch64, protects
	  getentropy compat code from calling sysctl if it is has been removed.

29 November 2014: Wouter
	- Add include to getentropy_linux.c, hopefully fixing debian build.

28 November 2014: Wouter
	- Fix makefile for build from noexec source tree.

26 November 2014: Wouter
	- Fix libunbound undefined symbol errors for main.
	  Referencing main does not seem to be possible for libunbound.

24 November 2014: Wouter
	- Fix log at high verbosity and memory allocation failure.
	- iana portlist update.

21 November 2014: Wouter
	- Fix crash on multiple thread random usage on systems without
	  arc4random.

20 November 2014: Wouter
	- fix compat/getentropy_win.c check if CryptGenRandom works and no
	  immediate exit on windows.

19 November 2014: Wouter
	- Fix cdflag dns64 processing.

18 November 2014: Wouter
	- Fix that CD flag disables DNS64 processing, returning the DNSSEC
	  signed AAAA denial.
	- iana portlist update.

17 November 2014: Wouter
	- Fix #627: SSL_CTX_load_verify_locations return code not properly
	  checked.

14 November 2014: Wouter
	- parser with bison 2.7

13 November 2014: Wouter
	- Patch from Stephane Lapie for ASAHI Net that implements aaaa-filter,
	added to contrib/aaaa-filter-iterator.patch.

12 November 2014: Wouter
	- trunk has 1.5.1 in development.
	- Patch from Robert Edmonds to build pyunbound python module
	  differently.  No versioninfo, with -shared and without $(LIBS).
	- Patch from Robert Edmonds fixes hyphens in unbound-anchor man page.
	- Removed 'increased limit open files' log message that is written
	  to console.  It is only written on verbosity 4 and higher.
	  This keeps system bootup console cleaner.
	- Patch from James Raftery, always print stats for rcodes 0..5.

11 November 2014: Wouter
	- iana portlist update.
	- Fix bug where forward or stub addresses with same address but
	  different port number were not tried.
	- version number in svn trunk is 1.5.0
	- tag 1.5.0rc1
	- review fix from Ralph.

7 November 2014: Wouter
	- dnstap fixes by Robert Edmonds:
		dnstap/dnstap.m4: cosmetic fixes
		dnstap/: Remove compiled protoc-c output files
		dnstap/dnstap.m4: Error out if required libraries are not found
		dnstap: Fix ProtobufCBufferSimple usage that is incorrect as of
			protobuf-c 1.0.0
		dnstap/: Adapt to API changes in latest libfstrm (>= 0.2.0)

4 November 2014: Wouter
	- Add ub_ctx_add_ta_autr function to add a RFC5011 automatically
	  tracked trust anchor to libunbound.
	- Redefine internal minievent symbols to unique symbols that helps
	  linking on platforms where the linker leaks names across modules.

27 October 2014: Wouter
	- Disabled use of SSLv3 in remote-control and ssl-upstream.
	- iana portlist update.

16 October 2014: Wouter
	- Documented dns64 configuration in unbound.conf man page.

13 October 2014: Wouter
	- Fix #617: in ldns in unbound, lowercase WKS services.
	- Fix ctype invocation casts.

10 October 2014: Wouter
	- Fix unbound-checkconf check for module config with dns64 module.
	- Fix unbound capsforid fallback, it ignores TTLs in comparison.

6 October 2014: Wouter
	- Fix #614: man page variable substitution bug.
6 October 2014: Willem
	- Whitespaces after $ORIGIN are not part of the origin dname (ldns).
	- $TTL's value starts at position 5 (ldns).

1 October 2014: Wouter
	- fix #613: Allow tab ws in var length last rdfs (in ldns str2wire).

29 September 2014: Wouter
	- Fix #612: create service with service.conf in present directory and
	  auto load it.
	- Fix for mingw compile openssl ranlib.

25 September 2014: Wouter
	- updated configure and aclocal with newer autoconf 1.13.

22 September 2014: Wouter
	- Fix swig and python examples for Python 3.x.
	- Fix for mingw compile with openssl-1.0.1i.

19 September 2014: Wouter
	- improve python configuration detection to build on Fedora 22.

18 September 2014: Wouter
	- patches to also build with Python 3.x (from Pavel Simerda).

16 September 2014: Wouter
	- Fix tcp timer waiting list removal code.
	- iana portlist update.
	- Updated the TCP_BACLOG from 5 to 256, so that the tcp accept queue
	  is longer and more tcp connections can be handled.

15 September 2014: Wouter
	- Fix unit test for CDS typecode.

5 September 2014: Wouter
	- type CDS and CDNSKEY types in sldns.

25 August 2014: Wouter
	- Fixup checklock code for log lock and its mutual initialization
	  dependency.
	- iana portlist update.
	- Removed necessity for pkg-config from the dnstap.m4, new are
	  the --with-libfstrm and --with-protobuf-c configure options.

19 August 2014: Wouter
	- Update unbound manpage with more explanation (from Florian Obser).

18 August 2014: Wouter
	- Fix #603: unbound-checkconf -o <option> should skip verification
	  checks.
	- iana portlist update.
	- Fixup doc/unbound.doxygen to remove obsolete 1.8.7 settings.

5 August 2014: Wouter
	- dnstap support, with a patch from Farsight Security, written by
	  Robert Edmonds. The --enable-dnstap needs libfstrm and protobuf-c.
	  It is BSD licensed (see dnstap/dnstap.c).
	  Building with --enable-dnstap needs pkg-config with this patch.
	- Noted dnstap in doc/README and doc/CREDITS.
	- Changes to the dnstap patch.
	  - lint fixes.
	  - dnstap/dnstap_config.h should not have been added to the repo,
	    because is it generated.

1 August 2014: Wouter
	- Patch add msg, rrset, infra and key cache sizes to stats command
	  from Maciej Soltysiak.
	- iana portlist update.

31 July 2014: Wouter
	- DNS64 from Viagenie (BSD Licensed), written by Simon Perrault.
	  Initial commit of the patch from the FreeBSD base (with its fixes).
	  This adds a module (for module-config in unbound.conf) dns64 that
	  performs DNS64 processing, see README.DNS64.
	- Changes from DNS64:
	  strcpy changed to memmove.
	  arraybound check fixed from prefix_net/8/4 to prefix_net/8+4.
	  allocation of result consistently in the correct region.
	  time_t is now used for ttl in unbound (since the patch's version).
	- testdata/dns64_lookup.rpl for unit test for dns64 functionality.

29 July 2014: Wouter
	- Patch from Dag-Erling Smorgrav that implements feature, unbound -dd
	  does not fork in the background and also logs to stderr.

21 July 2014: Wouter
	- Fix endian.h include for OpenBSD.

16 July 2014: Wouter
	- And Fix#596: Bail out of unbound-control dump_infra when ssl
	  write fails.

15 July 2014: Wouter
	- Fix #596: Bail out of unbound-control list_local_zones when ssl
	  write fails.
	- iana portlist update.

13 July 2014: Wouter
	- Configure tests if main can be linked to from getentropy compat.

12 July 2014: Wouter
	- Fix getentropy compat code, function refs were not portable.
	- Fix to check openssl version number only for OpenSSL.
	- LibreSSL provides compat items, check for that in configure.
	- Fix bug in fix for log locks that caused deadlock in signal handler.
	- update compat/getentropy and arc4random to the most recent ones from OpenBSD.

11 July 2014: Matthijs
	- fake-rfc2553 patch (thanks Benjamin Baier).

11 July 2014: Wouter
	- arc4random in compat/ and getentropy, explicit_bzero, chacha for
	  dependencies, from OpenBSD.  arc4_lock and sha512 in compat.
	  This makes arc4random available on all platforms, except when
	  compiled with LIBNSS (it uses libNSS crypto random).
	- fix strptime implicit declaration error on OpenBSD.
	- arc4random, getentropy and explicit_bzero compat for Windows.

4 July 2014: Wouter
	- Fix #593: segfault or crash upon rotating logfile.

3 July 2014: Wouter
	- DLV tests added.
	- signit tool fixup for compile with libldns library.
	- iana portlist updated.

27 June 2014: Wouter
	- so-reuseport is available on BSDs(such as FreeBSD 10) and OS/X.

26 June 2014: Wouter
	- unbound-control status reports if so-reuseport was successful.
	- iana portlist updated.

24 June 2014: Wouter
	- Fix caps-for-id fallback, and added fallback attempt when servers
	  drop 0x20 perturbed queries.
	- Fixup testsetup for VM tests (run testcode/run_vm.sh).

17 June 2014: Wouter
	- iana portlist updated.

3 June 2014: Wouter
	- Add AAAA for B root server to default root hints.

2 June 2014: Wouter
	- Remove unused define from iterator.h

30 May 2014: Wouter
	- Fixup sldns_enum_edns_option typedef definition.

28 May 2014: Wouter
	- Code cleanup patch from Dag-Erling Smorgrav, with compiler issue
	  fixes from FreeBSD's copy of Unbound, he notes:
	  Generate unbound-control-setup.sh at build time so it respects
	  prefix and sysconfdir from the configure script.  Also fix the
	  umask to match the comment, and the comment to match the umask.
	  Add const and static where needed.  Use unions instead of
	  playing pointer poker.  Move declarations that are needed in
	  multiple source files into a shared header.  Move sldns_bgetc()
	  from parse.c to buffer.c where it belongs.  Introduce a new
	  header file, worker.h, which declares the callbacks that
	  all workers must define.  Remove those declarations from
	  libworker.h.	Include the correct headers in the correct places.
	  Fix a few dummy callbacks that don't match their prototype.
	  Fix some casts.  Hide the sbrk madness behind #ifdef HAVE_SBRK.
	  Remove a useless printf which breaks reproducible builds.
	  Get rid of CONFIGURE_{TARGET,DATE,BUILD_WITH} now that they're
	  no longer used.  Add unbound-control-setup.sh to the list of
	  generated files.  The prototype for libworker_event_done_cb()
	  needs to be moved from libunbound/libworker.h to
	  libunbound/worker.h.
	- Fixup out-of-directory compile with unbound-control-setup.sh.in.
	- make depend.

23 May 2014: Wouter
	- unbound-host -D enabled dnssec and reads root trust anchor from
	  the default root key file that was compiled in.

20 May 2014: Wouter
	- Feature, unblock-lan-zones: yesno that you can use to make unbound
	  perform 10.0.0.0/8 and other reverse lookups normally, for use if
	  unbound is running service for localhost on localhost.

16 May 2014: Wouter
	- Updated create_unbound_ad_servers and unbound_cache scripts from
	  Yuri Voinov in the source/contrib directory. Added
	  warmup.cmd (and .sh): warm up the DNS cache with your MRU domains.

9 May 2014: Wouter
	- Implement draft-ietf-dnsop-rfc6598-rfc6303-01.
	- iana portlist updated.

8 May 2014: Wouter
	- Contrib windows scripts from Yuri Voinov added to src/contrib:
	  create_unbound_ad_servers.cmd: enters anti-ad server lists.
	  unbound_cache.cmd: saves and loads the cache.
	- Added unbound-control-setup.cmd from Yuri Voinov to the windows
	  unbound distribution set.  It requires openssl installed in %PATH%.

6 May 2014: Wouter
	- Change MAX_SENT_COUNT from 16 to 32 to resolve some cases easier.

5 May 2014: Wouter
	- More #567: remove : from output of stub and forward lists, this is
	  easier to parse.

29 April 2014: Wouter
	- iana portlist updated.
	- Add unbound-control flush_negative that flushed nxdomains, nodata,
	  and errors from the cache.  For dnssec-trigger and NetworkManager,
	  fixes cases where network changes have localdata that was already
	  negatively cached from the previous network.

23 April 2014: Wouter
	- Patch from Jeremie Courreges-Anglas to use arc4random_uniform
	  if available on the OS, it gets entropy from the OS.

15 April 2014: Wouter
	- Fix compile with libevent2 on FreeBSD.

11 April 2014: Wouter
	- Fix #502: explain that do-ip6 disable does not stop AAAA lookups,
	  but it stops the use of the ipv6 transport layer for DNS traffic.
	- iana portlist updated.

10 April 2014: Wouter
	- iana portlist updated.
	- Patch from Hannes Frederic Sowa for Linux 3.15 fragmentation
	  option for DNS fragmentation defense.
	- Document that dump_requestlist only prints queries from thread 0.
	- unbound-control stats prints num.query.tcpout with number of TCP
	  outgoing queries made in the previous statistics interval.
	- Fix #567: unbound lists if forward zone is secure or insecure with
	  +i annotation in output of list_forwards, also for list_stubs
	  (for NetworkManager integration.)
	- Fix #554: use unsigned long to print 64bit statistics counters on
	  64bit systems.
	- Fix #558: failed prefetch lookup does not remove cached response
	  but delays next prefetch (in lieu of caching a SERVFAIL).
	- Fix #545: improved logging, the ip address of the error is printed
	  on the same log-line as the error.

8 April 2014: Wouter
	- Fix #574: make test fails on Ubuntu 14.04.  Disabled remote-control
	  in testbound scripts.
	- iana portlist updated.

7 April 2014: Wouter
	- C.ROOT-SERVERS.NET has an IPv6 address, and we updated the root
	  hints (patch from Anand Buddhdev).
	- Fix #572: Fix unit test failure for systems with different
	  /etc/services.

28 March 2014: Wouter
	- Fix #569: do_tcp is do-tcp in unbound.conf man page.

25 March 2014: Wouter
	- Patch from Stuart Henderson to build unbound-host man from .1.in.

24 March 2014: Wouter
	- Fix print filename of encompassing config file on read failure.

12 March 2014: Wouter
	- tag 1.4.22
	- trunk has 1.4.23 in development.

10 March 2014: Wouter
	- Fix bug#561: contrib/cacti plugin did not report SERVFAIL rcodes
	  because of spelling.  Patch from Chris Coates.

27 February 2014: Wouter
	- tag 1.4.22rc1

21 February 2014: Wouter
	- iana portlist updated.

20 February 2014: Matthijs
	- Be lenient when a NSEC NameError response with RCODE=NXDOMAIN is
	  received. This is okay according 4035, but not after revising
	  existence in 4592.  NSEC empty non-terminals exist and thus the
	  RCODE should have been NOERROR. If this occurs, and the RRsets
	  are secure, we set the RCODE to NOERROR and the security status
	  of the response is also considered secure.

14 February 2014: Wouter
	- Works on Minix (3.2.1).

11 February 2014: Wouter
	- Fix parse of #553(NSD) string in sldns, quotes without spaces.

7 February 2014: Wouter
	- iana portlist updated.
	- add body to ifstatement if locks disabled.
	- add TXT string"string" test case to unit test.
	- Fix #551: License change "Regents" to "Copyright holder", matching
	  the BSD license on opensource.org.

6 February 2014: Wouter
	- sldns has type HIP.
	- code documentation on the module interface.

5 February 2014: Wouter
	- Fix sldns parse tests on osx.

3 February 2014: Wouter
	- Detect libevent2 install automatically by configure.
	- Fixup link with lib/event2 subdir.
	- Fix parse in sldns of quoted parenthesized text strings.

31 January 2014: Wouter
	- unit test for ldns wire to str and back with zones, root, nlnetlabs
	  and types.sidnlabs.
	- Fix for hex to string in unknown, atma and nsap.
	- fixup nss compile (no ldns in it).
	- fixup warning in unitldns
	- fixup WKS and rdata type service to print unsigned because strings
	  are not portable; they cannot be read (for sure) on other computers.
	- fixup type EUI48 and EUI64, type APL and type IPSECKEY in string
	  parse sldns.

30 January 2014: Wouter
	- delay-close does not act if there are udp-wait queries, so that
	  it does not make a socketdrain DoS easier.

28 January 2014: Wouter
	- iana portlist updated.
	- iana portlist test updated so it does not touch the source
	  if there are no changes.
	- delay-close: msec option that delays closing ports for which
	  the UDP reply has timed out.  Keeps the port open, only accepts
	  the correct reply.  This correct reply is not used, but the port
	  is open so that no port-denied ICMPs are generated.

27 January 2014: Wouter
	- reuseport is attempted, then fallback to without on failure.

24 January 2014: Wouter
	- Change unbound-event.h to use void* buffer, length idiom.
	- iana portlist updated.
	- unbound-event.h is installed if you configure --enable-event-api.
	- speed up unbound (reports say it could be up to 10%), by reducing
	  lock contention on localzones.lock.  It is changed to an rwlock.
	- so-reuseport: yesno option to distribute queries evenly over
	  threads on Linux (Thanks Robert Edmonds).
	- made lint clean.

21 January 2014: Wouter
	- Fix #547: no trustanchor written if filesystem full, fclose checked.

17 January 2014: Wouter
	- Fix isprint() portability in sldns, uses unsigned int.
	- iana portlist updated.

16 January 2014: Wouter
	- fix #544: Fixed +i causes segfault when running with module conf
	  "iterator".
	- Windows port, adjust %lld to %I64d, and warning in win_event.c.

14 January 2014: Wouter
	- iana portlist updated.

5 Dec 2013: Wouter
	- Fix bug in cachedump that uses sldns.
	- update pythonmod for ldns_ to sldns_ name change.

3 Dec 2013: Wouter
	- Fix sldns to use sldns_ prefix for all ldns_ variables.
	- Fix windows compile to compile with sldns.

30 Nov 2013: Wouter
	- Fix sldns to make globals use sldns_ prefix.  This fixes
	  linking with libldns that uses global variables ldns_ .

13 Nov 2013: Wouter
	- Fix bug#537: compile python plugin without ldns library.

12 Nov 2013: Wouter
	- Fix bug#536: acl_deny_non_local and refuse_non_local added.

5 Nov 2013: Wouter
	- Patch from Neel Goyal to fix async id assignment if callback
	  is called by libunbound in the mesh attach.
	- Accept ip-address: as an alternative for interface: for
	  consistency with nsd.conf syntax.

4 Nov 2013: Wouter
	- Patch from Neel Goyal to fix callback in libunbound.

3 Nov 2013: Wouter
	- if configured --with-libunbound-only fix make install.

31 Oct 2013: Wouter
	- Fix #531: Set SO_REUSEADDR so that the wildcard interface and a 
	  more specific interface port 53 can be used at the same time, and
	  one of the daemons is unbound.
	- iana portlist update.
	- separate ldns into core ldns inside ldns/ subdirectory.  No more
	  --with-ldns is needed and unbound does not rely on libldns.
	- portability fixes for new USE_SLDNS ldns subdir codebase.

22 Oct 2013: Wouter
	- Patch from Neel Goyal: Add an API call to set an event base on an
	  existing ub_ctx.  This basically just destroys the current worker and
	  sets the event base to the current.  And fix a deadlock in
	  ub_resolve_event – the cfglock is held when libworker_create is
	  called.  This ends up trying to acquire the lock again in
	  context_obtain_alloc in the call chain.
	- Fix #528: if very high logging (4 or more) segfault on allow_snoop.

26 Sep 2013: Wouter
	- unbound-event.h is installed if configured --with-libevent.  It
	  contains low-level library calls, that use libevent's event_base
	  and an ldns_buffer for the wire return packet to perform async
	  resolution in the client's eventloop.

19 Sep 2013: Wouter
	- 1.4.21 tag created.
	- trunk has 1.4.22 number inside it.
	- iana portlist updated.
	- acx_nlnetlabs.m4 to 26; improve FLTO help text.

16 Sep 2013: Wouter
	- Fix#524: max-udp-size not effective to non-EDNS0 queries, from
	  Daisuke HIGASHI.

10 Sep 2013: Wouter
	- MIN_TTL and MAX_TTL also in time_t.
	- tag 1.4.21rc1 made again.

26 Aug 2013: Wouter
	- More fixes for bug#519: for the threaded case test if the bg
	  thread has been killed, on ub_ctx_delete, to avoid hangs.

22 Aug 2013: Wouter
	- more fixes that I overlooked.
	- review fixes from Willem.

21 Aug 2013: Wouter
	- Fix#520: Errors found by static analysis from Tomas Hozza(redhat).

20 Aug 2013: Wouter
	- Fix for 2038, with time_t instead of uint32_t.

19 Aug 2013: Wouter
	- Fix#519 ub_ctx_delete may hang in some scenarios (libunbound).

14 Aug 2013: Wouter
	- Fix uninit variable in fix#516.

8 Aug 2013: Wouter
	- Fix#516 dnssec lameness detection for answers that are improper.

30 Jun 2013: Wouter
	- tag 1.4.21rc1

29 Jun 2013: Wouter
	- Fix#512 memleak in testcode for testbound (if it fails).
	- Fix#512 NSS returned arrays out of setup function to be statics.

26 Jun 2013: Wouter
	- max include of 100.000 files (depth and globbed at one time).
	  This is to preserve system memory in bug cases, or endless cases.
	- iana portlist updated.

